#include <sys/types.h>
#include <stdio.h>
#include <libetc.h>
#include <libgte.h>
#include <libgpu.h>
#include <libgs.h>
#include <libsn.h>
#include <libcd.h>
#include <libds.h>
#include <libsn.h>
#include <libsnd.h>
#include <libspu.h>
#include <gtemac.h>
#include <inline_c.h>
#include <ctrller.h>
#include "frontend.h"
#include "sdlib\sdfunc.h"
#include "header.h"
#include "psx\mathpsx.h"
#include "render.h"
#include "psx\loadPSX.h"
#include "mesh.h"
#include "psx\soundPSX.h"
#include "state.h"
#include "gameloop.h"
#include "objects.h"
#include "pickups.h"
#include "psx\psx_pcks.h"
#include "psx\psx_expn.h"
#include "AI.h"
#include "version.h"
#include "collide.h"
#include "poon.h"
#include "memcard.h"
#include "cdlib.h"
#include "wake.h"
#include "action.h"
#include "loadit.h"
#include "camera.h"
#include "score.h"
#include "pal_ntsc.h"
#include "text.h"

void LOAD_SetLogo(); // Not correctly defined in loadpsx.h


#define	ROBTEST 0


///////////////////////////////////////////////////////////////////////////////////////////////
//		Game initialisation.
///////////////////////////////////////////////////////////////////////////////////////////////
//		Started:		19/5/98
//		Geeza:		J.coelho
//    PSX:        Y
//    N64:        Y.
//    Notes:    move to Psx dir!     in your dreams.
//    Dear Matman, no "#if PSX" today thanks!
///////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////
// External Declarations
///////////////////////////////////////////////////////////////////////////////////////////////
extern   void   STATE_initstatesonboot();
extern   vec16   SIM_rp[];
extern   void  GPU_initcallback();

///////////////////////////////////////////////////////////////////////////////////////////////
// Private Declarations
///////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////
// Definitions
///////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////
// Functions
///////////////////////////////////////////////////////////////////////////////////////////////

#if ROBTEST
void testtesttest(void);
#endif

//extern int clipflag;

void	BOOT_boot()
	{
//   s16   f;
//   s16  i;

	WTXT_init();

// Mat: 22/03/1999
	CDLIB_Init();

   LOAD_SetLogo();

   STATE_initstatesonboot();
//	mprintf("MT_DEBUG: BOOT_boot => DsInit\n");

// Mat: 22/03/1999
//   DsInit();
//   DsSetDebug(0);

   //DsGetDiskType();
   #if PAL
   SD_Init(1,512,256); // fucking toss	///0
   #else
   SD_Init(0,512,256); // fucking toss	///0
   #endif
	MEMCARD_init();
   SD_ViewInit(0,0,-400,0,0,400,200);  //225, 150, 180, 190

   GPU_initcallback();
   SOUND_init();

#if ROBTEST
testtesttest();
#endif

   CAM_precalcmatricies();
   MATH_init();


   LOAD_genericdata();
   LOAD_level();
//   CAM_cammode[CAM_c] = 4;
//   init_player_stats();
//   set_line();

//   allocate_player_pickups(&OBJ_players[0]);
//   allocate_player_pickups(&OBJ_players[1]);

WAKE_init();
SCORE_reset();

//arSaveInitialState();
#if   CDMASTER
#else
FntLoad(960,256);
FntOpen(-240,-120,256,200,0,512);
#endif
}



#if ROBTEST
void testtesttest(void)
{
long flag;
long z;
u16 sxy[2];
long p;

SVECTOR sv = {-2,18,7};
SVECTOR sv2;
VECTOR v1;

MATRIX m1 =
	{
		{
			{3784,1107,1107},
			{0,2896,-2896},
			{-1567,2675,2675}
		},
        {8,-5,17}
	};

//ApplyMatrix(&m1,&s1,&v2);
//ApplyMatrixLV(&m1,&v1,&v3);

//mprintf("arse2 : %ld,%ld,%ld\n",v2.vx,v2.vy,v2.vz);
//mprintf("arse3 : %ld,%ld,%ld\n",v3.vx,v3.vy,v3.vz);

SetRotMatrix((MATRIX *)&m1);
SetTransMatrix((MATRIX *)&m1);

z = RotTransPers(&sv,(long *)sxy,&p,&flag);

RotTrans(&sv,&v1,&flag);


RotTransSV(&sv,&sv2,&flag);

while(1) pollhost();
}
#endif
