//
// Frontend.C
//
// Author: Mathew Twigg.
// Start: 22-sept-98
//
// Purpose: Selects players, level, all frontend stuff.
//

#if 0

#if PSX
// Too much unneeded junk here..... Who gives a fuck?
#include <sys/types.h>
#include <libetc.h>
#include <libgte.h>
#include <libgpu.h>
#include <libgs.h>
#include <libsn.h>
#include <gtemac.h>
#include <inline_c.h>
#include <libsn.h>
#include "sdlib\sdfunc.h"
#endif

#if N64
#include <ultra64.h>
#include <sched.h>
#endif

#include "header.h"
#include "frontend.h"
#include "gameloop.h"
#include "mesh.h"
#include "keys.h"
#include "fade.h"

#if N64

void FntPrint(char *s,...)
{
return;
}

void printf(char *s,...)
{
return;
}

#endif




int frMode;
int nextFrMode;
int changeMode;


// And back... 2.. 3.. 4..


#if PSX
//jofPOLY_FT4 backdrop[32] [256];
POLY_FT4 backdrop[1] [1];
#endif

#if PSX
//jofu32 mtemp[60000]; // 240Kb
u32 mtemp[1];//jof // 240Kb
#endif

void FRONTEND_LanguageSelect_Init()
	{
	int i,x,y,j,accel,pos,vel;

#if PSX
	LOAD_nread(mtemp,__CD_NAME_GEN("c:\\360\\data\\test\\360.TIM"));
	DrawSync(0);
	LOAD_loadTexture((u32 *)mtemp);
	DrawSync(0);

	i = 0;

	for(y=0;y<256;y+=64)
	for(x=0;x<512;x+=64,i++)
		{
        SetPolyFT4(&backdrop[i] [0]);

        backdrop[i] [0].x0 = -256 + x;
        backdrop[i] [0].y0 = -128 + y;

        backdrop[i] [0].x1 = backdrop[i] [0].x0 + 64;
        backdrop[i] [0].y1 = backdrop[i] [0].y0;

        backdrop[i] [0].x2 = backdrop[i] [0].x0;
        backdrop[i] [0].y2 = backdrop[i] [0].y0 + 64;

        backdrop[i] [0].x3 = backdrop[i] [0].x0 + 64;
        backdrop[i] [0].y3 = backdrop[i] [0].y0 + 64;

        backdrop[i] [0].r0 = 128;
        backdrop[i] [0].g0 = 128;
        backdrop[i] [0].b0 = 128;

        backdrop[i] [0].clut = getClut(512,256);
        backdrop[i] [0].tpage = getTPage(1,0,x<256?512:640,0);

        backdrop[i] [0].u0 = x&0xff;
        backdrop[i] [0].v0 = y&0xff;

        backdrop[i] [0].u1 = backdrop[i] [0].u0 + 63;
        backdrop[i] [0].v1 = backdrop[i] [0].v0;

        backdrop[i] [0].u2 = backdrop[i] [0].u0;
        backdrop[i] [0].v2 = backdrop[i] [0].v0 + 63;

        backdrop[i] [0].u3 = backdrop[i] [0].u0 + 63;
        backdrop[i] [0].v3 = backdrop[i] [0].v0 + 63;
        }

	for(i=1;i<256;i++)
    for(j=0;j<32;j++)
    	memcpy(&backdrop[j] [i],&backdrop[j] [0],sizeof(POLY_FT4));

#endif

	fadeInSpeed = 24;
	fadeOutSpeed = 24;

	fadeInSpeed = 4;
	fadeOutSpeed = 4;

	return;
	}

#if 0
RECT rct;
//u_short buf[1024] [512];
int doScreen = 0;
#endif

void FRONTEND_LanguageSelect_Tick()
	{
	int i;

	if(frState==FD_FADEIN)
		{
		// Fading in
		}
	if((frState==FD_NORMAL)||(frState==FD_FADEIN))
		{
		// Main loop
		// Jump into game if X is pressed
		if(~SD_PadData[0].data&K_SLS_STARTGAME)
			{
			nextFrMode = FRS_LANGSELECT;
//			nextGLstate = GLgame;
			nextGLstate = GLintro;

			fadeOut();
			}
		}
	if(frState==FD_FADEOUT)
		{
		// Fading out, will change screen flag set when complete
		}

	// Print backdrop
	#if PSX
	for(i=0;i<32;i++)
        //GsSortPoly(&backdrop[i] [fadeValue],&Wot[outbuf_idx],(1<<OT_LENGTH)-1);
	#endif

#if 0
	if(doScreen)
    	{
        rct.x = 0;
        rct.y = 0;
        rct.w = 1024;
        rct.h = 512;
        StoreImage(&rct,buf);
        doScreen = 0;
        }
#endif

	FntPrint("PRESS SELECT TO START GAME\n");
	}

#endif
