// 360 load track format 11/9/98

typedef	struct{
	u16		numjigmodels;	// number of jigsaw models to load
	u16		numsegpieces;  // number of segments in the track/arena
	}TRACKDATAHEADER;

typedef	struct{
	u16	jigpiece;    		// jigsaw model id number. Assume 1st piece loaded is 0 etc.
	u16	segyrotation;     // Y rotation of jigpiece. 360degrees=65536.
	vec32	position;         // x,y,z of the jigpiece offset.
	s16	vis[12];          // list of other visible segments.( 12? )
	u8		numadjacentsegs;  // how many segments is this one joined to.
		}TRACKSEGINFO;

/*
 level data format:
	1)	TRACKDATAHEADER
	2) Jigsaw pieces in the new format
	3) TRACKSEGINFO * numsegpieces

 Notes:
 	This is very provisional at the moment, should be finalised as soon as the new
 	model format is decided

 Other stuff to be included later:
	startpoints.
	event boxes.
	navigation lines/info.
	poly normals.( for collision )
	poly info.( coll flag, surface type etc )
*/



