OPT = -G0 -O0 -c -g -Wall -DSCREENSHOT=0 -DPSX=1 -DNEWPAD=1 -DPAL=1
OPT2 = -G0 -O2 -c -g -Wall -DSCREENSHOT=0 -DPSX=1 -DNEWPAD=1 -DPAL=1

ASM = asmpsx
LINK = psylink

LINKOPTS = /m/n768/wm/c
OBJECTS = cdlib.obj sdlib\SubDiv.obj sdlib\gtefile2.obj main.obj sdlib\sdfunc.obj sdlib\psx_only.obj render.obj psx\mathPSX.obj psx\loadPSX.obj collide.obj sim.obj psx\soundPSX.obj boot.obj gameloop.obj camera.obj weapons.obj mesh.obj objects.obj PSX\tweakPSX.obj pickups.obj state.obj frontend.obj colobj.obj hue.obj psx\PSX_expn.obj psx\gpuPSX.obj psx\rendmPSX.obj psx\PSX_pcks.obj fade.obj sdlib\sddemo.obj sdlib\screen.obj AI.obj psx\textPSX.obj loadit2.obj psx\onscreen.obj wake.obj memcard.obj menu.obj screens.obj loadit.obj water.obj s2.obj poon.obj action.obj fileaddr.obj score.obj text.obj stack.obj emu.obj mprintf.obj
#movie.obj movie360.obj

main.cpe: $(OBJECTS) linkfile.lnk
 $(LINK) $(LINKOPTS) @linkfile.lnk,main.cpe,main.sym,main.map
 symmunge main.sym

AI.obj: AI.C header.h version.h frontend.h fade.h render.h camera.h \
 objects.h collide.h pickups.h ctrller.h gameloop.h state.h AI.H
 ccpsx $(OPT2) ai.c -oai.obj

BOOT.obj: BOOT.C frontend.h sdlib\sdfunc.h sdlib\sdtypes.h \
 sdlib\sddemo.h header.h version.h psx\mathpsx.h render.h \
 psx\loadPSX.h mesh.h psx\soundPSX.h state.h gameloop.h objects.h \
 pickups.h psx\psx_pcks.h psx\psx_expn.h AI.h collide.h poon.h \
 memcard.h cdlib.h wake.h action.h loadit.h camera.h makefile.mak
 ccpsx $(OPT2) boot.c -oboot.obj

CAMERA.obj: CAMERA.C header.h version.h render.h objects.h sim.h \
 gameloop.h mesh.h state.h collide.h
 ccpsx $(OPT2) camera.c -ocamera.obj

COLLIDE.obj: COLLIDE.C header.h version.h psx\mathpsx.h mesh.h \
 camera.h objects.h collide.h state.h
 ccpsx $(OPT2) collide.c -ocollide.obj

COLOBJ.obj: COLOBJ.C header.h version.h mesh.h camera.h objects.h \
 collide.h pickups.h psx\mathpsx.h PSX\PSX_libs.h PSX\PSX_pcks.h \
 PSX\PSX_expn.h PSX\soundPSX.h state.h
 ccpsx $(OPT2) colobj.c -ocolobj.obj

FADE.obj: FADE.C
 ccpsx $(OPT2) fade.c -ofade.obj

FRONTEND.obj: FRONTEND.C
 ccpsx $(OPT2) frontend.c -ofrontend.obj

GAMELOOP.obj: GAMELOOP.C header.h version.h frontend.h fade.h render.h \
 camera.h objects.h collide.h sdlib\sdtypes.h sdlib\sdfunc.h \
 sdlib\sddemo.h ctrller.h gameloop.h state.h PSX\PSX_pcks.h \
 PSX\PSX_expn.h AI.h psx\textPSX.h hue.h menu.h cdlib.h psx\mathpsx.h \
 psx\gpuPSX.h sim.h mesh.h psx\onscreen.h pickups.h weapons.h action.h \
 psx\soundpsx.h poon.h psx\gpupsx.h psx\loadPSX.h s2.h
 ccpsx $(OPT2) gameloop.c -ogameloop.obj

HUE.obj: HUE.C header.h version.h hue.h
 ccpsx $(OPT2) hue.c -ohue.obj

LOADIT.obj: LOADIT.C
 ccpsx $(OPT2) loadit.c -oloadit.obj

LOADIT2.obj: LOADIT2.C frontend.h sdlib\sdfunc.h sdlib\sdtypes.h \
 sdlib\sddemo.h header.h version.h psx\mathpsx.h render.h \
 psx\loadPSX.h mesh.h psx\soundPSX.h state.h gameloop.h objects.h \
 pickups.h psx\psx_pcks.h psx\psx_expn.h AI.h collide.h poon.h \
 memcard.h cdlib.h wake.h action.h loadit.h camera.h
 ccpsx $(OPT2) loadit2.c -oloadit2.obj

MAIN.obj: MAIN.C header.h version.h frontend.h gameloop.h
 ccpsx $(OPT2) main.c -omain.obj

MESH.obj: MESH.C header.h version.h mesh.h
 ccpsx $(OPT2) mesh.c -omesh.obj

OBJECTS.obj: OBJECTS.C header.h version.h objects.h sim.h weapons.h \
 mesh.h pickups.h collide.h state.h psx\loadpsx.h psx\psx_libs.h \
 psx\mathpsx.h psx\psx_pcks.h psx\psx_expn.h psx\onscreen.h \
 sdlib\sdtypes.h ai.h action.h render.h loadit.h score.h
 ccpsx $(OPT2) objects.c -oobjects.obj

PICKUPS.obj: PICKUPS.C header.h version.h objects.h pickups.h \
 collide.h state.h camera.h AI.h c:/ps/psx/include\rand.h \
 psx\mathpsx.h c:/ps/psx/include\libgte.h
 ccpsx $(OPT2) pickups.c -opickups.obj

RENDER.obj: RENDER.C frontend.h c:/ps/psx/include\rand.h \
 sdlib\sdfunc.h sdlib\sdtypes.h sdlib\sddemo.h header.h version.h \
 render.h psx\mathpsx.h psx\gpuPSX.h gameloop.h objects.h sim.h mesh.h \
 camera.h collide.h state.h hue.h psx\textPSX.h
 ccpsx $(OPT2) render.c -orender.obj

SIM.obj: SIM.C frontend.h sdlib\sdfunc.h sdlib\sdtypes.h \
 sdlib\sddemo.h c:/ps/psx/include\rand.h header.h version.h \
 psx\soundPSX.h psx\mathpsx.h render.h objects.h sim.h collide.h \
 weapons.h mesh.h camera.h pickups.h ctrller.h state.h craftdef.h \
 psx\loadpsx.h poon.h
 ccpsx $(OPT2) sim.c -osim.obj

STATE.obj: STATE.C header.h version.h state.h loadit.h
 ccpsx $(OPT2) state.c -ostate.obj

WEAPONS.obj: WEAPONS.C header.h version.h state.h objects.h collide.h \
 weapons.h sdlib\sdfunc.h sdlib\sdtypes.h sdlib\sddemo.h \
 psx\soundpsx.h psx\mathpsx.h psx\textpsx.h
 ccpsx $(OPT2) weapons.c -oweapons.obj

ACTION.obj: ACTION.C frontend.h sdlib\sdfunc.h sdlib\sdtypes.h \
 sdlib\sddemo.h header.h version.h render.h psx\mathpsx.h psx\gpuPSX.h \
 gameloop.h objects.h sim.h mesh.h camera.h collide.h state.h hue.h \
 psx\textPSX.h action.h menu.h
 ccpsx $(OPT2) action.c -oaction.obj

MEMCARD.obj: MEMCARD.C sdlib\sddemo.h sdlib\sdtypes.h header.h \
 version.h memcard.h
 ccpsx $(OPT2) memcard.c -omemcard.obj

WATER.obj: WATER.C version.h frontend.h c:/ps/psx/include\rand.h \
 sdlib\sdfunc.h sdlib\sdtypes.h sdlib\sddemo.h header.h render.h \
 psx\mathpsx.h psx\gpuPSX.h gameloop.h objects.h sim.h mesh.h camera.h \
 collide.h state.h hue.h psx\textPSX.h water.h
 ccpsx $(OPT2) water.c -owater.obj

CDLIB.obj: CDLIB.C version.h cdlib.h fileaddr.h header.h
 ccpsx $(OPT2) cdlib.c -ocdlib.obj

wake.obj: wake.c header.h version.h render.h camera.h objects.h \
 collide.h sdlib\sdtypes.h sdlib\sdfunc.h sdlib\sddemo.h ctrller.h \
 gameloop.h state.h wake.h psx\mathpsx.h
 ccpsx $(OPT2) wake.c -owake.obj
 dmpsx wake.obj

S2.obj: S2.C header.h version.h objects.h psx\mathPSX.h camera.h \
 state.h psx\soundPSX.h
 ccpsx $(OPT2) s2.c -os2.obj

POON.obj: POON.C header.h version.h poon.h psx\mathpsx.h objects.h \
 psx\textpsx.h action.h score.h
 ccpsx $(OPT2) poon.c -opoon.obj

psx/GPUPSX.obj: psx/GPUPSX.C psx/..\frontend.h psx/..\sdlib\sdfunc.h \
 psx/..\sdlib\sdtypes.h psx/..\sdlib\sddemo.h psx/..\header.h \
 psx/..\version.h psx/..\mesh.h psx/..\objects.h psx/..\hue.h \
 psx/..\render.h psx/..\state.h psx/..\camera.h
 ccpsx $(OPT2) psx\gpupsx.c -opsx\gpupsx.obj

psx/LOADPSX.obj: psx/LOADPSX.C psx/..\frontend.h psx/..\sdlib\sdfunc.h \
 psx/..\sdlib\sdtypes.h psx/..\sdlib\sddemo.h psx/..\header.h \
 psx/..\version.h psx/mathpsx.h psx/..\render.h psx/loadPSX.h \
 psx/..\mesh.h psx/soundPSX.h psx/..\state.h psx/..\gameloop.h \
 psx/..\objects.h psx/..\pickups.h psx/psx_pcks.h psx/psx_expn.h \
 psx/..\AI.h psx/..\collide.h psx/..\poon.h psx/..\sim.h cdname.def \
 fileaddr.h
 ccpsx $(OPT2) psx\loadpsx.c -opsx\loadpsx.obj

psx/MATHPSX.obj: psx/MATHPSX.C psx/..\header.h psx/..\version.h \
 psx/..\camera.h psx/mathPSX.h
 ccpsx $(OPT2) psx\mathpsx.c -opsx\mathpsx.obj

psx/ONSCREEN.obj: psx/ONSCREEN.C psx/..\header.h psx/..\version.h \
 psx/..\objects.h psx/..\collide.h psx/..\pickups.h psx/..\weapons.h \
 psx/..\render.h psx/..\camera.h psx/..\ctrller.h \
 psx/..\sdlib\sdtypes.h psx/..\sdlib\sdfunc.h psx/..\sdlib\sddemo.h \
 psx/..\state.h psx/MATHPSX.h psx/PSX_libs.h psx/PSX_pcks.h \
 psx/PSX_expn.h psx/TEXTPSX.h psx/onscreen.h makefile.mak
 ccpsx $(OPT2) psx\onscreen.c -opsx\onscreen.obj

psx/PSX_EXPN.obj: psx/PSX_EXPN.C psx/..\header.h psx/..\version.h \
 psx/..\objects.h psx/..\pickups.h psx/..\weapons.h psx/..\render.h \
 psx/..\camera.h psx/..\state.h psx/..\collide.h psx/PSX_pcks.h \
 psx/PSX_expn.h psx/MATHPSX.h psx/..\sdlib\sdfunc.h \
 psx/..\sdlib\sdtypes.h psx/..\sdlib\sddemo.h psx/soundPSX.h
 ccpsx $(OPT2) psx\psx_expn.c -opsx\psx_expn.obj
 dmpsx psx\psx_expn.obj

psx/PSX_PCKS.obj: psx/PSX_PCKS.C psx/..\header.h psx/..\version.h \
 psx/..\objects.h psx/..\collide.h psx/..\pickups.h psx/..\weapons.h \
 psx/..\render.h psx/..\camera.h psx/..\ctrller.h \
 psx/..\sdlib\sdtypes.h psx/..\sdlib\sdfunc.h psx/..\sdlib\sddemo.h \
 psx/..\state.h psx/MATHPSX.h psx/PSX_libs.h psx/PSX_pcks.h \
 psx/PSX_expn.h psx/..\AI.h psx/soundpsx.h
 ccpsx $(OPT2) psx\psx_pcks.c -opsx\psx_pcks.obj

psx/RENDMPSX.obj: psx/RENDMPSX.C psx/..\frontend.h \
 c:/ps/psx/include\rand.h psx/..\sdlib\sdfunc.h psx/..\sdlib\sdtypes.h \
 psx/..\sdlib\sddemo.h psx/..\header.h psx/..\version.h \
 psx/..\objects.h psx/..\render.h psx/mathpsx.h psx/..\sim.h \
 psx/..\mesh.h psx/..\camera.h psx/..\collide.h psx/..\hue.h \
 psx/textPSX.h psx/..\state.h
 ccpsx $(OPT2) psx\rendmpsx.c -opsx\rendmpsx.obj

psx/SOUNDPSX.obj: psx/SOUNDPSX.C psx/..\header.h psx/..\version.h \
 psx/..\objects.h psx/mathPSX.h psx/..\camera.h psx/soundPSX.h \
 psx/..\state.h fileaddr.h cdname.def
 ccpsx $(OPT2) psx\soundpsx.c -opsx\soundpsx.obj

psx/SPRTPSX.obj: psx/SPRTPSX.C
 ccpsx $(OPT2) psx\sprtpsx.c -opsx\sprtpsx.obj

psx/TEXTPSX.obj: psx/TEXTPSX.C psx/../header.h psx/../version.h \
 psx/../render.h psx/textPSX.h
 ccpsx $(OPT2) psx\textpsx.c -opsx\textpsx.obj

psx/TWEAKPSX.obj: psx/TWEAKPSX.C psx/..\frontend.h \
 c:/ps/psx/include\rand.h psx/..\sdlib\sdfunc.h psx/..\sdlib\sdtypes.h \
 psx/..\sdlib\sddemo.h psx/..\header.h psx/..\version.h \
 psx/..\objects.h psx/..\render.h psx/..\collide.h psx/mathpsx.h \
 psx/soundpsx.h psx/..\sim.h psx/..\ctrller.h psx/..\gameloop.h \
 psx/..\hue.h psx/..\state.h psx/..\memcard.h psx/..\menu.h \
 psx/..\loadit.h psx/..\wake.h psx/..\poon.h psx/..\cdlib.h \
 psx/..\action.h psx/loadpsx.h psx/gpupsx.h fileaddr.h cdname.def
 ccpsx $(OPT2) psx\tweakpsx.c -opsx\tweakpsx.obj

sdlib/GTEFILE2.obj: sdlib/GTEFILE2.C sdlib/sdtypes.h sdlib/sddemo.h \
 sdlib/subdiv.h
 ccpsx $(OPT2) sdlib\gtefile2.c -osdlib\gtefile2.obj
 dmpsx sdlib\gtefile2.obj

sdlib/PSX_ONLY.obj: sdlib/PSX_ONLY.C sdlib/sddemo.h
 ccpsx $(OPT2) sdlib\psx_only.c -osdlib\psx_only.obj

sdlib/SCREEN.obj: sdlib/SCREEN.C makefile.mak
 ccpsx $(OPT2) sdlib\screen.c -osdlib\screen.obj

sdlib/SDDEMO.obj: sdlib/SDDEMO.C sdlib/sddemo.h sdlib/sdtypes.h \
 sdlib/subdiv.h
 ccpsx $(OPT2) sdlib\sddemo.c -osdlib\sddemo.obj

sdlib/SDFUNC.obj: sdlib/SDFUNC.C sdlib/..\header.h sdlib/..\version.h \
 sdlib/..\gameloop.h sdlib/..\state.h sdlib/screen.h sdlib/..\loadit.h \
 sdlib/sdfunc.h sdlib/sdtypes.h sdlib/sddemo.h sdlib/subdiv.h makefile.mak
 ccpsx $(OPT2) sdlib\sdfunc.c -osdlib\sdfunc.obj

sdlib/subdiv.obj: sdlib/subdiv.c sdlib/sdtypes.h sdlib/subdiv.h
 ccpsx $(OPT2) sdlib\subdiv.c -osdlib\subdiv.obj
 dmpsx sdlib\subdiv.obj

sdlib/text.obj: sdlib/text.c sdlib/sddemo.h sdlib/sdtypes.h \
 sdlib/subdiv.h sdlib/text.h
 ccpsx $(OPT2) sdlib\text.c -osdlib\text.obj

fileaddr.obj: fileaddr.c fileaddr.h header.h
 ccpsx $(OPT2) fileaddr.c -ofileaddr.obj

#movie.obj: movie.c movie.h movie360.c sdlib\sddemo.h
# ccpsx $(OPT2) movie.c -omovie.obj
#
#movie360.obj: movie360.c movie.h movie.c sdlib\sddemo.h
# ccpsx $(OPT2) movie360.c -omovie360.obj

score.obj: score.c score.h header.h state.h objects.h loadit.h action.h
 ccpsx $(OPT2) score.c -oscore.obj

menu.obj: menu.c header.h version.h frontend.h fade.h render.h \
 camera.h objects.h collide.h sdlib\sdtypes.h sdlib\sdfunc.h \
 sdlib\sddemo.h ctrller.h gameloop.h state.h psx\psx_pcks.h \
 psx\psx_expn.h ai.h psx\textpsx.h hue.h menu.h memcard.h keys.h \
 loadit.h savedata.h psx\loadpsx.h psx\soundpsx.h action.h screens.h
 ccpsx $(OPT2) menu.c -omenu.obj

screens.obj: screens.c screens.h
 ccpsx $(OPT2) screens.c -oscreens.obj

text.obj: text.c text.h
 ccpsx $(OPT2) text.c -otext.obj

mprintf.obj: mprintf.c mprintf.h
 ccpsx $(OPT2) mprintf.c -omprintf.obj

stack.obj: stack.c
 ccpsx $(OPT2) stack.c -ostack.obj

emu.obj: emu.c
 ccpsx -G0 -O2 -c -g -Wall emu.c -oemu.obj
