#include <sys/types.h>
#include <r3000.h>
#include <asm.h>
#include <kernel.h>
#include <libetc.h>
#include <libgte.h>
#include <libgpu.h>
#include <libds.h>
#include <libspu.h>
#include <libpress.h>
#include <libsnd.h>
#include <ctrller.h>

#include "movie.h"
#include "sdtypes.h"

extern	APAD   	SD_PadData[8];	// pad structure >SDLib structure

//
// Edit the data in IntroStr (See movie.h for structure)
// Call PlayMovie passing number of FMV to play
//

static short ExitPressed(void);


void PlayMovie(int MovieNum)
{
	static StrInfo IntroStr[] =
	{
#if PAL
		{"\\CD\\FMV\\CRYO.STR;1",  STR_MODE16,STR_BORDERS_ON,320, 0,16, 320, 240, 376, 	0, 127},		// 0 pal
#else
		{"\\CD\\FMV\\CRYO.STR;1",  STR_MODE16,STR_BORDERS_ON,320, 0,16, 320, 240, 376, 	0, 127},		// 1 ntsc
#endif
	};

	GsClearDispArea(0,0,0);
	DrawSync(0);
	GsSwapDispBuff();
	VSync(0);
	GsClearDispArea(0,0,0);
	DrawSync(0);

//	mprintf ("Playing movie '%s' (number %d)\n",IntroStr[MovieNum].strName,MovieNum);

	PlayStream(&IntroStr[MovieNum], ExitPressed);

	GsClearDispArea(0,0,0);
	DrawSync(0);
	GsSwapDispBuff();
	VSync(0);
	GsClearDispArea(0,0,0);
	DrawSync(0);


}



//
// Modify this function using your own input handler
//
static short ExitPressed(void) {


/* - Type:	PRIVATE
 * -
 * - Ret:	1 = Exit button pressed, 0 = otherwise.
 * -
 * - Usage:	Check if exit stream player key has been pressed.
 */

	SD_GetPadData(&SD_PadData);	// gets all data from pads hardware and puts in this structure

	if((SD_PadData[0].push2 & PAD_SEL)==0) return 1;
	else if((SD_PadData[0].push2 & PAD_START)==0) return 1;
	else if((SD_PadData[0].push2 & PAD_RD)==0) return 1;


	return 0;
}

