#include <sys/types.h>
#include <libetc.h>
#include <libgte.h>
#include <libgpu.h>
#include <libgs.h>
#include <libsn.h>
#include <gtemac.h>
#include <inline_c.h>
#include <ctrller.h>
#include	<libmath.h>
#include "..\frontend.h"
#include "..\sdlib\sdfunc.h"
#include "..\header.h"
#include "..\mesh.h"
#include "..\objects.h"
#include "..\hue.h"
#include "..\render.h"
#include "..\state.h"

extern   GsOT        *ptrwot;//jof
extern   GsOT        Wotwin0[2];                    // OT header
extern   GsOT        Wotwin1[2];                    // OT header
//extern   GsOT        Wotref[2];                    // OT header
extern   GsOT_TAG    zsorttable[2][(1<<OT_LENGTH)+100];  // Area of OT
//extern   GsOT_TAG    zsorttableref[2][1<<6];  // Area of OT

//#include "..\render.h"
//#include "mathpsx.h"
//#include "..\collide.h"
//#include "..\sim.h"
#include "..\camera.h"
//#include "..\objects.h"

//GsRVIEW2       view;                   // View Point Handler
//PACKET         out_packet[2][0x8800];        // GPU PACKETS AREA
//int            outbuf_idx __attribute__ ((section("cachedata"))) =0; // double buffer index

POLY_GT4 gt4 __attribute ((section("odcache"))) = {0};
POLY_FT4 ft4 __attribute ((section("odcache"))) = {0};
POLY_GT3 gt3 __attribute ((section("odcache"))) = {0};
POLY_FT3 ft3 __attribute ((section("odcache"))) = {0};

GsSPRITE sprite __attribute ((section("cachedata"))) = {0};

//GsOT     Wot[2]   __attribute__ ((section("cachedata"))) ={{0}};
//GsOT_TAG zsorttable[2][1<<OT_LENGTH]; /* Area of OT */
Uint8    screenflag;

s32      otzshift;          // real-z shift for order table entry
GsLINE   RENDER_line;
GsSPRITE	RENDER_sprite;
POLY_F4	RENDER_POLYF4;
POLY_F3	RENDER_POLYF3;
POLY_G4	RENDER_POLYG4;
POLY_G3	RENDER_POLYG3;
POLY_FT4  RENDER_POLYFT4;

u32   GPU_vsync[10];
//extern   void  SdModelPrint(Uint32 *MemPointer,Uint8 md,GsOT *OT,Uint8 idx,Uint32 Sort);  // print Sd model
extern   void    PrintModel(Uint32 *MemPointer,int md,GsOT *OT,Uint8 idx);

u16 last_model;
u16 last_obj;
u32 *last_mesh;

extern   int   Zoffset;
void  GPU_rendersdmodel( u16 model, u16 obj )
   {
   Zoffset=0;
   PrintModel( MESH_modeladdr[ model ], obj, &Wotwin0[0], outbuf_idx );
   }

void  GPU_rendersdtrackseg( u16 obj )
   {
   Zoffset=0;
   PrintModel( MESH_track, obj, &Wotwin0[0], outbuf_idx );
   }

void  GPU_rendersdtracksegref( u16 obj )
   {
//   void  *old;

   Zoffset=50;

   //old   =  ptrwot;
   //ptrwot   =  &Wotref[outbuf_idx];

   //PrintModel( MESH_trackref, obj, &Wotref[0], outbuf_idx );
   PrintModel( MESH_trackref, obj, &Wotwin0[0], outbuf_idx );
   //ptrwot   =old;
   }
/*
void  GPU_rendersprite( u16 f )
   {
   // plas//ex
   s32      sx0, sy0;
   s32      zv;
   vec16    v0;
   s32      sc;
   u32      sxy0;
   u32      pppp, flag;

   v0.vx =  ( OBJ_objects[ f ].p.vx>>8 )   -  CAM_camp[CAM_c].vx;
   v0.vy =  ( OBJ_objects[ f ].p.vy>>8 )   -  CAM_camp[CAM_c].vy;
   v0.vz =  ( OBJ_objects[ f ].p.vz>>8 )   -  CAM_camp[CAM_c].vz;

   CAM_camm[CAM_c].t[0]  =  0;
   CAM_camm[CAM_c].t[1]  =  0;
   CAM_camm[CAM_c].t[2]  =  0;

   vsetrotmatrix( &CAM_camm[CAM_c] );
   vsettransmatrix( &CAM_camm[CAM_c] );

   zv = RotTransPers( (SVECTOR*)&v0, &sxy0, &pppp, &flag );

   sx0   =  (s16)(sxy0&0xffff);
   sx0   =  (sx0*25)>>4;
   sy0   =  (sxy0>>16);

   if( zv>10 )
      {
      sc =  0xfffff/zv;
		RENDER_sprite.attribute	=(0<<28) | (1<<24) | (0<<30);
      RENDER_sprite.x   =sx0;
      RENDER_sprite.y   =sy0;
		RENDER_sprite.w	=64;
      RENDER_sprite.h   =64;
      RENDER_sprite.tpage=28 ;
      RENDER_sprite.u   =64;
  		RENDER_sprite.v	=0;
  		RENDER_sprite.cx	=640;
  		RENDER_sprite.cy	=255;
      RENDER_sprite.r   =128;
      RENDER_sprite.g   =128;
      RENDER_sprite.b   =128;
      RENDER_sprite.mx  =32;
      RENDER_sprite.my  =32;
      RENDER_sprite.scalex =(sc*25)>>4;
      RENDER_sprite.scaley =sc;
  		RENDER_sprite.rotate	=0;
      GsSortSprite( &RENDER_sprite, ptrwot, zv );
      }
   }
*/
/*
void  GPU_flatmod( u16  modnum )
   {
   s32   sx0,sy0,sx1,sy1,sx2,sy2,sx3, sy3;
   u32   sxy0, sxy1, sxy2, sxy3;
   u32   pppp, flag;
   vec16 a,b,c,d;

   u32   f, g;
	u32	*mp;

   FACE_VERT   *pface3list;   // tri ptr for obj0
   s16         face3num;      // num tri's
   FACE_VERT4  *pface4list;   // quad ptr for obj0
   s16         face4num;      // num quads
   s16         numobj;
   u32 zv;

   numobj  =  *MESH_modeladdr[ modnum ];
   if(numobj>4)numobj=4;
   deb3= numobj;
   for(f=0;f<numobj;f++)
      {
      face3num  =  0;
      face4num  =  0;

      mp =  MESH_modeladdr[ modnum ];
		mp++;
		mp++;
		mp++;
		mp	+=	34*f;//(f<<5)+f+f

      pface3list   =  (FACE_VERT *)*mp++;

		mp++;
      face3num+=   *mp++;
		mp++;
      face3num+=   *mp++;
		mp++;
      face3num+=   *mp++;
		mp++;
      face3num+=   *mp++;

		mp++;
      face3num+=   *mp++;
		mp++;
      face3num+=   *mp++;
		mp++;
      face3num+=   *mp++;
		mp++;
      face3num+=   *mp++;

      pface4list = (FACE_VERT4 *)*mp++;

		mp++;
      face4num+=   *mp++;
		mp++;
      face4num+=   *mp++;
		mp++;
      face4num+=   *mp++;
		mp++;
      face4num+=   *mp++;

		mp++;
      face4num+=   *mp++;
		mp++;
      face4num+=   *mp++;
		mp++;
      face4num+=   *mp++;
		mp++;
      face4num+=   *mp++;

      deb4  =  face3num;
      deb5  =  face4num;

      for(g=0;g<face3num;g++)
         {
         pppp=0;
         flag=0;
         a.vx  =  pface3list->a.vx;   a.vy  =  pface3list->a.vy;   a.vz  =  pface3list->a.vz;
         b.vx  =  pface3list->b.vx;   b.vy  =  pface3list->b.vy;   b.vz  =  pface3list->b.vz;
         c.vx  =  pface3list->c.vx;   c.vy  =  pface3list->c.vy;   c.vz  =  pface3list->c.vz;

         zv = RotTransPers3( (SVECTOR*)&a, (SVECTOR*)&b, (SVECTOR*)&c,               //temp
                        &sxy0, &sxy1, &sxy2,
                        &pppp, &flag );

         sx0   =  (sxy0&0xffff);   sy0   =  (sxy0>>16);
         sx1   =  (sxy1&0xffff);   sy1   =  (sxy1>>16);
         sx2   =  (sxy2&0xffff);   sy2   =  (sxy2>>16);
//         pppp>>=0;

         //if( sz0>0 && sz1>0 && sz2>0 )
//           sx0   < xdim   &&
//            sx0   >-xdim   &&
//            sy0   < ydim   &&
//            sy0   >-ydim   &&
//            sx1   < xdim   &&
//            sx1   >-xdim   &&
//            sy1   < ydim   &&
//            sy1   >-ydim   &&
//            sx2   < xdim   &&
//            sx2   >-xdim   &&
//            sy2   < ydim   &&
//            sy2   >-ydim   )
         //if(pppp>0)
            {
            RENDER_POLYG3.x0  =  sx0;
            RENDER_POLYG3.y0  =  sy0;
            RENDER_POLYG3.x1  =  sx1;
            RENDER_POLYG3.y1  =  sy1;
            RENDER_POLYG3.x2  =  sx2;
            RENDER_POLYG3.y2  =  sy2;
            RENDER_POLYG3.r0=newhue2rgb[(f<<5 )&255].r;
            RENDER_POLYG3.r1=newhue2rgb[(f<<5 )&255].r;
            RENDER_POLYG3.r2=newhue2rgb[(f<<5 )&255].r;
            RENDER_POLYG3.g0=newhue2rgb[(f<<5 )&255].g;
            RENDER_POLYG3.g1=newhue2rgb[(f<<5 )&255].g;
            RENDER_POLYG3.g2=newhue2rgb[(f<<5 )&255].g;
            RENDER_POLYG3.b0=newhue2rgb[(f<<5 )&255].b;
            RENDER_POLYG3.b1=newhue2rgb[(f<<5 )&255].b;
            RENDER_POLYG3.b2=newhue2rgb[(f<<5 )&255].b;

            GsSortPoly( &RENDER_POLYG3, ptrwot, zv>>otzshift );
            }
         pface3list++;
         }

      for(g=0;g<face4num;g++)
         {
         pppp=0;
         flag=0;
         a.vx  =  pface4list->d.vx;   a.vy  =  pface4list->d.vy;   a.vz  =  pface4list->d.vz;
         b.vx  =  pface4list->c.vx;   b.vy  =  pface4list->c.vy;   b.vz  =  pface4list->c.vz;
         c.vx  =  pface4list->b.vx;   c.vy  =  pface4list->b.vy;   c.vz  =  pface4list->b.vz;
         d.vx  =  pface4list->a.vx;   d.vy  =  pface4list->a.vy;   d.vz  =  pface4list->a.vz;

         zv = RotTransPers4( (SVECTOR*)&a, (SVECTOR*)&b, (SVECTOR*)&c, (SVECTOR*)&d,
                        &sxy0, &sxy1, &sxy2, &sxy3,
                        &pppp, &flag );


         sx0   =  (sxy0&0xffff);   sy0   =  (sxy0>>16);
         sx1   =  (sxy1&0xffff);   sy1   =  (sxy1>>16);
         sx2   =  (sxy2&0xffff);   sy2   =  (sxy2>>16);
         sx3   =  (sxy3&0xffff);   sy3   =  (sxy3>>16);


         //if( sz0>0 && sz1>0 && sz2>0 )
//            sx0   < xdim   &&
//            sx0   >-xdim   &&
//            sy0   < ydim   &&
//            sy0   >-ydim   &&
//            sx1   < xdim   &&
//            sx1   >-xdim   &&
//            sy1   < ydim   &&
//            sy1   >-ydim   &&
//            sx2   < xdim   &&
//            sx2   >-xdim   &&
//            sy2   < ydim   &&
//            sy2   >-ydim   )
         //if(pppp>0)
            {
            RENDER_POLYG4.x0  =  sx0;
            RENDER_POLYG4.y0  =  sy0;
            RENDER_POLYG4.x1  =  sx1;
            RENDER_POLYG4.y1  =  sy1;
            RENDER_POLYG4.x2  =  sx2;
            RENDER_POLYG4.y2  =  sy2;
            RENDER_POLYG4.x3  =  sx3;
            RENDER_POLYG4.y3  =  sy3;
            RENDER_POLYG4.r0=newhue2rgb[(g<<5 )&255].r;
            RENDER_POLYG4.r1=newhue2rgb[(g<<5 )&255].r;
            RENDER_POLYG4.r2=newhue2rgb[(g<<5 )&255].r;
            RENDER_POLYG4.r3=newhue2rgb[(g<<5 )&255].r;
            RENDER_POLYG4.g0=newhue2rgb[(g<<5 )&255].g;
            RENDER_POLYG4.g1=newhue2rgb[(g<<5 )&255].g;
            RENDER_POLYG4.g2=newhue2rgb[(g<<5 )&255].g;
            RENDER_POLYG4.g3=newhue2rgb[(g<<5 )&255].g;
            RENDER_POLYG4.b0=newhue2rgb[(g<<5 )&255].b;
            RENDER_POLYG4.b1=newhue2rgb[(g<<5 )&255].b;
            RENDER_POLYG4.b2=newhue2rgb[(g<<5 )&255].b;
            RENDER_POLYG4.b3=newhue2rgb[(g<<5 )&255].b;



            GsSortPoly( &RENDER_POLYG4, ptrwot, zv>>otzshift );
            }
         pface4list++;
         }
      }
   }
*/

void  GPU_changesplitscreen(u8 n)
   {
   RECT  rect;

   SD_InitDraw();
   rect.x = 0;
   rect.y = 0;
   rect.w = 512;
   rect.h = 512;
   ClearImage(&rect, 0,0,0);
   SD_EndDraw();


   //DrawSync(0);               // wait for last frames drwaing to be completed
   //ResetGraph(1);
    //GsSwapDispBuff();            // Swap double buffer

   switch( n )
      {
      // sould wait eof draw till swap?
      case 1:
         {// single screen
         STATE.numscreens  = 1;

         Wotwin0[0].length=OT_LENGTH;   // Set bit length of OT handler
         Wotwin0[1].length=OT_LENGTH;
         //Wotref[0].length=6;
         //Wotref[1].length=6;

         Wotwin0[0].org=zsorttable[0];  // Set Top address of OT Area to OT handler
         Wotwin0[1].org=zsorttable[1];

         //Wotref[0].org=zsorttableref[0];  // Set Top address of OT Area to OT handler
         //Wotref[1].org=zsorttableref[1];

         otzshift =  14-OT_LENGTH;

         }
         break;

      case 2:
         {// two screens
         STATE.numscreens  = 2;

         Wotwin0[0].length =  OT_LENGTH-1;   // Set bit length of OT handler
         Wotwin0[1].length =  OT_LENGTH-1;
         Wotwin0[0].org    =  zsorttable[0];  // Set Top address of OT Area to OT handler
         Wotwin0[1].org    =  zsorttable[1];

         Wotwin1[0].length =  OT_LENGTH-1;   // Set bit length of OT handler
         Wotwin1[1].length =  OT_LENGTH-1;
         Wotwin1[0].org    =  zsorttable[0] + ((1<<OT_LENGTH)>>1);  // Set Top address of OT Area to OT handler
         Wotwin1[1].org    =  zsorttable[1] + ((1<<OT_LENGTH)>>1);

         otzshift =  14-(OT_LENGTH-1);

         }
         break;
      }

   }

void  GPU_initdraw()
	{
	vec16 		rot;
   /*
   RECT        rect;

   rect.x   =  64;
   rect.y   =  25;
   rect.w   =  384;
   rect.h   =  200;

   GsSetClip2D(&rect);
   */
   SetPolyF4( &RENDER_POLYF4 );//euh?
   SetPolyF3( &RENDER_POLYF3 );
   SetPolyG4( &RENDER_POLYG4 );//euh?
   SetPolyG3( &RENDER_POLYG3 );
   SetPolyFT4( &RENDER_POLYFT4 );

	// set up cam rot matrix
   rot.vx =( CAM_came[CAM_c].vx )>>4;      // change 0x10000=360 to 0x1000=360
   rot.vy =( CAM_came[CAM_c].vy )>>4;
   rot.vz =( CAM_came[CAM_c].vz )>>4;


	//CAM_camm.m[0][0]	=	(CAM_camm.m[0][0]*25)>>4;//aspect


   }

void  GPU_halfcls( u8 a )
   {
   POLY_FT4 sline;

   SetPolyFT4(&sline);


   sline.r0 = a;
   sline.g0 = a;
   sline.b0 = a;

   sline.u0 = sline.u1 = sline.u2 = sline.u3 = 0;
   sline.v0 = sline.v1 = sline.v2 = sline.v3 = 0;

   //sline.clut = getClut(640,0);      // dont need to, 15-bit direct mode
   setSemiTrans(&sline,1);
   sline.tpage = (1<<6) | getTPage(2,0,640,0);  // 0.5+0.5
   //sline.tpage = (1<<6);

   sline.x0 = -255;
   sline.x1 = 256;
   sline.x2 = -256;
   sline.x3 = 255;

   sline.y0 = 127;
   sline.y1 = 127;
   sline.y2 = -128;
   sline.y3 = -128;

   GsSortPoly(&sline, ptrwot, 800);
   GsSortPoly(&sline, ptrwot, 1400);
   }

void  GPU_drawdebgrid()
   {
   s16   f;

   GsLINE   line;

   line.attribute=0;
   line.r   =0xf;
   line.g   =0x0;
   line.b   =0xf;

   for(f=0;f<33;f++)
      {
      line.x0  =  f<<3;
      line.y0  =  0;
      line.x1  =  f<<3;
      line.y1  =  33<<3;
      GsSortLine( &line, ptrwot, 5 );

      line.x0  =  0;
      line.y0  =  f<<3;
      line.x1  =  33<<3;
      line.y1  =  f<<3;
      GsSortLine( &line, ptrwot, 5 );

      }
   }

void  GPU_highlightgrid( s16 x,s16 z, u8 r, u8 g, u8 b )
   {
   s16   xx, zz;

   GsLINE   line;

   line.attribute=0;
   line.r   =r;
   line.g   =g;
   line.b   =b;

   xx =  x<<3;
   zz =  z<<3;

   line.x0  =  xx+1;
   line.y0  =  zz+1;
   line.x1  =  xx+7;
   line.y1  =  zz+1;
   GsSortLine( &line, ptrwot, 4 );

   line.x0  =  xx+1;
   line.y0  =  zz+7;
   line.x1  =  xx+7;
   line.y1  =  zz+7;
   GsSortLine( &line, ptrwot, 4 );

   line.x0  =  xx+1;
   line.y0  =  zz+1;
   line.x1  =  xx+1;
   line.y1  =  zz+7;
   GsSortLine( &line, ptrwot, 4 );

   line.x0  =  xx+7;
   line.y0  =  zz+1;
   line.x1  =  xx+7;
   line.y1  =  zz+7;
   GsSortLine( &line, ptrwot, 4 );
   }

void  GPU_plot( s16 x,s16 z, u8 r, u8 g, u8 b )
   {
   GsLINE   line;

   line.attribute=0;
   line.r   =r;
   line.g   =g;
   line.b   =b;


   line.x0  =  x;
   line.y0  =  z;
   line.x1  =  x+1;
   line.y1  =  z;
   GsSortLine( &line, ptrwot, 0 );
   }

void  GPU_line( s16 x0, s16 y0, s16 x1, s16 y1 )
   {
   GsLINE   line;

   line.attribute=0;
   line.r   =0xff;
   line.g   =0xff;
   line.b   =0xff;

   line.x0  =  x0;
   line.y0  =  y0;
   line.x1  =  x1;
   line.y1  =  y1;
   GsSortLine( &line, ptrwot, 1 );
   }


void  GPU_3dline( vec32 *l0, vec32 *l1, u8 r,u8 g,u8 b )
   {
//   vec16 v0,v1,v2;
//   u32   sxy0, sxy1, sxy2;
//   s32   sx0,sy0,sx1,sy1;
//   u32   pppp, flag;
//   u32   zv;
//   GsLINE   line;

//   v0.vx =  l0->vx   -  CAM_camp[CAM_c].vx;
//   v0.vy =  l0->vy   -  CAM_camp[CAM_c].vy;
//   v0.vz =  l0->vz   -  CAM_camp[CAM_c].vz;

//   v1.vx =  l1->vx   -  CAM_camp[CAM_c].vx;
//   v1.vy =  l1->vy   -  CAM_camp[CAM_c].vy;
//   v1.vz =  l1->vz   -  CAM_camp[CAM_c].vz;

//   v2.vx = v1.vx;
//   v2.vy = v1.vx;
//   v2.vz = v1.vx;

//   CAM_camm[CAM_c].t[0]  =  0;
//   CAM_camm[CAM_c].t[1]  =  0;
//   CAM_camm[CAM_c].t[2]  =  0;

//   vsetrotmatrix( &CAM_camm[CAM_c] );
//   vsettransmatrix( &CAM_camm[CAM_c] );

//   zv = RotTransPers3( (SVECTOR*)&v0, (SVECTOR*)&v1, (SVECTOR*)&v2,        //temp
//                        &sxy0, &sxy1, &sxy2,
//                        &pppp, &flag );

//   sx0   =  (sxy0&0xffff);   sy0   =  (sxy0>>16);
//   sx1   =  (sxy1&0xffff);   sy1   =  (sxy1>>16);

//   line.attribute=0;
//   line.r   =r;
//   line.g   =g;
//   line.b   =b;

//   line.x0  =  (sx0*25)>>4;
//   line.y0  =  sy0;
//   line.x1  =  (sx1*25)>>4;
//   line.y1  =  sy1;
//   if(zv>0)
//      GsSortLine( &line, ptrwot, 0 );
   }

/*
void  GPU_drawtimebar( s32 left, s32 right, u8 r, u8 g, u8 b )
	{
   s32   xl = (left>>1)-240;
   s32   xr = (right>>1)-240;

   s32   yu =  -111 ;
   s32   yb =  -111 +7;

   if(g==255)yb+=4;
	RENDER_POLYF4.x0	=	xl;	  	RENDER_POLYF4.y0	=	yu;
   RENDER_POLYF4.x1  =  xr;      RENDER_POLYF4.y1  =  yu;
	RENDER_POLYF4.x2	=	xl;	  	RENDER_POLYF4.y2	=	yb;
   RENDER_POLYF4.x3  =  xr;      RENDER_POLYF4.y3  =  yb;

   RENDER_POLYF4.r0  =  r;     RENDER_POLYF4.g0  =  g;   RENDER_POLYF4.b0  =  b;
   GsSortPoly( &RENDER_POLYF4, ptrwot, 10 );

GPU_line( (320>>1)-240, -112, (320>>1)-240, -100 );
GPU_line( (640>>1)-240, -112, (640>>1)-240, -100 );
   }
*/

void  GPU_bar( s32 x, u8 n )
	{

   s32   yu =  -111 +n*8;
   s32   yb =  -111 +7+n*8;

   RENDER_POLYF4.x0  =  -256;          RENDER_POLYF4.y0  =  yu;
   RENDER_POLYF4.x1  =  x-256;      RENDER_POLYF4.y1  =  yu;
   RENDER_POLYF4.x2  =  -256;          RENDER_POLYF4.y2  =  yb;
   RENDER_POLYF4.x3  =  x-256;      RENDER_POLYF4.y3  =  yb;

   RENDER_POLYF4.r0  =  255;     RENDER_POLYF4.g0  =  0;   RENDER_POLYF4.b0  =  100;
   GsSortPoly( &RENDER_POLYF4, ptrwot, 10 );
   }

void  GPU_callback()
   {
   //GPU_vsync[3]=VSync(1);
   }

//void  GPU_vsynccallback()
//   {
//   }

void  GPU_initcallback()
   {
/*
{//benchmaking stuff
u32   f;
u16   a=123,b=222;

mprintf("fr%d \n", VSync(-1) );
VSync(0);
for(f=0;f<5000;f++)
   {
   a=a+b;
   a=a+b;
   a=a+b;
   a=a+b;
   a=a+b;
   a=a+b;
   a=a+b;
   a=a+b;
   a=a+b;
   a=a+b;
   }
mprintf("time: %d fr%d \n", VSync(1),VSync(-1) );
exit(0) ;
} */
   //DrawSyncCallback( GPU_callback );
   }
