// fetch my bone bitch!
#include <sys/types.h>
#include <stdio.h>
#include <libetc.h>
#include <libgte.h>
#include <libgpu.h>
#include <libgs.h>
#include <libsn.h>
#include <libcd.h>
#include <libds.h>
#include <libsn.h>
#include <libsnd.h>
#include <libspu.h>
#include <gtemac.h>
#include <inline_c.h>
#include <ctrller.h>
#include "..\frontend.h"
#include "..\sdlib\sdfunc.h"

#include "..\header.h"
#include "mathpsx.h"
#include "..\render.h"
#include "loadPSX.h"
#include "..\mesh.h"
#include "soundPSX.h"
#include "..\state.h"
#include "..\gameloop.h"
#include "gpupsx.h"
//IAN TOMKINS - included for test purposes only
#include "..\objects.h"
#include "..\pickups.h"
#include "psx_pcks.h"
#include "psx_expn.h"
#include "..\AI.h"
#include "..\version.h"
#include "..\collide.h"
#include "..\poon.h"
#include "..\sim.h"

// MAT - included because 360 rocks
#include "..\cdlib.h"
#include "..\water.h"
#include "..\score.h"
#include "..\wake.h"

#if CDMASTER
#define  READCD   1
#define  READPC   0
#else
#define  READCD   0
#define  READPC   1
#endif

#if READPC
// !! This needs to be in a file without .c extension !!
#include "..\cdname.def"
#endif

#if READCD
#include "..\fileaddr.h"
#endif

///////////////////////////////////////////////////////////////////////////////////////////////
// External Declarations
///////////////////////////////////////////////////////////////////////////////////////////////
extern   vec16 SIM_rp[];
extern   void texture_init( u32 addr);
extern   void SetGraphics();      // upld graphics to vid mem and set PS vars
extern   u32   RENDER_rlestart[32*32];
extern   u8    RENDER_rledata[25*1024] ;
extern   s16   RENDER_321startstate;
extern   int   FarZDist;
extern   u8    CAM_numpancam;
extern   vec16 pancam[];
extern   s16  wrongway0, wrongway1;
// gtefile2.c
void MapModelData(Uint32 *ModAddr);

///////////////////////////////////////////////////////////////////////////////////////////////
// Private Declarations
///////////////////////////////////////////////////////////////////////////////////////////////
u8     *temp = (u8*)MESH_track;             // for textures. use union to share
s32   len;
u8 loaddirnames[17][16]={
   {" Water1"},//0
   {" Water2"},//1
   {" Water3"},//2
   {" Water arena"},//3
   {" Ice1"},//4
   {" Ice2"},//5
   {" Ice3"},//6
   {" Ice arena"},//7
   {" Seabed1"},//8
   {" Seabed2"},//9
   {" Seabed3"},//10
   {" Seabed arena"},//11
   {" Lava1"},//12
   {" Lava2"},
   {" Lava3"},
   {" Lavaarena"},
   {" Junmungle"}
   };

vec32    LOAD_startpoints[8];
s32      LOAD_startrots[8];

///////////////////////////////////////////////////////////////////////////////////////////////
// Prototypes
///////////////////////////////////////////////////////////////////////////////////////////////
s32  LOAD_findheight( s16 x, s16 z );
void  LOAD_map();
void  LOAD_mapref();
// Mat: 22/03/1999
//s32   readCDfile(void *m,char *f);
u32   modlen[30];
void  LOAD_remapplayermod( s16 n );
void  LOAD_tof();
s32   findheight( s16 x, s16 z );
///////////////////////////////////////////////////////////////////////////////////////////////
// Functions
///////////////////////////////////////////////////////////////////////////////////////////////

// DSspin logo stuff
void  LOAD_PutLogo();                                 //////////////
void  LOAD_SetLogo();                                 // DDD  SSSS /
                                                      // D  D S    /
RECT  LogoFrom;                                       // D  D SSSS /
RECT  ScreenFrom;                                     // D  D    S /
u_short  LogoBuff[48];                                // DDD  SSSS /
u_short  ScreenBuff[48];                              //////////////
u_short  *Buff;
u_short  *SBuff;
int   lp1;
u_short  LPX=30;
u_short  LPY=15;
///////////////////

//u8    filename[500][100];
extern   u32   *GameMode;

void  LOAD_genericdata()
   {
//   u32   *p;
//   s32   f;

   printf( "LOAD: Generic data\n" );
   printf( "GameMode(%lu)\n ", (u32)GameMode-0x80010000 );
// Mat: 22/03/1999
//   DsInit();
//		VSync(0);
   //DsReset();

   LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\tims\\lens\\flare.btm")   );LOAD_btm((u32*)temp);
   LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\tims\\icons\\icons.btm")  );LOAD_btm((u32*)temp);
   LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\weapons\\weapons.btm") );LOAD_btm((u32*)temp);

// load models from gen.dat
      {
      s16   f;
      s32   *ilen=(s32*)temp;
      u8    *s;
      u8    *d;
      s16   indx=0;
      u8    modused[10]={0,0,0,0,0,0,0,0,0,0};
      u8    modnum;

      // load .dat file and skip header
      LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\generic\\generic.dat") );

      s  =  temp+ilen[indx++];
      d  =  (u8*)MESH_models;
      /////////////////////////////////

      // find which models are used
      for(f=0;f<10;f++)
         {
         modused[STATE.ctype[f]]=1;
         }
      for(f=0;f<10;f++)
         {
         printf("modused(%d)\n",modused[f] );
         }

      /////////////////////////////

      // load car models from .dat
      for(modnum=0,f=0;f<10;f++)
         {
         if( modused[f] )
            {
            crafts[f].model=modnum;
            MESH_modeladdr[modnum] =  (u32 *)d;
            memcpy( d, s, ilen[indx] );
            MapModelData( (Uint32 *)d );
            modnum++;
            d+=ilen[f+1];
            }
         indx++;
         s+=ilen[f+1];
         }
      /////////////////////////////

      // load carmip mods
      for(f=10;f<20;f++)
         {
         MESH_modeladdr[modnum] =  (u32 *)d;
         memcpy( d, s, ilen[indx] );
         MapModelData((Uint32 *) d );

         modnum++;
         indx++;
         s+=ilen[f+1];
         d+=ilen[f+1];
         }
      /////////////////

      // load misc mods
      for(f=20;f<26;f++)
         {
         MESH_modeladdr[modnum] =  (u32 *)d;
         memcpy( d, s, ilen[indx] );
         MapModelData((Uint32 *) d );

         modnum++;
         indx++;
         s+=ilen[f+1];
         d+=ilen[f+1];
         }
      /////////////////

      // load mod btms
      for(modnum=0,f=0;f<10;f++)
         {
         if( modused[f] )
            {
            LOAD_btm((u32*)s);
            LOAD_remapplayermod( modnum );
            modnum++;
            }
         s+=ilen[indx];
         indx++;
         }
      ////////////////

      // load mip mod btms
      for(f=0;f<1;f++)
         {
         LOAD_btm((u32*)s);
         s+=ilen[indx];
         indx++;
         }
      ////////////////////
      LOAD_btm((u32*)s);
      s+=ilen[indx];
      indx++;
      ////////////////////
      LOAD_btm((u32*)s);

      //for(f=0;f<20;f++)
      //   {
      //   printf("ilen %d\n",ilen[f] );
      //   }
      }
// ^load models from gen.dat^
   }

void  *FILE_bigmac[17] = {
   __CD_NAME_GEN("c:\\360\\data\\w1\\bigmac.rle"),
   __CD_NAME_GEN("c:\\360\\data\\w2\\bigmac.rle"),
   __CD_NAME_GEN("c:\\360\\data\\w3\\bigmac.rle"),
   __CD_NAME_GEN("c:\\360\\data\\wa\\bigmac.rle"),

   __CD_NAME_GEN("c:\\360\\data\\i1\\bigmac.rle"),
   __CD_NAME_GEN("c:\\360\\data\\i2\\bigmac.rle"),
   __CD_NAME_GEN("c:\\360\\data\\i3\\bigmac.rle"),
   __CD_NAME_GEN("c:\\360\\data\\ia\\bigmac.rle"),

   __CD_NAME_GEN("c:\\360\\data\\s1\\bigmac.rle"),
   __CD_NAME_GEN("c:\\360\\data\\s2\\bigmac.rle"),
   __CD_NAME_GEN("c:\\360\\data\\s3\\bigmac.rle"),
   __CD_NAME_GEN("c:\\360\\data\\sa\\bigmac.rle"),

   __CD_NAME_GEN("c:\\360\\data\\l1\\bigmac.rle"),
   __CD_NAME_GEN("c:\\360\\data\\l2\\bigmac.rle"),
   __CD_NAME_GEN("c:\\360\\data\\l3\\bigmac.rle"),
   __CD_NAME_GEN("c:\\360\\data\\la\\bigmac.rle"),

   __CD_NAME_GEN("c:\\360\\data\\ja\\bigmac.rle")
 };

void  *FILE_poomap[17] = {
   __CD_NAME_GEN("c:\\360\\data\\w1\\poo.map"),
   __CD_NAME_GEN("c:\\360\\data\\w2\\poo.map"),
   __CD_NAME_GEN("c:\\360\\data\\w3\\poo.map"),
   __CD_NAME_GEN("c:\\360\\data\\wa\\poo.map"),

   __CD_NAME_GEN("c:\\360\\data\\i1\\poo.map"),
   __CD_NAME_GEN("c:\\360\\data\\i2\\poo.map"),
   __CD_NAME_GEN("c:\\360\\data\\i3\\poo.map"),
   __CD_NAME_GEN("c:\\360\\data\\ia\\poo.map"),

   __CD_NAME_GEN("c:\\360\\data\\s1\\poo.map"),
   __CD_NAME_GEN("c:\\360\\data\\s2\\poo.map"),
   __CD_NAME_GEN("c:\\360\\data\\s3\\poo.map"),
   __CD_NAME_GEN("c:\\360\\data\\sa\\poo.map"),

   __CD_NAME_GEN("c:\\360\\data\\l1\\poo.map"),
   __CD_NAME_GEN("c:\\360\\data\\l2\\poo.map"),
   __CD_NAME_GEN("c:\\360\\data\\l3\\poo.map"),
   __CD_NAME_GEN("c:\\360\\data\\la\\poo.map"),

   __CD_NAME_GEN("c:\\360\\data\\ja\\poo.map")
};

void  *FILE_backdr[17] = {
    __CD_NAME_GEN("c:\\360\\data\\backdrop\\waterT.TIM"),
    __CD_NAME_GEN("c:\\360\\data\\backdrop\\waterT.TIM"),
    __CD_NAME_GEN("c:\\360\\data\\backdrop\\waterT.TIM"),
    __CD_NAME_GEN("c:\\360\\data\\backdrop\\waterA.TIM"),

    __CD_NAME_GEN("c:\\360\\data\\backdrop\\iceT.TIM"),
    __CD_NAME_GEN("c:\\360\\data\\backdrop\\iceT.TIM"),
    __CD_NAME_GEN("c:\\360\\data\\backdrop\\iceT.TIM"),
    __CD_NAME_GEN("c:\\360\\data\\backdrop\\iceA.TIM"),

    __CD_NAME_GEN("c:\\360\\data\\backdrop\\seaT.TIM"),
    __CD_NAME_GEN("c:\\360\\data\\backdrop\\seaT.TIM"),
    __CD_NAME_GEN("c:\\360\\data\\backdrop\\seaT.TIM"),
    __CD_NAME_GEN("c:\\360\\data\\backdrop\\seaA.TIM"),

    __CD_NAME_GEN("c:\\360\\data\\backdrop\\lavaT.TIM"),
    __CD_NAME_GEN("c:\\360\\data\\backdrop\\lavaT.TIM"),
    __CD_NAME_GEN("c:\\360\\data\\backdrop\\lavaT.TIM"),
    __CD_NAME_GEN("c:\\360\\data\\backdrop\\lavaA.TIM"),

    __CD_NAME_GEN("c:\\360\\data\\backdrop\\jungleA.TIM")
    };

void  *FILE_panbtm[17] = {
   __CD_NAME_GEN("c:\\360\\data\\w1\\panic.btm"),
   __CD_NAME_GEN("c:\\360\\data\\w2\\panic.btm"),
   __CD_NAME_GEN("c:\\360\\data\\w3\\panic.btm"),
   __CD_NAME_GEN("c:\\360\\data\\wa\\panic.btm"),

   __CD_NAME_GEN("c:\\360\\data\\i1\\panic.btm"),
   __CD_NAME_GEN("c:\\360\\data\\i2\\panic.btm"),
   __CD_NAME_GEN("c:\\360\\data\\i3\\panic.btm"),
   __CD_NAME_GEN("c:\\360\\data\\ia\\panic.btm"),

   __CD_NAME_GEN("c:\\360\\data\\s1\\panic.btm"),
   __CD_NAME_GEN("c:\\360\\data\\s2\\panic.btm"),
   __CD_NAME_GEN("c:\\360\\data\\s3\\panic.btm"),
   __CD_NAME_GEN("c:\\360\\data\\sa\\panic.btm"),

   __CD_NAME_GEN("c:\\360\\data\\l1\\panic.btm"),
   __CD_NAME_GEN("c:\\360\\data\\l2\\panic.btm"),
   __CD_NAME_GEN("c:\\360\\data\\l3\\panic.btm"),
   __CD_NAME_GEN("c:\\360\\data\\la\\panic.btm"),

   __CD_NAME_GEN("c:\\360\\data\\ja\\panic.btm")

    };

void  *FILE_panmap[17] = {
   __CD_NAME_GEN("c:\\360\\data\\w1\\panic.map"),
   __CD_NAME_GEN("c:\\360\\data\\w2\\panic.map"),
   __CD_NAME_GEN("c:\\360\\data\\w3\\panic.map"),
   __CD_NAME_GEN("c:\\360\\data\\wa\\panic.map"),

   __CD_NAME_GEN("c:\\360\\data\\i1\\panic.map"),
   __CD_NAME_GEN("c:\\360\\data\\i2\\panic.map"),
   __CD_NAME_GEN("c:\\360\\data\\i3\\panic.map"),
   __CD_NAME_GEN("c:\\360\\data\\ia\\panic.map"),

   __CD_NAME_GEN("c:\\360\\data\\s1\\panic.map"),
   __CD_NAME_GEN("c:\\360\\data\\s2\\panic.map"),
   __CD_NAME_GEN("c:\\360\\data\\s3\\panic.map"),
   __CD_NAME_GEN("c:\\360\\data\\sa\\panic.map"),

   __CD_NAME_GEN("c:\\360\\data\\l1\\panic.map"),
   __CD_NAME_GEN("c:\\360\\data\\l2\\panic.map"),
   __CD_NAME_GEN("c:\\360\\data\\l3\\panic.map"),
   __CD_NAME_GEN("c:\\360\\data\\la\\panic.map"),

   __CD_NAME_GEN("c:\\360\\data\\ja\\panic.map")
    };

void  *FILE_pansdf[17] = {
   __CD_NAME_GEN("c:\\360\\data\\w1\\panic.sdf"),
   __CD_NAME_GEN("c:\\360\\data\\w2\\panic.sdf"),
   __CD_NAME_GEN("c:\\360\\data\\w3\\panic.sdf"),
   __CD_NAME_GEN("c:\\360\\data\\wa\\panic.sdf"),

   __CD_NAME_GEN("c:\\360\\data\\i1\\panic.sdf"),
   __CD_NAME_GEN("c:\\360\\data\\i2\\panic.sdf"),
   __CD_NAME_GEN("c:\\360\\data\\i3\\panic.sdf"),
   __CD_NAME_GEN("c:\\360\\data\\ia\\panic.sdf"),

   __CD_NAME_GEN("c:\\360\\data\\s1\\panic.sdf"),
   __CD_NAME_GEN("c:\\360\\data\\s2\\panic.sdf"),
   __CD_NAME_GEN("c:\\360\\data\\s3\\panic.sdf"),
   __CD_NAME_GEN("c:\\360\\data\\sa\\panic.sdf"),

   __CD_NAME_GEN("c:\\360\\data\\l1\\panic.sdf"),
   __CD_NAME_GEN("c:\\360\\data\\l2\\panic.sdf"),
   __CD_NAME_GEN("c:\\360\\data\\l3\\panic.sdf"),
   __CD_NAME_GEN("c:\\360\\data\\la\\panic.sdf"),

   __CD_NAME_GEN("c:\\360\\data\\ja\\panic.sdf")

    };

void  *FILE_object[17] = {
   __CD_NAME_GEN("c:\\360\\data\\w1\\objects.tof"),
   __CD_NAME_GEN("c:\\360\\data\\w2\\objects.tof"),
   __CD_NAME_GEN("c:\\360\\data\\w3\\objects.tof"),
   __CD_NAME_GEN("c:\\360\\data\\wa\\objects.tof"),

   __CD_NAME_GEN("c:\\360\\data\\i1\\objects.tof"),
   __CD_NAME_GEN("c:\\360\\data\\i2\\objects.tof"),
   __CD_NAME_GEN("c:\\360\\data\\i3\\objects.tof"),
   __CD_NAME_GEN("c:\\360\\data\\ia\\objects.tof"),

   __CD_NAME_GEN("c:\\360\\data\\s1\\objects.tof"),
   __CD_NAME_GEN("c:\\360\\data\\s2\\objects.tof"),
   __CD_NAME_GEN("c:\\360\\data\\s3\\objects.tof"),
   __CD_NAME_GEN("c:\\360\\data\\sa\\objects.tof"),

   __CD_NAME_GEN("c:\\360\\data\\l1\\objects.tof"),
   __CD_NAME_GEN("c:\\360\\data\\l2\\objects.tof"),
   __CD_NAME_GEN("c:\\360\\data\\l3\\objects.tof"),
   __CD_NAME_GEN("c:\\360\\data\\la\\objects.tof"),

   __CD_NAME_GEN("c:\\360\\data\\ja\\objects.tof")

    };

void  *FILE_poosdf[17] = {
   __CD_NAME_GEN("c:\\360\\data\\w1\\poo.sdf"),
   __CD_NAME_GEN("c:\\360\\data\\w2\\poo.sdf"),
   __CD_NAME_GEN("c:\\360\\data\\w3\\poo.sdf"),
   __CD_NAME_GEN("c:\\360\\data\\wa\\poo.sdf"),

   __CD_NAME_GEN("c:\\360\\data\\i1\\poo.sdf"),
   __CD_NAME_GEN("c:\\360\\data\\i2\\poo.sdf"),
   __CD_NAME_GEN("c:\\360\\data\\i3\\poo.sdf"),
   __CD_NAME_GEN("c:\\360\\data\\ia\\poo.sdf"),

   __CD_NAME_GEN("c:\\360\\data\\s1\\poo.sdf"),
   __CD_NAME_GEN("c:\\360\\data\\s2\\poo.sdf"),
   __CD_NAME_GEN("c:\\360\\data\\s3\\poo.sdf"),
   __CD_NAME_GEN("c:\\360\\data\\sa\\poo.sdf"),

   __CD_NAME_GEN("c:\\360\\data\\l1\\poo.sdf"),
   __CD_NAME_GEN("c:\\360\\data\\l2\\poo.sdf"),
   __CD_NAME_GEN("c:\\360\\data\\l3\\poo.sdf"),
   __CD_NAME_GEN("c:\\360\\data\\la\\poo.sdf"),

   __CD_NAME_GEN("c:\\360\\data\\ja\\poo.sdf")

    };

void  *FILE_aidata[17] = {
    __CD_NAME_GEN("c:\\360\\data\\AI_data\\tracks\\water\\track1\\AIwater1.aim"),
    __CD_NAME_GEN("c:\\360\\data\\AI_data\\tracks\\water\\track2\\AIwater2.aim"),
    __CD_NAME_GEN("c:\\360\\data\\AI_data\\tracks\\water\\track3\\AIwater3.aim"),
    __CD_NAME_GEN("c:\\360\\data\\AI_data\\arenas\\water\\AIwatera.aim"),

    __CD_NAME_GEN("c:\\360\\data\\AI_data\\tracks\\ice\\track1\\AIice1.aim"),
    __CD_NAME_GEN("c:\\360\\data\\AI_data\\tracks\\ice\\track2\\AIice2.aim"),
    __CD_NAME_GEN("c:\\360\\data\\AI_data\\tracks\\ice\\track3\\AIice3.aim"),
    __CD_NAME_GEN("c:\\360\\data\\AI_data\\arenas\\ice\\AIicea.aim"),

    __CD_NAME_GEN("c:\\360\\data\\AI_data\\tracks\\seabed\\track1\\AIsea1.aim"),
    __CD_NAME_GEN("c:\\360\\data\\AI_data\\tracks\\seabed\\track2\\AIsea2.aim"),
    __CD_NAME_GEN("c:\\360\\data\\AI_data\\tracks\\seabed\\track3\\AIsea3.aim"),
    __CD_NAME_GEN("c:\\360\\data\\AI_data\\arenas\\seabed\\AIseaa.aim"),

    __CD_NAME_GEN("c:\\360\\data\\AI_data\\tracks\\lava\\track1\\AIlava1.aim"),
    __CD_NAME_GEN("c:\\360\\data\\AI_data\\tracks\\lava\\track2\\AIlava2.aim"),
    __CD_NAME_GEN("c:\\360\\data\\AI_data\\tracks\\lava\\track3\\AIlava3.aim"),
    __CD_NAME_GEN("c:\\360\\data\\AI_data\\arenas\\lava\\AIlavaa.aim"),

    __CD_NAME_GEN("c:\\360\\data\\AI_data\\arenas\\jungle\\AIjungle.aim")
    };

void  *FILE_bilsdf[17] = {
   __CD_NAME_GEN("c:\\360\\data\\w1\\billie.sdf"),//
   __CD_NAME_GEN("c:\\360\\data\\w2\\billie.sdf"),//no btm
   __CD_NAME_GEN("c:\\360\\data\\w3\\billie.sdf"),//
   __CD_NAME_GEN("c:\\360\\data\\wa\\billie.sdf"),//

   __CD_NAME_GEN("c:\\360\\data\\i1\\billie.sdf"),//no btm
   __CD_NAME_GEN("c:\\360\\data\\i2\\billie.sdf"),//no btm
   __CD_NAME_GEN("c:\\360\\data\\i3\\billie.sdf"),//no btm1
   __CD_NAME_GEN("c:\\360\\data\\ia\\billie.sdf"),//

   __CD_NAME_GEN("c:\\360\\data\\s1\\billie.sdf"),//
   __CD_NAME_GEN("c:\\360\\data\\s2\\billie.sdf"),//
   __CD_NAME_GEN("c:\\360\\data\\s3\\billie.sdf"),//
   __CD_NAME_GEN("c:\\360\\data\\sa\\billie.sdf"),//

   __CD_NAME_GEN("c:\\360\\data\\l1\\billie.sdf"),// got
   __CD_NAME_GEN("c:\\360\\data\\l2\\billie.sdf"),// got
   __CD_NAME_GEN("c:\\360\\data\\l3\\billie.sdf"),// got
   __CD_NAME_GEN("c:\\360\\data\\la\\billie.sdf"),// got

   __CD_NAME_GEN("c:\\360\\data\\ja\\billie.sdf") //
    };

void  *FILE_bilmap[17] = {
   __CD_NAME_GEN("c:\\360\\data\\w1\\billie.map"),
   __CD_NAME_GEN("c:\\360\\data\\w2\\billie.map"),
   __CD_NAME_GEN("c:\\360\\data\\w3\\billie.map"),
   __CD_NAME_GEN("c:\\360\\data\\wa\\billie.map"),

   __CD_NAME_GEN("c:\\360\\data\\i1\\billie.map"),
   __CD_NAME_GEN("c:\\360\\data\\i2\\billie.map"),
   __CD_NAME_GEN("c:\\360\\data\\i3\\billie.map"),
   __CD_NAME_GEN("c:\\360\\data\\ia\\billie.map"),

   __CD_NAME_GEN("c:\\360\\data\\s1\\billie.map"),
   __CD_NAME_GEN("c:\\360\\data\\s2\\billie.map"),
   __CD_NAME_GEN("c:\\360\\data\\s3\\billie.map"),
   __CD_NAME_GEN("c:\\360\\data\\sa\\billie.map"),

   __CD_NAME_GEN("c:\\360\\data\\l1\\billie.map"),
   __CD_NAME_GEN("c:\\360\\data\\l2\\billie.map"),
   __CD_NAME_GEN("c:\\360\\data\\l3\\billie.map"),
   __CD_NAME_GEN("c:\\360\\data\\la\\billie.map"),

   __CD_NAME_GEN("c:\\360\\data\\ja\\billie.map")

    };

void  *FILE_bilbtm[17] = {
   __CD_NAME_GEN("c:\\360\\data\\w1\\billie.btm"),
   __CD_NAME_GEN("c:\\360\\data\\w2\\billie.btm"),
   __CD_NAME_GEN("c:\\360\\data\\w3\\billie.btm"),
   __CD_NAME_GEN("c:\\360\\data\\wa\\billie.btm"),

   __CD_NAME_GEN("c:\\360\\data\\i1\\billie.btm"),
   __CD_NAME_GEN("c:\\360\\data\\i2\\billie.btm"),
   __CD_NAME_GEN("c:\\360\\data\\i3\\billie.btm"),
   __CD_NAME_GEN("c:\\360\\data\\ia\\billie.btm"),

   __CD_NAME_GEN("c:\\360\\data\\s1\\billie.btm"),
   __CD_NAME_GEN("c:\\360\\data\\s2\\billie.btm"),
   __CD_NAME_GEN("c:\\360\\data\\s3\\billie.btm"),
   __CD_NAME_GEN("c:\\360\\data\\sa\\billie.btm"),

   __CD_NAME_GEN("c:\\360\\data\\l1\\billie.btm"),
   __CD_NAME_GEN("c:\\360\\data\\l2\\billie.btm"),
   __CD_NAME_GEN("c:\\360\\data\\l3\\billie.btm"),
   __CD_NAME_GEN("c:\\360\\data\\la\\billie.btm"),

   __CD_NAME_GEN("c:\\360\\data\\ja\\billie.btm")

    };

void  LOAD_level()
	{
   u32   *p;
//   s32   f, index;
   s32   i, success;
   s32   level =  STATE.currlevel;
//   RECT vram;
	u8		AI_data_buffer[MAX_AI_COLLISION_MAP_ENTRIES * 5];
   G_cyc =  0;
   CAM_numpancam  =  0;
   wrongway0   =  wrongway1   =  0 ;

   printf("LOAD: Level specific stuff\n");

   if( ((STATE.currlevel&3)==3) || (STATE.currlevel==16))
      {
      STATE.arena_mode  =  1;
      }
   else
      STATE.arena_mode  =  0;

   STATE.raceclock      =  -0xfffffff;
   RENDER_321startstate =  0;
   SOUND_killobjects();
// initialise player objects
   OBJ_initobjarray();
   PCK_totalnumpickups=0;

   if( STATE.demomode == 1)
      {
      s16   i;
      STATE.wankers  =  2;
      for(i=0;i<STATE.wankers;i++)
         {
         OBJ_newobj( OTcraft );     OBJ_initplayer( i,STATE.ctype[i],1 );
         }
      }
   else
      {

//1 ul   ong   - what game mode are we in 0-battle 1-tourn 2-time 3-arcade
      switch( STATE.gametype )
         {
         case 0 : //battle
            STATE.wankers = 2;
            OBJ_newobj( OTcraft );     OBJ_initplayer( 0,STATE.ctype[0],0 );
            OBJ_newobj( OTcraft );     OBJ_initplayer( 1,STATE.ctype[1],0 );
            break;

         case 1 : //tourn
            STATE.wankers = 2;
            OBJ_newobj( OTcraft );     OBJ_initplayer( 0,STATE.ctype[0],0 );
            OBJ_newobj( OTcraft );     OBJ_initplayer( 1,STATE.ctype[1],0 );
            break;

         case 2 : //time-t
            STATE.wankers = 1;
            OBJ_newobj( OTcraft );     OBJ_initplayer( 0,STATE.ctype[0],0 );
            break;

         case 3 : //arcade
            STATE.wankers = 6;
            OBJ_newobj( OTcraft );     OBJ_initplayer( 0,STATE.ctype[0],0 );

            OBJ_newobj( OTcraft );     OBJ_initplayer( 1,STATE.ctype[1],1 );
            OBJ_newobj( OTcraft );     OBJ_initplayer( 2,STATE.ctype[2],1 );
            OBJ_newobj( OTcraft );     OBJ_initplayer( 3,STATE.ctype[3],1 );
            OBJ_newobj( OTcraft );     OBJ_initplayer( 4,STATE.ctype[4],1 );
            OBJ_newobj( OTcraft );     OBJ_initplayer( 5,STATE.ctype[5],1 );
            break;
         }
      }
//   if(STATE.numscreens==1)
//   {
//      OBJ_newobj( OTcraft );
//      OBJ_initplayer( 1,STATE.ctype[1],1 );
//   }
//   else
//   {
//      OBJ_newobj( OTcraft );
//      OBJ_initplayer( 1,STATE.ctype[1],0 );
//   }

//   for (i = 2; i < MAXNUMPLAYERS; i++)
//   {
//      OBJ_newobj( OTcraft );
//      OBJ_initplayer( i,STATE.ctype[i],1 );
//   }
//// initialise player objects^^


// Mat: 22/03/1999
//   DsInit();

   VSync(0);

   MESH_xgridnum =  32;
   MESH_zgridnum =  32;

   MESH_xgridsize  =  65536/MESH_xgridnum;
   MESH_zgridsize  =  65536/MESH_zgridnum;


   STATE.vsync=ON;
   //DsReset();
   //printf("t0 %d\n", (u32)MESH_track&0xffffff);
   //printf("t1 %d\n", (u32)MESH_trackref&0xffffff);
   //LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\tims\\font\\Ntext_sm.tim")   );LOAD_loadTexture((u32 *)temp);
   LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\tims\\font\\itext_sm.tim")  );LOAD_loadTexture((u32 *)temp);
   LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\tims\\font\\inums_bg.tim")   );LOAD_loadTexture((u32 *)temp);
   LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\tims\\font\\ingame02.tim")   );LOAD_loadTexture((u32 *)temp);

   FarZDist =4500;


//   switch( level )
//      {
//      case  0:// water track1
         SOUND_tracklist[0]=7;

         //viewcone rle
         LOAD_nread( temp, FILE_bigmac[level] );
         memcpy( RENDER_rlestart,   temp, 32*32*4 );
         memcpy( RENDER_rledata,    temp+32*32*4, 22*1024 );
         //viewcone rle


         //reflection map
         LOAD_nread( temp, FILE_poomap[level] );LOAD_mapref();

         if(STATE.numscreens==1)
            {
            //backdrop
            LOAD_nread( temp, FILE_backdr[level] );LOAD_loadTexture((u32 *)temp);
            // main model
            LOAD_nread( temp, FILE_panbtm[level] );LOAD_btm((u32*)temp);
            LOAD_nread( temp, FILE_panmap[level] );LOAD_map();
            len=LOAD_nread(temp, FILE_pansdf[level]);
            p=(u32 *)temp;
            MapModelData((Uint32 *) p );
            }
         else
            {
            // 2plyr model cos artists are complete wankers
            LOAD_nread( temp, FILE_bilbtm[level] );LOAD_btm((u32*)temp);
            LOAD_nread( temp, FILE_bilmap[level] );LOAD_map();
            len=LOAD_nread(temp, FILE_bilsdf[level]);
            p=(u32 *)temp;
            MapModelData((Uint32 *) p );
            }
         MESH_trackref  =  MESH_track+(len>>2);

         //info
         LOAD_nread( MESH_trackref, FILE_object[level] );LOAD_tof();


         if(STATE.numscreens==1)
            {
            // reflection model
            len+=LOAD_nread(MESH_trackref, FILE_poosdf[level] );
            p=MESH_trackref;
            MapModelData((Uint32 *) p );
            }
         printf("tot sdf mem %ld\n", len);
         success = LOAD_nread( AI_data_buffer, FILE_aidata[ level ] );

         if (success != NULLVAL)
              AI_init_data( AI_data_buffer );

//         break;
//      case  1:// water 2
//         SOUND_tracklist[0]=7;

//         //viewcone rle
//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\w2\\bigmac.rle"));
//         memcpy( RENDER_rlestart,   temp, 32*32*4 );
//         memcpy( RENDER_rledata,    temp+32*32*4, 22*1024 );
//         //viewcone rle

//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\w2\\poo.map"));LOAD_mapref();

//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\backdrop\\waterT.TIM")   );LOAD_loadTexture((u32 *)temp);
//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\w2\\panic.btm"));LOAD_btm((u32*)temp);
//         //LOAD_nread(temp, "c:\\360\\data\\tims\\font\\Ntext_sm.tim"   );LOAD_loadTexture((u32 *)temp);
//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\w2\\panic.map"));LOAD_map();
//         len=LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\w2\\panic.sdf"));
//          p=temp;
//         MapModelData((Uint32 *) p );

//         MESH_trackref  =  MESH_track+(len>>2);

//         //info
//         LOAD_nread(MESH_trackref, __CD_NAME_GEN("c:\\360\\data\\w2\\objects.tof"));LOAD_tof();

//         len+=LOAD_nread(MESH_trackref, __CD_NAME_GEN("c:\\360\\data\\w2\\poo.sdf"));
//          p=MESH_trackref;
//         MapModelData((Uint32 *) p );
//         printf("tot sdf mem %d\n", len);


//         success = LOAD_nread(AI_data_buffer, __CD_NAME_GEN("c:\\360\\data\\AI_data\\tracks\\water\\track2\\AIwater2.aim"));

//         if (success != NULLVAL)
//              AI_init_data(AI_data_buffer);

//         break;
//      case  2:// water 3
//         SOUND_tracklist[0]=7;

//         //viewcone rle
//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\w3\\bigmac.rle"));
//         memcpy( RENDER_rlestart,   temp, 32*32*4 );
//         memcpy( RENDER_rledata,    temp+32*32*4, 22*1024 );
//         //viewcone rle

//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\w3\\poo.map"));LOAD_mapref();

//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\backdrop\\waterT.TIM")   );LOAD_loadTexture((u32 *)temp);
//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\w3\\panic.btm"));LOAD_btm((u32*)temp);
//         //LOAD_nread(temp, "c:\\360\\data\\tims\\font\\Ntext_sm.tim"   );LOAD_loadTexture((u32 *)temp);
//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\w3\\panic.map"));LOAD_map();
//         len=LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\w3\\panic.sdf"));
//          p=temp;
//         MapModelData((Uint32 *) p );

//         MESH_trackref  =  MESH_track+(len>>2);

//         //info
//         LOAD_nread(MESH_trackref, __CD_NAME_GEN("c:\\360\\data\\w3\\objects.tof"));LOAD_tof();

//         len+=LOAD_nread(MESH_trackref, __CD_NAME_GEN("c:\\360\\data\\w3\\poo.sdf"));
//          p=MESH_trackref;
//         MapModelData((Uint32 *) p );
//         printf("tot sdf mem %d\n", len);
//         success = LOAD_nread(AI_data_buffer, __CD_NAME_GEN("c:\\360\\data\\AI_data\\tracks\\water\\track3\\AIwater3.aim"));

//         if (success != NULLVAL)
//              AI_init_data(AI_data_buffer);

//         break;
//      case  3:// water A

//         SOUND_tracklist[0]=7;

//         //viewcone rle
//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\wa\\bigmac.rle"));
//         memcpy( RENDER_rlestart,   temp, 32*32*4 );
//         memcpy( RENDER_rledata,    temp+32*32*4, 22*1024 );
//         //viewcone rle

//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\wa\\poo.map"));LOAD_mapref();

//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\backdrop\\WaterA.TIM")   );LOAD_loadTexture((u32 *)temp);
//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\wa\\panic.btm"));LOAD_btm((u32*)temp);
//         //LOAD_nread(temp, "c:\\360\\data\\tims\\font\\Ntext_sm.tim"   );LOAD_loadTexture((u32 *)temp);
//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\wa\\panic.map"));LOAD_map();
//         len=LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\wa\\panic.sdf"));
//          p=temp;
//         MapModelData( p );

//         MESH_trackref  =  MESH_track+(len>>2);

//         //info
//         LOAD_nread(MESH_trackref, __CD_NAME_GEN("c:\\360\\data\\wa\\objects.tof"));LOAD_tof();

//         len+=LOAD_nread(MESH_trackref, __CD_NAME_GEN("c:\\360\\data\\wa\\poo.sdf"));
//          p=MESH_trackref;
//         MapModelData( p );
//         printf("tot sdf mem %d\n", len);

////         vequ(&LOAD_startpoints[0], 9086, -1035, 14308);
////         vequ(&LOAD_startpoints[1], 10921, -1035, 13763);
////         vequ(&LOAD_startpoints[2], 13637, -1035, 14292);
////         vequ(&LOAD_startpoints[3], 6983, -1035, 14825);
////         vequ(&LOAD_startpoints[4], 2796, -1097, 21589);
////         vequ(&LOAD_startpoints[5], -6707, -659, 14611);
////         vequ(&LOAD_startpoints[6], -5989, -659, 7440);
////         vequ(&LOAD_startpoints[7], -2109, -940, -5817);

//         success = LOAD_nread(AI_data_buffer, __CD_NAME_GEN("c:\\360\\data\\AI_data\\arenas\\water\\AIwatera.aim"));

//         if (success != NULLVAL)
//              AI_init_data(AI_data_buffer);

//         break;
//      case  4:// ice1
//         SOUND_tracklist[0]=6;

//         //viewcone rle
//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\i1\\bigmac.rle"));
//         memcpy( RENDER_rlestart,   temp, 32*32*4 );
//         memcpy( RENDER_rledata,    temp+32*32*4, 22*1024 );
//         //viewcone rle

//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\i1\\poo.map"));LOAD_mapref();

//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\backdrop\\IceT.TIM")   );LOAD_loadTexture((u32 *)temp);
//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\i1\\panic.btm"));LOAD_btm((u32*)temp);
//         //LOAD_nread(temp, "c:\\360\\data\\i1\\font\\Ntext_sm.tim"   );LOAD_loadTexture((u32 *)temp);
//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\i1\\panic.map"));LOAD_map();
//         len=LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\i1\\panic.sdf"));
//          p=temp;
//         MapModelData( p );

//         MESH_trackref  =  MESH_track+(len>>2);

//         //info
//         LOAD_nread(MESH_trackref, __CD_NAME_GEN("c:\\360\\data\\i1\\objects.tof"));LOAD_tof();

//         len+=LOAD_nread(MESH_trackref, __CD_NAME_GEN("c:\\360\\data\\i1\\poo.sdf"));
//          p=MESH_trackref;
//         MapModelData( p );
//         printf("tot sdf mem %d\n", len);

////         vequ(&LOAD_startpoints[0], -7375, -64, -11013);
////         vequ(&LOAD_startpoints[1], -5874,-64,15083);

//         success = LOAD_nread(AI_data_buffer, __CD_NAME_GEN("c:\\360\\data\\AI_data\\tracks\\ice\\track1\\AIice1.aim"));

//         if (success != NULLVAL)
//              AI_init_data(AI_data_buffer);

//         break;
//      case  5:// ice2
//         SOUND_tracklist[0]=6;

//         //viewcone rle
//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\i2\\bigmac.rle"));
//         memcpy( RENDER_rlestart,   temp, 32*32*4 );
//         memcpy( RENDER_rledata,    temp+32*32*4, 22*1024 );
//         //viewcone rle


//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\i2\\poo.map"));LOAD_mapref();

//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\backdrop\\IceT.TIM")  );LOAD_loadTexture((u32 *)temp);
//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\i2\\panic.btm"));LOAD_btm((u32*)temp);
//         //LOAD_nread(temp, "c:\\360\\data\\i2\\font\\Ntext_sm.tim"   );LOAD_loadTexture((u32 *)temp);
//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\i2\\panic.map"));LOAD_map();
//         len=LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\i2\\panic.sdf"));
//          p=temp;
//         MapModelData( p );

//         MESH_trackref  =  MESH_track+(len>>2);

//         //info
//         LOAD_nread(MESH_trackref, __CD_NAME_GEN("c:\\360\\data\\i2\\objects.tof"));LOAD_tof();

//         len+=LOAD_nread(MESH_trackref, __CD_NAME_GEN("c:\\360\\data\\i2\\poo.sdf"));
//          p=MESH_trackref;
//         MapModelData( p );
//         printf("tot sdf mem %d\n", len);


//         success = LOAD_nread(AI_data_buffer, __CD_NAME_GEN("c:\\360\\data\\AI_data\\tracks\\ice\\track2\\AIice2.aim"));

//         if (success != NULLVAL)
//              AI_init_data(AI_data_buffer);

//         break;
//      case  6:// ice3
//         SOUND_tracklist[0]=6;

//         //viewcone rle
//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\i3\\bigmac.rle"));
//         memcpy( RENDER_rlestart,   temp, 32*32*4 );
//         memcpy( RENDER_rledata,    temp+32*32*4, 22*1024 );
//         //viewcone rle


//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\i3\\poo.map"));LOAD_mapref();

//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\backdrop\\IceT.TIM")   );LOAD_loadTexture((u32 *)temp);
//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\i3\\panic.btm"));LOAD_btm((u32*)temp);
//         //LOAD_nread(temp, "c:\\360\\data\\i3\\font\\Ntext_sm.tim"   );LOAD_loadTexture((u32 *)temp);
//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\i3\\panic.map"));LOAD_map();
//         len=LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\i3\\panic.sdf"));
//          p=temp;
//         MapModelData( p );

//         MESH_trackref  =  MESH_track+(len>>2);

//         //info
//         LOAD_nread(MESH_trackref, __CD_NAME_GEN("c:\\360\\data\\i3\\objects.tof"));LOAD_tof();

//         len+=LOAD_nread(MESH_trackref, __CD_NAME_GEN("c:\\360\\data\\i3\\poo.sdf"));
//          p=MESH_trackref;
//         MapModelData( p );
//         printf("tot sdf mem %d\n", len);

////         vequ(&LOAD_startpoints[0], -17677, -95, 8932);//JT startpoints
////         vequ(&LOAD_startpoints[1], -17440, -95, 9147);
////         vequ(&LOAD_startpoints[2], -17156, -95, 9405);
////         vequ(&LOAD_startpoints[3], -16824, -95, 9706);
////         vequ(&LOAD_startpoints[4], -15899, -95, 9162);
////         vequ(&LOAD_startpoints[5], -16308, -95, 9137);
////         vequ(&LOAD_startpoints[6], -16735, -95, 8750);
////         vequ(&LOAD_startpoints[7], -17019, -95, 8492);

//         success = LOAD_nread(AI_data_buffer, __CD_NAME_GEN("c:\\360\\data\\AI_data\\tracks\\ice\\track3\\AIice3.aim"));

//         if (success != NULLVAL)
//              AI_init_data(AI_data_buffer);

//         break;
//      case  7:// icea
//         SOUND_tracklist[0]=6;

//         //viewcone rle
//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\i3\\bigmac.rle"));
//         memcpy( RENDER_rlestart,   temp, 32*32*4 );
//         memcpy( RENDER_rledata,    temp+32*32*4, 22*1024 );
//         //viewcone rle


//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\ia\\poo.map"));LOAD_mapref();

//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\backdrop\\IceA.TIM")  );LOAD_loadTexture((u32 *)temp);
//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\ia\\panic.btm"));LOAD_btm((u32*)temp);
//         //LOAD_nread(temp, "c:\\360\\data\\ia\\font\\Ntext_sm.tim")   );LOAD_loadTexture((u32 *)temp);
//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\ia\\panic.map"));LOAD_map();
//         len=LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\ia\\panic.sdf"));
//          p=temp;
//         MapModelData( p );

//         MESH_trackref  =  MESH_track+(len>>2);

//         //info
//         LOAD_nread(MESH_trackref, __CD_NAME_GEN("c:\\360\\data\\ia\\objects.tof"));LOAD_tof();

//         len+=LOAD_nread(MESH_trackref, __CD_NAME_GEN("c:\\360\\data\\ia\\poo.sdf"));
//          p=MESH_trackref;
//         MapModelData( p );
//         printf("tot sdf mem %d\n", len);

////         vequ(&LOAD_startpoints[0], 7880,-180,-15020);
////         vequ(&LOAD_startpoints[1], -88,-150,2520);

//         success = LOAD_nread(AI_data_buffer, __CD_NAME_GEN("c:\\360\\data\\AI_data\\arenas\\ice\\AIicea.aim"));

//         if (success != NULLVAL)
//              AI_init_data(AI_data_buffer);

//         break;
//      case  8:// sea1
//         SOUND_tracklist[0]=5;

//         //viewcone rle
//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\s1\\bigmac.rle"));
//         memcpy( RENDER_rlestart,   temp, 32*32*4 );
//         memcpy( RENDER_rledata,    temp+32*32*4, 22*1024 );
//         //viewcone rle


//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\s1\\poo.map"));LOAD_mapref();

//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\backdrop\\seat.TIM")   );LOAD_loadTexture((u32 *)temp);
//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\s1\\panic.btm"));LOAD_btm((u32*)temp);
//         //LOAD_nread(temp, "c:\\360\\data\\ia\\font\\Ntext_sm.tim"   );LOAD_loadTexture((u32 *)temp);
//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\s1\\panic.map"));LOAD_map();
//         len=LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\s1\\panic.sdf"));
//          p=temp;
//         MapModelData( p );

//         MESH_trackref  =  MESH_track+(len>>2);

//         //info
//         LOAD_nread(MESH_trackref, __CD_NAME_GEN("c:\\360\\data\\s1\\objects.tof"));LOAD_tof();

//         len+=LOAD_nread(MESH_trackref, __CD_NAME_GEN("c:\\360\\data\\s1\\poo.sdf"));
//          p=MESH_trackref;
//         MapModelData( p );
//         printf("tot sdf mem %d\n", len);

////         vequ(&LOAD_startpoints[0], -17200, -100, -164); //JT
////         vequ(&LOAD_startpoints[1], -17474, -100, -433);
////         vequ(&LOAD_startpoints[2], -17063, -100, -29 );
////         vequ(&LOAD_startpoints[3], -16789, -100, -240);
////         vequ(&LOAD_startpoints[4], -16113, -100, -174);
////         vequ(&LOAD_startpoints[5], -16342, -100, -398);
////         vequ(&LOAD_startpoints[6], -16616, -100, -667);
////         vequ(&LOAD_startpoints[7], -16844, -100, -891);

//         success = LOAD_nread(AI_data_buffer, __CD_NAME_GEN("c:\\360\\data\\AI_data\\tracks\\seabed\\track1\\AIsea1.aim"));

//         if (success != NULLVAL)
//              AI_init_data(AI_data_buffer);

//         break;
//      case  9:// sea2
//         SOUND_tracklist[0]=5;

//         //viewcone rle
//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\s2\\bigmac.rle"));
//         memcpy( RENDER_rlestart,   temp, 32*32*4 );
//         memcpy( RENDER_rledata,    temp+32*32*4, 22*1024 );
//         //viewcone rle


//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\s2\\poo.map"));LOAD_mapref();

//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\backdrop\\seat2.TIM")   );LOAD_loadTexture((u32 *)temp);
//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\s2\\panic.btm"));LOAD_btm((u32*)temp);
//         //LOAD_nread(temp, "c:\\360\\data\\ia\\font\\Ntext_sm.tim"   );LOAD_loadTexture((u32 *)temp);
//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\s2\\panic.map"));LOAD_map();
//         len=LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\s2\\panic.sdf"));
//          p=temp;
//         MapModelData( p );

//         MESH_trackref  =  MESH_track+(len>>2);

//         //info
//         LOAD_nread(MESH_trackref, __CD_NAME_GEN("c:\\360\\data\\s2\\objects.tof"));LOAD_tof();

//         len+=LOAD_nread(MESH_trackref, __CD_NAME_GEN("c:\\360\\data\\s2\\poo.sdf"));
//          p=MESH_trackref;
//         MapModelData( p );
//         printf("tot sdf mem %d\n", len);

////         vequ(&LOAD_startpoints[0], 18779,-380,7361);
////         vequ(&LOAD_startpoints[1], 21962,-537,9460);

//         success = LOAD_nread(AI_data_buffer, __CD_NAME_GEN("c:\\360\\data\\AI_data\\tracks\\seabed\\track2\\AIsea2.aim"));

//         if (success != NULLVAL)
//              AI_init_data(AI_data_buffer);

//         break;
//      case 10:// sea3
//         SOUND_tracklist[0]=5;

//         //viewcone rle
//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\s3\\bigmac.rle"));
//         memcpy( RENDER_rlestart,   temp, 32*32*4 );
//         memcpy( RENDER_rledata,    temp+32*32*4, 22*1024 );
//         //viewcone rle


//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\s3\\poo.map"));LOAD_mapref();

//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\backdrop\\seat.TIM")   );LOAD_loadTexture((u32 *)temp);
//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\s3\\panic.btm"));LOAD_btm((u32*)temp);
//         //LOAD_nread(temp, "c:\\360\\data\\ia\\font\\Ntext_sm.tim"   );LOAD_loadTexture((u32 *)temp);
//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\s3\\panic.map"));LOAD_map();
//         len=LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\s3\\panic.sdf"));
//          p=temp;
//         MapModelData( p );

//         MESH_trackref  =  MESH_track+(len>>2);

//         //info
//         LOAD_nread(MESH_trackref, __CD_NAME_GEN("c:\\360\\data\\s3\\objects.tof"));LOAD_tof();

//         len+=LOAD_nread(MESH_trackref, __CD_NAME_GEN("c:\\360\\data\\s3\\poo.sdf"));
//          p=MESH_trackref;
//         MapModelData( p );
//         printf("tot sdf mem %d\n", len);

//         success = LOAD_nread(AI_data_buffer, __CD_NAME_GEN("c:\\360\\data\\AI_data\\tracks\\seabed\\track3\\AIsea3.aim"));

//         if (success != NULLVAL)
//              AI_init_data(AI_data_buffer);

//         break;

//      case 11:// seaA
//         SOUND_tracklist[0]=5;

//         //viewcone rle
//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\sa\\bigmac.rle"));
//         memcpy( RENDER_rlestart,   temp, 32*32*4 );
//         memcpy( RENDER_rledata,    temp+32*32*4, 22*1024 );
//         //viewcone rle


//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\sa\\poo.map"));LOAD_mapref();

//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\backdrop\\SeaA.TIM")  );LOAD_loadTexture((u32 *)temp);
//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\sa\\panic.btm"));LOAD_btm((u32*)temp);
//         //LOAD_nread(temp, "c:\\360\\data\\ia\\font\\Ntext_sm.tim")   );LOAD_loadTexture((u32 *)temp);
//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\sa\\panic.map"));LOAD_map();
//         len=LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\sa\\panic.sdf"));
//          p=temp;
//         MapModelData( p );

//         MESH_trackref  =  MESH_track+(len>>2);

//         //info
//         LOAD_nread(MESH_trackref, __CD_NAME_GEN("c:\\360\\data\\sa\\objects.tof"));LOAD_tof();

//         len+=LOAD_nread(MESH_trackref, __CD_NAME_GEN("c:\\360\\data\\sa\\poo.sdf"));
//          p=MESH_trackref;
//         MapModelData( p );
//         printf("tot sdf mem %d\n", len);

////         vequ(&LOAD_startpoints[0], -2713, -189,-626);
////         vequ(&LOAD_startpoints[1], -88,-150,2520);

//         success = LOAD_nread(AI_data_buffer, __CD_NAME_GEN("c:\\360\\data\\AI_data\\arenas\\seabed\\AIseaA.aim"));

//         if (success != NULLVAL)
//              AI_init_data(AI_data_buffer);

//         break;

//      case 12:// lava1
//         SOUND_tracklist[0]=4;

//         //viewcone rle
//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\l1\\bigmac.rle"));
//         memcpy( RENDER_rlestart,   temp, 32*32*4 );
//         memcpy( RENDER_rledata,    temp+32*32*4, 22*1024 );
//         //viewcone rle


//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\l1\\poo.map"));LOAD_mapref();

//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\backdrop\\LavaT.TIM")  );LOAD_loadTexture((u32 *)temp);
//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\l1\\panic.btm"));LOAD_btm((u32*)temp);
//         //LOAD_nread(temp, "c:\\360\\data\\tims\\font\\Ntext_sm.tim"   );LOAD_loadTexture((u32 *)temp);
//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\l1\\panic.map"));LOAD_map();
//         len=LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\l1\\panic.sdf"));
//          p=temp;
//         MapModelData( p );

//         MESH_trackref  =  MESH_track+(len>>2);

//         //info
//         LOAD_nread(MESH_trackref, __CD_NAME_GEN("c:\\360\\data\\l1\\objects.tof"));LOAD_tof();

//         len+=LOAD_nread(MESH_trackref, __CD_NAME_GEN("c:\\360\\data\\l1\\poo.sdf"));
//          p=MESH_trackref;
//         MapModelData( p );
//         printf("tot sdf mem %d\n", len);

////vequ(&LOAD_startpoints[0],-22614 , -61 , 7921      );
////vequ(&LOAD_startpoints[1],134 , -61 , 846          );
////vequ(&LOAD_startpoints[2],-1895 , -61 , -1664      );
////vequ(&LOAD_startpoints[3],841 , -62 , -9475        );
////vequ(&LOAD_startpoints[4],10877 , -61 , 24826      );
////vequ(&LOAD_startpoints[5],-14832 , -60 , -9934     );
////vequ(&LOAD_startpoints[6],-16100 , -60 , -11760    );
////vequ(&LOAD_startpoints[7],-14906 , -61 , -3186     );


//         success = LOAD_nread(AI_data_buffer, __CD_NAME_GEN("c:\\360\\data\\AI_data\\tracks\\lava\\track1\\AIlava1.aim"));

//         if (success != NULLVAL)
//              AI_init_data(AI_data_buffer);

//         break;
//      case 13:// lava2
//         SOUND_tracklist[0]=4;

//         //viewcone rle
//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\l2\\bigmac.rle"));
//         memcpy( RENDER_rlestart,   temp, 32*32*4 );
//         memcpy( RENDER_rledata,    temp+32*32*4, 22*1024 );
//         //viewcone rle


//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\l2\\poo.map"));LOAD_mapref();

//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\backdrop\\LavaT.TIM")   );LOAD_loadTexture((u32 *)temp);
//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\l2\\panic.btm"));LOAD_btm((u32*)temp);
//         //LOAD_nread(temp, "c:\\360\\data\\tims\\font\\Ntext_sm.tim"   );LOAD_loadTexture((u32 *)temp);
//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\l2\\panic.map"));LOAD_map();
//         len=LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\l2\\panic.sdf"));
//          p=temp;
//         MapModelData( p );

//         MESH_trackref  =  MESH_track+(len>>2);

//         //info
//         LOAD_nread(MESH_trackref, __CD_NAME_GEN("c:\\360\\data\\l2\\objects.tof"));LOAD_tof();

//         len+=LOAD_nread(MESH_trackref, __CD_NAME_GEN("c:\\360\\data\\l2\\poo.sdf"));
//          p=MESH_trackref;
//         MapModelData( p );
//         printf("tot sdf mem %d\n", len);

////         vequ(&LOAD_startpoints[0], 5033, -60, 585 );
////         vequ(&LOAD_startpoints[1], 5330, -60, 465 );
////         vequ(&LOAD_startpoints[2], 5567, -60, 370 );
////         vequ(&LOAD_startpoints[3], 5924, -60, 227 );
////         vequ(&LOAD_startpoints[4], 5958, -60, -891);
////         vequ(&LOAD_startpoints[5], 5601, -60, -747);
////         vequ(&LOAD_startpoints[6], 5245, -60, -604);
////         vequ(&LOAD_startpoints[7], 4948, -60, -485);

//         success = LOAD_nread(AI_data_buffer, __CD_NAME_GEN("c:\\360\\data\\AI_data\\tracks\\lava\\track2\\AIlava2.aim"));

//         if (success != NULLVAL)
//              AI_init_data(AI_data_buffer);

//         break;
//      case 14:// lava3
//         SOUND_tracklist[0]=4;

//         //viewcone rle
//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\l3\\bigmac.rle"));
//         memcpy( RENDER_rlestart,   temp, 32*32*4 );
//         memcpy( RENDER_rledata,    temp+32*32*4, 22*1024 );
//         //viewcone rle


//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\l3\\poo.map"));LOAD_mapref();

//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\backdrop\\LavaT.TIM")  );LOAD_loadTexture((u32 *)temp);
//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\l3\\panic.btm"));LOAD_btm((u32*)temp);
//         //LOAD_nread(temp, "c:\\360\\data\\tims\\font\\Ntext_sm.tim"   );LOAD_loadTexture((u32 *)temp);
//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\l3\\panic.map"));LOAD_map();
//         len=LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\l3\\panic.sdf"));
//          p=temp;
//         MapModelData( p );

//         MESH_trackref  =  MESH_track+(len>>2);

//         //info
//         LOAD_nread(MESH_trackref, __CD_NAME_GEN("c:\\360\\data\\l3\\objects.tof"));LOAD_tof();

//         len+=LOAD_nread(MESH_trackref, __CD_NAME_GEN("c:\\360\\data\\l3\\poo.sdf"));
//          p=MESH_trackref;
//         MapModelData( p );
//         printf("tot sdf mem %d\n", len);

////      vequ(&LOAD_startpoints[0],1466 , -61 , 18674         );
////      vequ(&LOAD_startpoints[1],10538 , -61 , 27251        );
////      vequ(&LOAD_startpoints[2],8018 , -61 , 17487         );
////      vequ(&LOAD_startpoints[3],10859 , -61 , 5710         );
////      vequ(&LOAD_startpoints[4],22558 , -61 , 412          );
////      vequ(&LOAD_startpoints[5],2310 , -60 , -12571        );
////      vequ(&LOAD_startpoints[6],-651 , -62 , 17742         );
////      vequ(&LOAD_startpoints[7],9065 , -62 , 25382         );

//         success = LOAD_nread(AI_data_buffer, __CD_NAME_GEN("c:\\360\\data\\AI_data\\tracks\\lava\\track3\\AIlava3.aim"));

//         if (success != NULLVAL)
//              AI_init_data(AI_data_buffer);

//         break;
//      case 15:// lavaa
//         SOUND_tracklist[0]=4;

//         //viewcone rle
//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\la\\bigmac.rle"));
//         memcpy( RENDER_rlestart,   temp, 32*32*4 );
//         memcpy( RENDER_rledata,    temp+32*32*4, 22*1024 );
//         //viewcone rle


//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\la\\poo.map"));LOAD_mapref();

//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\backdrop\\LavaA.TIM")  );LOAD_loadTexture((u32 *)temp);
//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\la\\panic.btm"));LOAD_btm((u32*)temp);
//         //LOAD_nread(temp, "c:\\360\\data\tims\\font\\Ntext_sm.tim"   );LOAD_loadTexture((u32 *)temp);
//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\la\\panic.map"));LOAD_map();
//         len=LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\la\\panic.sdf"));
//          p=temp;
//         MapModelData( p );

//         MESH_trackref  =  MESH_track+(len>>2);

//         //info
//         LOAD_nread(MESH_trackref, __CD_NAME_GEN("c:\\360\\data\\la\\objects.tof"));LOAD_tof();

//         len+=LOAD_nread(MESH_trackref, __CD_NAME_GEN("c:\\360\\data\\la\\poo.sdf"));
//          p=MESH_trackref;
//         MapModelData( p );
//         printf("tot sdf mem %d\n", len);

////         vequ(&LOAD_startpoints[0], 18038,1131,-2965);
////         vequ(&LOAD_startpoints[1], 17379,1131,-8815);
////         vequ(&LOAD_startpoints[2], 18379,1131,-8815);

//         success = LOAD_nread(AI_data_buffer, __CD_NAME_GEN("c:\\360\\data\\AI_data\\arenas\\lava\\AIlavaa.aim"));

//         if (success != NULLVAL)
//              AI_init_data(AI_data_buffer);

//         break;
//      case 16://jungle
//         FarZDist =2200;
//         SOUND_tracklist[0]=6;

//         //viewcone rle
//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\ja\\bigmac.rle"));
//         memcpy( RENDER_rlestart,   temp, 32*32*4 );
//         memcpy( RENDER_rledata,    temp+32*32*4, 22*1024 );
//         //viewcone rle

//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\ja\\poo.map"));LOAD_mapref();

//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\backdrop\\junglea.TIM")   );LOAD_loadTexture((u32 *)temp);
//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\ja\\panic.btm"));LOAD_btm((u32*)temp);
//         //LOAD_nread(temp, "c:\\360\\data\\tims\\font\\Ntext_sm.tim"   );LOAD_loadTexture((u32 *)temp);
//         LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\ja\\panic.map"));LOAD_map();
//         len=LOAD_nread(temp, __CD_NAME_GEN("c:\\360\\data\\ja\\panic.sdf"));
//          p=temp;
//         MapModelData( p );

//         MESH_trackref  =  MESH_track+(len>>2);

//         //info
////         LOAD_nread(MESH_trackref, "c:\\360\\data\\ja\\objects.tof");LOAD_tof();

//         len+=LOAD_nread(MESH_trackref, __CD_NAME_GEN("c:\\360\\data\\ja\\poo.sdf"));
//          p=MESH_trackref;
//         MapModelData( p );
//         printf("tot sdf mem %d\n", len);

//         vequ(&LOAD_startpoints[0], -11377, -67, 656);
//         vequ(&LOAD_startpoints[1], -11567, -98, -6078);

//         success = LOAD_nread(AI_data_buffer, __CD_NAME_GEN("c:\\360\\data\\AI_data\\arenas\\jungle\\AIjungle.aim"));

//         if (success != NULLVAL)
//              AI_init_data(AI_data_buffer);

//         break;
//      }

//IAN TOMKINS INITIALISERS
//PSX_init_lens_flare();

PCK_init_all();
PCK_init_flares();
//PCK_init_octane_structs();
PSX_init_burst_structs();
//PCK_init_rocket_sets();
PSX_init_shield_structs();
PSX_init_shield();

init_icon_struct();
//allocate_player_pickups(&OBJ_players[0]);
//allocate_player_pickups(&OBJ_players[1]);

//init_ripple_structs();
//init_ripple_ctrl_structs();
//init_explosion_ctrl_structs();
//init_explosion_flames();
//#if IAN
PSX_init_all_flame_ctrls();
PSX_make_scenic_effects_for_kam_and_co();
//#endif
set_identity_matrix();
//PSX_init_start_finish_markers();


   for(i=0;i<STATE.wankers;i++)
      {
      if( OBJ_objects[i].type!=OTcraft )continue;
      SIM_startsim( i );

      }

   for (i = 0; i < STATE.wankers; i++)
	   AI_init_player(&OBJ_objects[i]);


//#else

//END OF IAN TOMKINS INITIALISERS

/*   OBJ_initplayer( 0,1,0 );
   OBJ_initplayer( 1,1,1 );
   OBJ_initplayer( 2,1,0 );
   OBJ_initplayer( 3,1,0 );
   OBJ_initplayer( 4,1,0 );
   OBJ_initplayer( 5,1,0 );
   OBJ_initplayer( 6,1,0 );
   OBJ_initplayer( 7,1,0 );

#endif
*/


	//PCK_init_pickups();
	PCK_360isfuckingshitbutinitallpickupsanyway();
	SOUND_setvol(127);
	SCORE_reset();
	WAKE_init();

	// 29/04/1999 - MT: Moved lower down
//	SOUND_playcdtrack( );

   /*
	if (level == 12)
      {
           for (i = 0; i < 4; i++)
          {
            index = OBJ_newobj(OTsmoke_fx);

            OBJ_objects[index].p.vx = (23690 - (400 * (i + 1))) << 8;
            OBJ_objects[index].p.vy = 400 << 8;
            OBJ_objects[index].p.vz = (20327 + (70 * (i + 1))) << 8;

            OBJ_objects[index].v.vx = 0;
            OBJ_objects[index].v.vy = 0;
            OBJ_objects[index].v.vz = 0;

            if (index != NULLVAL)
                PSX_init_new_explosion(&OBJ_objects[index], smoke_fx, OTHER_COLLISION);
          }
      }
   */

	waterFallInit();

   GPU_changesplitscreen(STATE.numscreens);

	// 29-04-1999: MT: Moved from above
	SOUND_playcdtrack( );
#if !CDMASTER
   FntLoad(960,256);
   FntOpen(-240,-120,256,200,0,512);

#endif
   }

#if READCD

s32 LOAD_nread(void *m,NFSRCH *f)
    {
	DrawSync(0);
	return CDLIB_NRead(f,m);
	}

#if 0
s32 LOAD_readPCfile(void *m,char *f )
	{
	DrawSync(0);
	return CDLIB_Read(f,m);
	}
#endif
#endif

#if READPC
s32 LOAD_nread(void *m,char *f)
	{
	return LOAD_readPCfile(m,f);
	}

s32 LOAD_readPCfile(void *m,char *f )
	{
	int l,len;
	int fh;

//	// 29-04-1999: MT: new thingy only in pc mode (emu cd stop, read)
	CDLIB_pctest();

    fh = PCopen(f,0,0);
	if(fh==-1)
		{
		printf("Bad load! %s %d\n",f,fh);
		return -1;
		}
	else{
		len = PClseek(fh,0,2);
		PClseek(fh,0,0);
		l = PCread(fh,m,len);
      	printf("loaded %s %d\n",f,l);
		PCclose(fh);
		return len;
		}
	}
#endif

void LOAD_writePCfile(void *m,char *f,u32 len)
	{
	int l;
	int fh = PCopen(f,2,0);
	//printf("Writing to %s\n",f);
	if(fh==-1)
		printf("DEBUG: Error opening pc files (%s)\n",f);
	else
		{
		l = PCwrite(fh,m,len);
		if(l!=len)
         {
         printf("DEBUG: Error writing pc files (%s)\n",f);
         RENDER_message("DEBUG: Error writing pc files ");
         }
      PCclose(fh);
		}
	}

////////////////////////////////////////////////////////////////////////////////////////////
// tim stuff
////////////////////////////////////////////////////////////////////////////////////////////

typedef  struct
   {
   u32   flag;
   u32   x;
   u32   y;
   u32   w;
   u32   h;
   }TIMDATA;

TIMDATA  LOAD_timdata[200];

void LOAD_loadTexture(u32 *t)
{
static int   timnum=0;

u32 *tp;
u_short *sp;
RECT rct;
tp = t+1;
LOAD_timdata[timnum].flag =  *tp;
if(*tp++&0x08)      // Flag dword
	{
   sp = (u_short *)++tp;
	rct.x = *sp++;
	rct.y = *sp++;
	rct.w = *sp++;
	rct.h = *sp++;

   tp = (u32 *)sp;
   //dmp("Clut",rct,tp);
   LoadImage(&rct,tp);
   tp += (rct.w*rct.h)>>1;
	}

sp = (u_short *)++tp;
LOAD_timdata[timnum].x  =  rct.x = (*sp++);// % 64;
LOAD_timdata[timnum].y  =  rct.y = (*sp++);// % 256;
LOAD_timdata[timnum].w  =  rct.w = *sp++;
LOAD_timdata[timnum].h  =  rct.h = *sp++;

tp = (u32 *)sp;
//dmp("Image",rct,tp);
LoadImage(&rct,tp);
/*printf("tim: %d id:%d x:%d y:%d w:%d h:%d\n", timnum,
        LOAD_timdata[timnum].flag,
        LOAD_timdata[timnum].x,
        LOAD_timdata[timnum].y,
        LOAD_timdata[timnum].w,
        LOAD_timdata[timnum].h
      );
*/
//EXP_fire_uv_table[timnum][0] = (LOAD_timdata[timnum].x % 64) * 4;
//EXP_fire_uv_table[timnum][1] = (LOAD_timdata[timnum].y % 256);
//EXP_fire_uv_table[timnum][2] = EXP_fire_uv_table[timnum][0] + ((LOAD_timdata[timnum].w * 4) - 1);
//EXP_fire_uv_table[timnum][3] = EXP_fire_uv_table[timnum][1] + (LOAD_timdata[timnum].h - 1);
//EXP_fire_uv_table[timnum][4] = EXP_fire_uv_table[timnum][2] - EXP_fire_uv_table[timnum][0];
//EXP_fire_uv_table[timnum][5] = EXP_fire_uv_table[timnum][3] - EXP_fire_uv_table[timnum][1];

//if (timnum < 26)
//    printf("test_tim: %d: w : %d h : %d\n", timnum,EXP_fire_uv_table[timnum][4], EXP_fire_uv_table[timnum][5]);

timnum++;
}

void  LOAD_btm( u32 *TextureAddr )
{
u32   NumTextures;
u16    llp;
u32   *ActualAddr;
u32   *BaseAddr;
DrawSync(0);

	NumTextures=*TextureAddr++;
   printf("NumTextures %lu\n",NumTextures);
	BaseAddr=TextureAddr;
	for (llp=0;llp<NumTextures;llp++)
	{
   ActualAddr=((u32 *) ( ((u32)BaseAddr) +(NumTextures*4)+ (*TextureAddr++) ) );
   texture_init((u32)ActualAddr);
	}
}

int doread = 0;
extern void  RENDER_loadcycle();


//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////
// Mat: 22/03/1999
#if 0
s32   readCDfile( void *m,char *f )
{
int i,l;
int fileSize;
u_char v[8];
char n[48];

l = strlen(f);			// Remove C: from name (temp)
for(i=0;i<l;i++)
	n[i] = f[i+2];

printf("z");
//printf("Reading from (CD) %s\n",f);
//sprintf( debbuf, "Reading from (CD) %s", n );
//RENDER_message(debbuf);

//sprintf(n,"\\GFXFILES.GFX");



retryCD:

do	{
    fileSize = DsReadFile(n,m,0);

	if(fileSize==0)
		{
      printf("DsReadFile Error, retrying (%s)\n",n);
		DsReset();
		VSync(0);
		DsClose();
		VSync(0);
		DsInit();
		VSync(0);
		}

	}while(fileSize==0);

//printf("Bytes to read : %d\n",fileSize);

i = DsReadSync(v);
do	{
   if(1)
      {
         {
         LOAD_PutLogo();
         //RENDER_loadcycle();
         }
      if(doread++>=30)
       {
          i = DsReadSync(v);
           doread = 0;
       if(i!=-1)
          printf(" %d\n",i);
           }
        }
    else
	 {
		for(i=0;i<30;i++)
			VSync(0);
	    i = DsReadSync(v);
		if(i!=-1)
			printf("	%d\n",i);
        }

	}
	while(i>0);

if(i==-1)
	{
    printf("CD Error : PSX Failed to load file\n");
    goto retryCD;
	}

return fileSize;
}
#endif
//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////

void  LOAD_map()
   {
   s16   x,z;
   u32   *ptr;

   printf("LOAD_map\n");
   ptr   =  (u32 *)temp;

   for(z=0;z<MESH_zgridnum;z++)
      for(x=0;x<MESH_xgridnum;x++)
         {
         MESH_map[z][x] =  *ptr++;
         }
   }

void  LOAD_mapref()
   {
   s16   x,z;
   u32   *ptr;

   printf("LOAD_map\n");
   ptr   =  (u32 *)temp;

   for(z=0;z<MESH_zgridnum;z++)
      for(x=0;x<MESH_xgridnum;x++)
         {
         MESH_mapref[z][x] =  *ptr++;
         }
   }


/*
void  LOAD_getdir()
   {
   // gets a dir /s/b  file from pc
   s32   len, idxname=0, idxchar=0, f ;
   u8    *p;

   len   =  LOAD_readPCfile(temp, "c:\\360\\data\\dir.txt" );
   p  =  temp;

   for(f=0;f<len;f++)
      {
      if( (*p == 0x0d ) )
         {
         filename[ idxname ][ idxchar ] = 0;
         //next
         idxname++;
         idxchar=0;
         if( idxname >= 100 )break;
         p++;
         p++;
         }
      else
         {
         filename[ idxname ][ idxchar ] = *p;
         idxchar++;
         if( idxchar >= 100 )break;
         p++;
         }
      }
   }
*/

//load level info
/*
LOAD_readPCfile(temp, "c:\\360\\data\\models\\map1.lev" );
   {
   u8    *p, *s;
   s32   f;


   p  =  temp;

   s  = (u8*)&header;
   for(f=0;f< sizeof(LEVHEADER);f++)*s++  =  *p++;

   s  =  (u8*)MESH_norms;
   for(f=0;f< 19*500*sizeof(vec16);f++)*s++  =  *p++;

   s  =  (u8*)MESH_objcentre;
   for(f=0;f< 19*sizeof(vec16);f++)*s++   =  *p++;

   s  =  (u8*)MESH_seglink;
   for(f=0;f< 19*sizeof(LINK);f++)*s++ =  *p++;
   }
*/


void  LOAD_loadmenu()
   {
   s32   f;
   static int sel  =0;
   u8 gch[15];

   for(f=0;f<17;f++)gch[f]=' ';
   gch[sel]='>';

   if( !(SD_PadData[0].data&PAD_LU) &&
       !(SD_PadData[0].old&PAD_LU) )
		{
      if(sel)sel--;
		}
   if( !(SD_PadData[0].data&PAD_LD) &&
       !(SD_PadData[0].old&PAD_LD) )
		{
      if(sel<17)sel++;
		}

   FntPrint("360 loadmenu %d \n \n",G_cyc);
   for(f=0;f<17;f++)
      FntPrint("%c %s \n", gch[f], loaddirnames[f] );

//   if( SD_PadData[0].data&PAD_START )
//      {
//      GAMELOOP_state=GLfadeouttogame;
//      }

   if( SD_PadData[0].push&PAD_RD )
		{
      STATE.currlevel =  sel;
      LOAD_level();
      GAMELOOP_state=GLfadeouttogame;
		}
   }

u8 *eofdir;
//void  LOAD_getdir()
//   {
//   // gets a dir /s/b  file from pc
//   s32   len, idxname=0, idxchar=0, f ;
//   u8    *p;

//   p  =  (u8*)temp;

//   len   =  LOAD_readPCfile( p, "c:\\360\\data\\dirsdf.txt" );
//   p  +=  len;

//   len   =  LOAD_readPCfile( p, "c:\\360\\data\\dirtim.txt" );
//   p  +=  len;

//   len   =  LOAD_readPCfile( p, "c:\\360\\data\\dirmap.txt" );
//   p  +=  len;

//   len   =  LOAD_readPCfile( p, "c:\\360\\data\\dirbtm.txt" );
//   p  +=  len;

//   eofdir   =  p;
//   }

//////////////
// DDD  SSSS /
// D  D S    /
// D  D SSSS /
// D  D    S /
// DDD  SSSS /
//////////////


void LOAD_SetLogo()
{
                                                    //////////////
   Buff=LogoBuff;       //&                         // DDD  SSSS /
   SBuff=ScreenBuff;     //&                        // D  D S    /
   LogoFrom.x=0;                                    // D  D SSSS /
   LogoFrom.y=256;                                  // D  D    S /
   LogoFrom.w=48;                                   // DDD  SSSS /
   LogoFrom.h=1;                                    //////////////
	ScreenFrom.x=LPX;
	ScreenFrom.y=LPY;
	ScreenFrom.w=48;
	ScreenFrom.h=1;

}
// into vsync callback?
void LOAD_PutLogo()
{
int	lp;
static	int	Ind;
static	int	del;
u_short	FrX;
u_short	FrY;

	del++;
   if ((del&1))                                        //////////////
      if (Ind++==49) Ind=0;                            // DDD  SSSS /
                                                       // D  D S    /
   FrY=256+((Ind/10)*48);                              // D  D SSSS /
   FrX=(Ind%10)*48;                                    // D  D    S /
   LogoFrom.x=FrX;                                     // DDD  SSSS /
                                                       //////////////
	for (lp1=0;lp1<32;lp1++)
	{
   LogoFrom.y=FrY+lp1;                                //////////////
   StoreImage(&LogoFrom,(u32 *)Buff);                        // DDD  SSSS /
   DrawSync(0);                                       // D  D S    /
   ScreenFrom.y=LPY+lp1;                              // D  D SSSS /
   StoreImage(&ScreenFrom,(u32 *)SBuff);                     // D  D    S /
   DrawSync(0);                                       // DDD  SSSS /
                                                      //////////////
	for (lp=0;lp<48;lp++)
		if (!(Buff[lp]&0x8000)) SBuff[lp]=Buff[lp];

    LoadImage(&ScreenFrom,(u32 *)SBuff);
    DrawSync(0);
	}
}

void  LOAD_remapplayermod( s16 n )
   {
   s16   x,y, newtp;
   RECT  rect;

   switch(n)
      {
      case  7: x=8;y=0;  newtp=8;
         MESH_cbf_cabaxoff=0;
         MESH_cbf_cabayoff=0;
        break;
      case  6: x=9;y=0;  newtp=9;
         MESH_cbf_cabaxoff=64;
         MESH_cbf_cabayoff=0;
        break;
      case  5: x=8;y=1;  newtp=8;
         MESH_cbf_cabaxoff=0;
         MESH_cbf_cabayoff=128;
       break;
      case  4: x=9;y=1;  newtp=9;
         MESH_cbf_cabaxoff=64;
         MESH_cbf_cabayoff=128;
        break;
      case  3: x=8;y=2;  newtp=24;
         MESH_cbf_cabaxoff=0;
         MESH_cbf_cabayoff=256;
       break;
      case  2: x=9;y=2;  newtp=25;
         MESH_cbf_cabaxoff=64;
         MESH_cbf_cabayoff=256;
       break;
      case  1: x=8;y=3;  newtp=24;
         MESH_cbf_cabaxoff=0;
         MESH_cbf_cabayoff=384;
       break;
      case  0: x=9;y=3;  newtp=25;
         MESH_cbf_cabaxoff=64;
         MESH_cbf_cabayoff=384;
       break;

		// added by mat, 22/03/1999
      default:
      	x=9;y=3;  newtp=25;
         MESH_cbf_cabaxoff=64;
         MESH_cbf_cabayoff=384;
		printf("LOAD_remapplayermod()  n == %d\n",n);
		break;
      }

   // move

   rect.x = 8*64;
   rect.y = 0*128;
   rect.w = 63;
   rect.h = 127;

   DrawSync( 0 );
   MoveImage( &rect, x*64, y*128 );
   DrawSync( 0 );

   MESH_cbf_newtpage =  newtp;
   MESH_scanmodel( MESH_modeladdr[n], 0 ,&cbfunc);
   }

void  LOAD_tof()
   {
   u32   numitems;
   s16   i;
   s16   *ptr;
   s16   field;
   s16   subi;
   s16   id;
   s16   type;
   s16   rad;
   s16   x;
   s16   y;
   s16   z;
   s16   vx;
   s16   vz;
   s16   a;

   RACE_rpnum=0;

   ptr   =  (s16*)MESH_trackref;

   numitems =  *ptr++;
   ptr++;
   printf("numitems %lu\n", numitems );

   for(i=0;i<numitems;i++)
      {
      id    =  *ptr++;
      type  =  *ptr++;
      rad   =  *ptr++;
      x     =  *ptr++;
      y     =  *ptr++;
      z     =  *ptr++;
      vx    =  *ptr++;
      vz    =  *ptr++;

      field =  type/100;
      subi  =  type%100;
      switch(field)
         {
         case  1://startpoints
            printf("startpoint\n");
//            printf("id  %d\n", id);
//            printf("    %d\n", type);
//            printf("    %d\n", x);
//            printf("    %d\n", y);
//            printf("    %d\n", z);
//            printf("    %d\n", vx);
//            printf("    %d\n", vz);
            y  =  LOAD_findheight( x,z ) - 100;
            equ( LOAD_startpoints[ subi ], x ,y ,z );
            LOAD_startrots[ subi ]=ratan2( vx-x, vz-z );
            printf("LOAD_startrots[%d](%ld)\n", subi,LOAD_startrots[ subi ]);
            break;
         case  2://pickups
            if(subi==20)
               {
               print("too many pickups, cunt.\n");
               break;
               }
            PCK_totalnumpickups++;
            printf("pickup\n");
            y=LOAD_findheight(x,z);

            PCK_positions[subi].vx =  x;
            PCK_positions[subi].vy =  y;
            PCK_positions[subi].vz =  z;
            break;
         case  5:// fog
            printf("fog!\n");
            y=LOAD_findheight(x,z);
            a=OBJ_newobj( OTfog );
            if(a>=0)
               {
               OBJ_objects[a].p.vx  =  x<<8;
               OBJ_objects[a].p.vy  =  y<<8;
               OBJ_objects[a].p.vz  =  z<<8;
               }
            break;
         case  6://racepoints
            RACE_points[ RACE_rpnum ].vx  =  x;
            RACE_points[ RACE_rpnum ].vz  =  z;
            //printf("rp%d %d %d\n", RACE_rpnum, x, z);
            RACE_rpnum++;
            break;
         case  8://panning cam
            y=LOAD_findheight(x,z)-200;
            pancam[ CAM_numpancam ].vx=x;
            pancam[ CAM_numpancam ].vy=y;
            pancam[ CAM_numpancam ].vz=z;
            CAM_numpancam++;
            printf("panncam\n");
            break;
         default:
            printf("unknown field, cunt.\n");
            break;
         }
      }
   }

s32  LOAD_findheight( s16 x, s16 z )
   {
   s16   i;
   vec32 v0, v1;
   s32   top =+ 2000;
   s32   bot =+ 2000 + 100;

   for(i=0;i<40;i++)
      {
      equ( v0, x, top  ,z);
      equ( v1, x, bot  ,z);
      if( COL_test2( &v0, &v1 ) >=0 )
         {
         return COL_inter.vy;
         }
      top-=100;
      bot-=100;
      }
   printf("could not find height to a satisfactory level of accuracy, writing to local m.p\n");
   return   12345;
   }
