void PSX_init_start_finish_markers(void);
//PSX SPECIFIC

//#include "PSX_libs.h"

/*
typedef struct 
{
	SVECTOR		position;

	s16			index;
	s8			in_use;
	s32			owner;

	s16			no_ripples;
	s16			current_no;

}RIPPLE_CTRL_STRUCT;

typedef struct 
{
	SVECTOR		position;

	s32			velocity;
   	s16			rotation;

	u8			r;
	u8			g;
	u8			b;

	s8			in_use;
	s16			index;

	s16			radius;
	s16			rad_inc;
	s16			timer;
	s16			end_point;

}RIPPLE_SPLASH;
*/

/*
typedef struct 
{
	SVECTOR		position;
	SVECTOR		rotation;
	SVECTOR		velocity;
//	int			velocity;

	short		in_use;
	int			index;

	int			owner;
	int			obj_index;

	int			timer;

	int			total_flames;
	int			release_total;

	int		    first_flame;
	int			latest_flame;

	int			type;
	int			collision_type;

	int			no_fragments;
	
}EXPLOSION_CTRL_STRUCT;

typedef struct 
{
	SVECTOR		position;
	SVECTOR		rotation;
	SVECTOR		craft_vel;

	int			velocity;

	short		in_use;
	int			index;

	int			owner;
	int			timer;

	int			next_flame;
	int			prev_flame;

	int			size;

	int			uv_index;
	int			increment;
	int			delay;

	int			end_point;
	int			smoke_point;
	int			smoke_flag;

	u8			r;
	u8			g;
	u8			b;

	int			type;
	
}EXPLOSION_FLAME;
*/
enum
{
	ship_collision_exp,
	mesh_collision_exp,
	other_collision_exp,
};

//enum
//{
//	missile_explosion,
//	torpedo_explosion,
//	cluster_explosion,
//	fragment_explosion,
//	rocket_explosion,
//	mine_explosion,
//	ion_explosion,
//	flare_trail,
//	craft_trail,
//	smoke_fx,
//	buring_craft,
//	flame_thrower

//};			  


extern MATRIX					IDENTITY_MATRIX;


extern s32						muzzle_flash_offset_table[10][7];
extern s16						PSX_fire_uv_table[MAX_EXP_TIMS][7];
//extern RIPPLE_SPLASH			PSX_ripples[MAX_RIPPLE_SPLASHES];
//extern RIPPLE_CTRL_STRUCT		PSX_ripple_ctrls[MAX_RIPPLE_CTRL_STRUCTS];
//extern EXPLOSION_CTRL_STRUCT	PSX_expns[MAX_EXPLOSIONS];
//extern EXPLOSION_FLAME			PSX_expn_flames[MAX_EXP_FLAMES];

	
//void init_ripple_structs(void);
//void PSX_process_ripple_ctrls(void);
//void PSX_init_ripple(OBJ_STRUCT *obj_ptr);
//void PSX_process_ripples(void);

//s32 PSX_init_new_explosion(OBJ_STRUCT *obj_ptr, int explosion_type, int collision_type);
//void PSX_explosions(void);
//void init_explosion_ctrl_structs(void);
//void init_explosion_flames(void);
//void PSX_process_explosions(void);


void set_camera_matrix(void);
void set_identity_matrix(void);

//MuzzleFlash
void PSX_process_muzzle_flash(OBJ_PLAYERSTRUCT *plyr_ptr);




//NEW EXPLOSION CODE ETC....

typedef struct {

	int				index;
	char			in_use;
	char			reserved;
	char			dont_increment;

	int				owner;
	char			type;
	short			timer;
	short			delay;

	unsigned long	*next;
	unsigned long	*prev;

	short			total;
	short			used;
	
	short			release_qty;
		
	vec16			position;
	vec16			velocity;
	vec16			rotation;

	short			decceleration;

}FLAME_CTRL;

typedef struct {

	int				index;
	char			in_use;
	int				owner;

	char			type;

	short			timer;
	short			delay;
	short			increment;
	short			uv_index;
	short			smoke_point;

	unsigned long	*next;
	unsigned long	*prev;

	short			length;

	unsigned char	r;
	unsigned char	g;
	unsigned char	b;

	short			colour_decrement;

	int				tp;
	int				cl;

	vec16			position;
	vec16			velocity;
	vec16			rotation;

	short			decceleration;

}FLAME_ANIMATION;

extern FLAME_CTRL				PSX_flame_ctrls[MAX_EXPLOSIONS];
extern FLAME_ANIMATION			PSX_flames[MAX_EXP_FLAMES];
	
void PSX_init_flame_ctrl(OBJ_STRUCT *obj_ptr, char type, int collision_type);
void PSX_process_flame_ctrls(void);
void PSX_process_flame_animations(void);

void PSX_init_flame_animation(OBJ_STRUCT *obj_ptr, int type, int collision_type);
void PSX_init_all_flame_ctrls(void);

//END OF NEW EXPLOSION CODE
void PSX_make_scenic_effects_for_kam_and_co(void);


//fragments
void PSX_init_fragment(FLAME_CTRL *ptr, int type);
void PSX_process_fragment(DROPLET_STRUCT *ptr);

/*
enum {

	lava_steam,
	water_spray

};



typedef struct {
	
	int				index;
	char			in_use;
	
	vec16			origin;
	vec16			direction;

}LEVEL_EFFECT;
*/