#include <sys/types.h>
#include <libetc.h>
#include <libgte.h>
#include <libgpu.h>
#include <libgs.h>
#include <libsn.h>
#include <gtemac.h>
#include <inline_c.h>
#include <ctrller.h>
#include	<libmath.h>
#include <string.h>
#include "..\frontend.h"
#include "rand.h"
#include "..\sdlib\sdfunc.h"

#include "..\header.h"
#include "..\objects.h"
#include "..\render.h"
#include "mathpsx.h"
#include "..\sim.h"
#include "..\mesh.h"
#include "..\camera.h"
#include "..\collide.h"
#include "..\hue.h"
#include "textPSX.h"
#include "..\state.h"

typedef  struct
   {
   u8 r;
   u8 g;
   u8 b;
   }RGB;


//RGB   bdcolstop[17]= {
//   {  49,   78,   146   }, //0
//   {  49,   78,   146   }, //1
//   {  49,   78,   146   }, //2
//   {  117,  115,  178   }, //3

//   {  158,  202,  182   }, //4
//   {  158,  202,  182   }, //5
//   {  158,  202,  182   }, //6
//   {  22,   52,   43    }, //7

//   {  113,  199,  204   }, //8
//   {  113,  199,  204   }, //9
//   {  113,  199,  204   }, //10
//   {  132,  126,  108   }, //11

//   {  175,  0,    0     }, //12
//   {  175,  0,    0     }, //13
//   {  175,  0,    0     }, //14
//   {  107,  76,   148   }, //15

//   {   14,  153,  165   }};//16


RGB   bdcolstop[17]= {
            {46,77,146},   //0
            {46,77,146},   //1
            {46,77,146},   //2
            {188,76,92},   //3

            {32,32,88},    //4
            {32,32,88},    //5
            {32,32,88},    //6
            {8,11,24},     //7

            {67,97,139},   //8
            {67,97,139},   //9
            {67,97,139},   //10
            {44,28,68},    //11

            {42,4,4},      //12
            {42,4,4},      //13
            {42,4,4},      //14
            {180,108,158}, //15

            {92,92,163}};


RGB   bdcolsbot[17]= {
          {202,215,234},//0
          {202,215,234},//1
          {202,215,234},//2
          {255,219,151},//3

          {132,132,153},//4
          {132,132,153},//5
          {132,132,153},//6
          {163,225,190},//7

          {238,207,139},//8
          {238,207,139},//9
          {238,207,139},//10
          {227,243,182},//11

          {238,217,103},//12
          {238,217,103},//13
          {238,217,103},//14
          {211,182,207},//15

          {248,249,124}};//16

extern   GsOT        *ptrwot;//jof
extern   GsOT        Wotwin0[2];                    // OT header
extern   GsOT        Wotwin1[2];                    // OT header
extern   GsOT_TAG    zsorttable[2][(1<<OT_LENGTH)+100];  // Area of OT

// ? pre-calculated (32) rotation matrices for torps (Mcam)(Mobj)
//extern   GsOT           Wot[2];           // from main.c
extern	OBJ_PRS			ObjInf[10];			// from main.c
extern	int				outbuf_idx;       // from main.c
//extern	MATRIX			SIM_objmat;			// from SIM
extern   FACE_VERT   *PMod1Vert;
extern	POLY_F3		*PMod1A_F;
extern   s32         PC_Mod1A_F;
extern	POLY_F3		*PMod1A_FD;
extern   s32         PC_Mod1A_FD;
extern	POLY_FT3		*PMod1A_T;
extern   s32          PC_Mod1A_T;
extern	POLY_FT3		*PMod1A_TD;
extern   s32          PC_Mod1A_TD;

extern	POLY_G3		*PMod1A_G;
extern   s32          PC_Mod1A_G;
extern	POLY_G3		*PMod1A_GD;
extern   s32          PC_Mod1A_GD;
extern	POLY_GT3		*PMod1A_GT;
extern   s32         PC_Mod1A_GT;
extern	POLY_GT3		*PMod1A_GTD;
extern   s32         PC_Mod1A_GTD;

extern	FACE_VERT4	*PMod1Vert4;
extern	POLY_F4		*PMod1F_F;
extern   s32         PC_Mod1F_F;
extern	POLY_F4		*PMod1F_FD;
extern   s32         PC_Mod1F_FD;
extern	POLY_FT4		*PMod1F_T;
extern   s32         PC_Mod1F_T;
extern	POLY_FT4		*PMod1F_TD;
extern   s32         PC_Mod1F_TD;

extern	POLY_G4		*PMod1F_G;
extern   s32         PC_Mod1F_G;
extern	POLY_G4		*PMod1F_GD;
extern   s32         PC_Mod1F_GD;
extern	POLY_GT4		*PMod1F_GT;
extern   s32         PC_Mod1F_GT;
extern	POLY_GT4		*PMod1F_GTD;
extern   s32         PC_Mod1F_GTD;
extern   GsSPRITE    RENDER_sprite;
extern   POLY_F4     RENDER_POLYF4;
extern   POLY_FT4    RENDER_POLYFT4;

///////////////////////////////////////////////////////////////////////////////////
// 360. SmartDog PSX version started 8/6/'98
// Guilty person	: J.Coelho
//
//	rendaux.c
// misc rendering functions. Uses render.h
///////////////////////////////////////////////////////////////////////////////////
/*
void  RENDER_map()
   {
   s16   f;
   for(f=0;f<29;f++)
      {
      GsLINE   line;

      line.attribute=0;
      line.r   =0xff;
      line.g   =0xff;
      line.b   =0xff;

      line.x0  =  ( SIM_rp[f].vx>>10 ) + 100;
      line.y0  =  ( SIM_rp[f].vz>>10 ) - 80;
      line.x1  =  ( SIM_rp[f+1].vx>>10 ) + 100;
      line.y1  =  ( SIM_rp[f+1].vz>>10 ) - 80;
      GsSortLine( &line, ptrwot, 0 );
      }
   }
*/
void  RENDER_loadcycle()
   {
   outbuf_idx=GsGetActiveBuff();
   GsSetWorkBase((PACKET*)out_packet[outbuf_idx]);
   GsClearOt(0,0,&Wotwin0[outbuf_idx]);
   RENDER_printmessages();
   DrawSync(0);
   VSync(0);
   ResetGraph(1);
   GsSwapDispBuff();
   GsSortClear(0x50,0x50,0x50,&Wotwin0[outbuf_idx]);
   GsDrawOt(&Wotwin0[outbuf_idx]);
   FntFlush(-1);
   }

vec32	l0, l1;
void	RENDER_shadow( s32 ob )
	{
   POLY_FT4  polyft4;

   s32   f, c, cs, pl, z;
	int	sx0, sy0, z0;
	int	sx1, sy1, z1;
	int	sx2, sy2, z2;
	int	sx3, sy3, z3;

	vec16	sh[4];
	vec16  p[4];

   SetPolyFT4( &polyft4 );
   polyft4.u0  =  48<<2; polyft4.v0  =  192;
   polyft4.u1  =  63<<2; polyft4.v1  =  192;
   polyft4.u2  =  48<<2; polyft4.v2  =  255;
   polyft4.u3  =  63<<2; polyft4.v3  =  255;
   polyft4.tpage  =  GetTPage(0,2,640,256);
   polyft4.clut   =  GetClut(688,447);//8148;
   SetSemiTrans( &polyft4, 1 );

   polyft4.r0=255;
   polyft4.g0=255;
   polyft4.b0=255;


   equ( p[0], -120, -40, +120 );
   equ( p[1], +120, -40, +120 );
   equ( p[2], -120, -40, -120 );
   equ( p[3], +120, -40, -120 );
   /*
   vequs( &p[0], -120, -40, +120 );
   vequs( &p[1], +120, -40, +120 );
   vequs( &p[2], -120, -40, -120 );
   vequs( &p[3], +120, -40, -120 );
   */

   pl =  OBJ_objects[ ob ].owner;

	for(f=0;f<4;f++)
		{
      ApplyMatrixSV( (MATRIX*)&OBJ_players[ pl ].SIM_objmat, (SVECTOR*)&p[f], (SVECTOR*)&p[f] );//ATTN!
		p[ f ].vx	+=	OBJ_objects[ ob ].p.vx>>8;
		p[ f ].vy	+=	OBJ_objects[ ob ].p.vy>>8;
		p[ f ].vz	+=	OBJ_objects[ ob ].p.vz>>8;
		}

	for(f=0, cs=0;f<4;f++)
		{
		l0.vx	=	p[f].vx;
		l0.vy	=	p[f].vy;
		l0.vz	=	p[f].vz;

		l1.vx	=  l0.vx;
		l1.vy	=  l0.vy+300;
		l1.vz	=  l0.vz;
      c  =  COL_test2( &l0, &l1 );
		if( c>=0 )
			{
			cs++;
			sh[ f ].vx	=	COL_inter.vx;
			sh[ f ].vy	=	COL_inter.vy;
			sh[ f ].vz	=	COL_inter.vz;
			}
		}

	if( cs==4 )
		{
      // need rtp4!!
      MATH_transform( &sh[0], &sx0, &sy0, &z0 );
      MATH_transform( &sh[1], &sx1, &sy1, &z1 );
      MATH_transform( &sh[2], &sx2, &sy2, &z2 );
      MATH_transform( &sh[3], &sx3, &sy3, &z3 );

      polyft4.x0  =  (sx0*25)>>4;     polyft4.y0  =  sy0;
      polyft4.x1  =  (sx1*25)>>4;     polyft4.y1  =  sy1;
      polyft4.x2  =  (sx2*25)>>4;     polyft4.y2  =  sy2;
      polyft4.x3  =  (sx3*25)>>4;     polyft4.y3  =  sy3;
      //polyf4.r0  =  0x80;    polyf4.g0  =  0x80;  polyf4.b0  =  0x80;
      z  =     (z0>>(otzshift+1))+20;
      if( z>0 )
         GsSortPoly( &polyft4, ptrwot, z );
		}
	}

void  RENDER_backdrop()
	{
   if( (STATE.numscreens==1) )
      {
      POLY_F4  polyf4;
      s32   xoff, f, sx, tp;
      s32   yoff;

      yoff  =  (-CAM_came[CAM_c].vx>>6)+10;

      //yoff=-10;
      //yoff=1;

      SetPolyF4(&polyf4 );
      if( yoff>=0 )
         {// fill top bit
         polyf4.x0  =  -254;    polyf4.y0  =  -127;
         polyf4.x1  =  255;     polyf4.y1  =  -127;
         polyf4.x2  =  -254;    polyf4.y2  =  yoff-127;
         polyf4.x3  =  255;     polyf4.y3  =  yoff-127;
         polyf4.r0  =  bdcolstop[STATE.currlevel].r;
         polyf4.g0  =  bdcolstop[STATE.currlevel].g;
         polyf4.b0  =  bdcolstop[STATE.currlevel].b;
         GsSortPoly( &polyf4, &Wot2[outbuf_idx], 0 );
         }

         {
         // fill bottom bit
         if(RENDER_refback[STATE.currlevel]==0)
            {
            polyf4.x0  =  -255;    polyf4.y0  =  yoff;
            polyf4.x1  =  256;     polyf4.y1  =  yoff;
            polyf4.x2  =  -255;    polyf4.y2  =  +128;
            polyf4.x3  =  256;     polyf4.y3  =  +128;
            polyf4.r0  =  0;
            polyf4.g0  =  0;
            polyf4.b0  =  0;
            GsSortPoly( &polyf4, &Wot2[outbuf_idx], 0 );
            }
         else
            {//double back(ref)
            polyf4.x0  =  -255;    polyf4.y0  =  yoff+128;
            polyf4.x1  =  255;     polyf4.y1  =  yoff+128;
            polyf4.x2  =  -255;    polyf4.y2  =  +128;
            polyf4.x3  =  255;     polyf4.y3  =  +128;
            polyf4.r0  =  bdcolstop[STATE.currlevel].r;
            polyf4.g0  =  bdcolstop[STATE.currlevel].g;
            polyf4.b0  =  bdcolstop[STATE.currlevel].b;
            GsSortPoly( &polyf4, &Wot2[outbuf_idx], 0 );
            }
         }

      // xoff 0-1024
      xoff  =  (CAM_came[CAM_c].vy >>5)&1023;

      tp = -(xoff>>7);
      sx =  (xoff&127)-128;

      for(f=0;f<5;f++)
         {
         // top bitmap
         RENDER_sprite.attribute =(1<<6) | (0<<28) | (1<<24) | (0<<30);
         RENDER_sprite.x   =(f<<7)-255+(sx);
         RENDER_sprite.y   =-128+yoff;
         RENDER_sprite.w   =64;
         RENDER_sprite.h   =128;
         RENDER_sprite.tpage=28 +((tp&7)>>1);
         RENDER_sprite.u   =64*(tp&1);
         RENDER_sprite.v   =128;
         RENDER_sprite.cx  =768;
         RENDER_sprite.cy  =383;
         //RENDER_sprite.r   =128+((hue2rgb[(G_cyc>>2)&255])&255)>>1;
         //RENDER_sprite.g   =128+((hue2rgb[(G_cyc>>2)&255]>>8)&255)>>1;
         //RENDER_sprite.b   =128+((hue2rgb[(G_cyc>>2)&255]>>16)&255)>>1;
         RENDER_sprite.r   =128;
         RENDER_sprite.g   =128;
         RENDER_sprite.b   =128;
         RENDER_sprite.mx  =0;
         RENDER_sprite.my  =0;
         RENDER_sprite.scalex =8192;
         RENDER_sprite.scaley =4096;
         RENDER_sprite.rotate =0;
         GsSortSprite( &RENDER_sprite, &Wot2[outbuf_idx], 0 );
         tp++;
         }

      tp = -(xoff>>7);
      sx =  (xoff&127)-128;

      for(f=0;f<5;f++)
         {
         // bottom bitmap
         RENDER_sprite.attribute =(1<<6) | (0<<28) | (1<<24) | (0<<30);
         RENDER_sprite.x   =(f<<7)-255+(sx);
         RENDER_sprite.y   =128+yoff;
         RENDER_sprite.w   =64;
         RENDER_sprite.h   =128;
         RENDER_sprite.tpage=28 +((tp&7)>>1);
         RENDER_sprite.u   =64*(tp&1);
         RENDER_sprite.v   =128;
         RENDER_sprite.cx  =768;
         RENDER_sprite.cy  =383;
         //RENDER_sprite.r   =128+((hue2rgb[(G_cyc>>2)&255])&255)>>1;
         //RENDER_sprite.g   =128+((hue2rgb[(G_cyc>>2)&255]>>8)&255)>>1;
         //RENDER_sprite.b   =128+((hue2rgb[(G_cyc>>2)&255]>>16)&255)>>1;
         RENDER_sprite.r   =64;
         RENDER_sprite.g   =96;
         RENDER_sprite.b   =128;
         RENDER_sprite.mx  =0;
         RENDER_sprite.my  =0;
         RENDER_sprite.scalex =8192;
         RENDER_sprite.scaley =-4096;
         RENDER_sprite.rotate =0;
         if(RENDER_refback[STATE.currlevel]==1)
            GsSortSprite( &RENDER_sprite, &Wot2[outbuf_idx], 0   );
         tp++;
         }
      }
   else
      {
      POLY_G4   poly;

      SetPolyG4(&poly);

      poly.x0  =  -256;    poly.y0  =  -64;
      poly.x1  =   256;    poly.y1  =  -64;
      poly.x2  =  -256;    poly.y2  =  64;
      poly.x3  =   256;    poly.y3  =  64;
      switch(STATE.currlevel)
         {
         case  0:
         case  1:
         case  2:
            poly.r0=poly.r1=  49;   poly.r2=poly.r3=  202;
            poly.g0=poly.g1=  78;   poly.g2=poly.g3=  215;
            poly.b0=poly.b1=  146;  poly.b2=poly.b3=  234;
            break;
         case  3:
            poly.r0=poly.r1=  117;  poly.r2=poly.r3=  255;
            poly.g0=poly.g1=  115;  poly.g2=poly.g3=  219;
            poly.b0=poly.b1=  178;  poly.b2=poly.b3=  151;
            break;
         case  4:
         case  5:
         case  6:
            poly.r0=poly.r1=  158;  poly.r2=poly.r3=  132;
            poly.g0=poly.g1=  202;  poly.g2=poly.g3=  132;
            poly.b0=poly.b1=  182;  poly.b2=poly.b3=  153;
            break;
         case  7:
            poly.r0=poly.r1=  22;  poly.r2=poly.r3=  163;
            poly.g0=poly.g1=  52;  poly.g2=poly.g3=  225;
            poly.b0=poly.b1=  43;  poly.b2=poly.b3=  190;
            break;
         case  8:
         case  9:
         case 10:
            poly.r0=poly.r1=  113;  poly.r2=poly.r3=  238;
            poly.g0=poly.g1=  199;  poly.g2=poly.g3=  207;
            poly.b0=poly.b1=  204;  poly.b2=poly.b3=  139;
            break;
         case 11:
            poly.r0=poly.r1=  132;  poly.r2=poly.r3=  227;
            poly.g0=poly.g1=  126;  poly.g2=poly.g3=  243;
            poly.b0=poly.b1=  108;  poly.b2=poly.b3=  182;
            break;
         case 12:
         case 13:
         case 14:
            poly.r0=poly.r1=  175;  poly.r2=poly.r3=  238;
            poly.g0=poly.g1=    0;  poly.g2=poly.g3=  217;
            poly.b0=poly.b1=    0;  poly.b2=poly.b3=  103;
            break;
         case 15:
            poly.r0=poly.r1=  107;  poly.r2=poly.r3=  211;
            poly.g0=poly.g1=   76;  poly.g2=poly.g3=  182;
            poly.b0=poly.b1=  148;  poly.b2=poly.b3=  207;
            break;
         case 16:
            poly.r0=poly.r1=   14;  poly.r2=poly.r3=  248;
            poly.g0=poly.g1=  153;  poly.g2=poly.g3=  249;
            poly.b0=poly.b1=  165;  poly.b2=poly.b3=  124;
            break;
         }
      GsSortPoly( &poly, ptrwot, 2047 );
      }
   }



/*
void  RENDER_shadem1()
   {
   vec32 ld,n;
   vec16 light={147,-147,147};
   s32   f,i,h, np, a=0;
	u8		r, g, b;

   vapplymatrix16( &OBJ_players[0].SIM_objmat, &light, &ld );


   h  =   *MESH_modeladdr[1];
	for(f=0;f<h;f++)
		{
		u32			*mp;
		POLY_GT3		*pgt3;
		POLY_GT3		*pgt3o;

		POLY_FT3		*pft3;
		POLY_FT3		*pft3o;

		POLY_GT4		*pgt4;
		POLY_GT4		*pgt4o;

      POLY_FT4    *pft4;
      POLY_FT4    *pft4o;

		u32	PolyBufferSize;
      np =  0;
      mp =  MESH_modeladdr[1];
		mp++;
		PolyBufferSize=*mp++;
		mp++;
		mp	+=	34*f;//(f<<5)+f+f

		mp++;

		PMod1A_F=(POLY_F3 *)(u_long)((*mp++));
		PC_Mod1A_F=*mp++;
		PMod1A_FD=(POLY_F3 *)(u_long)((*mp++) );
		PC_Mod1A_FD=*mp++;
		PMod1A_T=(POLY_FT3 *)(u_long)((*mp++) );
		PC_Mod1A_T=*mp++;
		PMod1A_TD=(POLY_FT3 *)(u_long)((*mp++) );
		PC_Mod1A_TD=*mp++;

		PMod1A_G=(POLY_G3 *)(u_long)((*mp++) );
		PC_Mod1A_G=*mp++;
		PMod1A_GD=(POLY_G3 *)(u_long)((*mp++) );
		PC_Mod1A_GD=*mp++;
		PMod1A_GT=(POLY_GT3 *)(u_long)((*mp++) );
		PC_Mod1A_GT=*mp++;
		PMod1A_GTD=(POLY_GT3 *)(u_long)((*mp++) );
		PC_Mod1A_GTD=*mp++;

		mp++;

		PMod1F_F=(POLY_F4 *)(u_long)((*mp++) );
		PC_Mod1F_F=*mp++;
		PMod1F_FD=(POLY_F4 *)(u_long)((*mp++) );
		PC_Mod1F_FD=*mp++;
		PMod1F_T=(POLY_FT4 *)(u_long)((*mp++) );
		PC_Mod1F_T=*mp++;
		PMod1F_TD=(POLY_FT4 *)(u_long)((*mp++) );
		PC_Mod1F_TD=*mp++;

		PMod1F_G=(POLY_G4 *)(u_long)((*mp++) );
		PC_Mod1F_G=*mp++;
		PMod1F_GD=(POLY_G4 *)(u_long)((*mp++) );
		PC_Mod1F_GD=*mp++;
		PMod1F_GT=(POLY_GT4 *)(u_long)((*mp++) );
		PC_Mod1F_GT=*mp++;
		PMod1F_GTD=(POLY_GT4 *)(u_long)((*mp++) );
		PC_Mod1F_GTD=*mp++;

      np =  0;

      for(i=0;i<PC_Mod1A_F;i++)np++;
      for(i=0;i<PC_Mod1A_FD;i++)np++;
      //for(i=0;i<PC_Mod1A_T;i++)np++;
		pft3	=	PMod1A_T;
		pft3o	=	(POLY_FT3 *)((u_long)PMod1A_T+PolyBufferSize);
      r=128;g=128;b=128;
		for(i=0;i<PC_Mod1A_T;i++)
			{
         n.vx  =  mod1norm[f][np].vx;n.vy  =  mod1norm[f][np].vy; n.vz  =  mod1norm[f][np].vz;
         a     =  n.vx*ld.vx + n.vy*ld.vy + n.vz*ld.vz;
         a>>=14;if(a<0)a=0;a+=64;if(a>255)a=255;

         pft3->r0 =a;pft3->g0 =a;pft3->b0 =a;
			pft3++;

         pft3o->r0   =a;pft3o->g0   =a;pft3o->b0   =a;
			pft3o++;
         np++;
			}

      for(i=0;i<PC_Mod1A_TD;i++)np++;

      for(i=0;i<PC_Mod1A_G;i++)np++;
      for(i=0;i<PC_Mod1A_GD;i++)np++;
      //for(i=0;i<PC_Mod1A_GT;i++)np++;
		pgt3	=	PMod1A_GT;
		pgt3o	=	(POLY_GT3 *)((u_long)PMod1A_GT+PolyBufferSize);
      r=128;g=128;b=128;
		for(i=0;i<PC_Mod1A_GT;i++)
			{
         pgt3->r0 =a;pgt3->g0 =a;pgt3->b0 =a;
         pgt3->r1 =a;pgt3->g1 =a;pgt3->b1 =a;
         pgt3->r2 =a;pgt3->g2 =a;pgt3->b2 =a;
			pgt3++;

         pgt3o->r0   =a;pgt3o->g0   =a;pgt3o->b0   =a;
         pgt3o->r1   =a;pgt3o->g1   =a;pgt3o->b1   =a;
         pgt3o->r2   =a;pgt3o->g2   =a;pgt3o->b2   =a;
			pgt3o++;
         np++;
			}

      for(i=0;i<PC_Mod1A_GTD;i++)np++;

      for(i=0;i<PC_Mod1F_F;i++)np++;
      for(i=0;i<PC_Mod1F_FD;i++)np++;
      //for(i=0;i<PC_Mod1F_T;i++)np++;
      pft4  =  PMod1F_T;
      pft4o =  (POLY_FT4 *)((u_long)PMod1F_T+PolyBufferSize);
      r=128;g=128;b=128;
      for(i=0;i<PC_Mod1F_T;i++)
			{
         n.vx  =  mod1norm[f][np].vx;n.vy  =  mod1norm[f][np].vy; n.vz  =  mod1norm[f][np].vz;
         a     =  n.vx*ld.vx + n.vy*ld.vy + n.vz*ld.vz;
         a>>=14;if(a<0)a=0;a+=64;if(a>255)a=255;

         pft4->r0 =a;pft4->g0 =a;pft4->b0 =a;
         pft4++;

         pft4o->r0   =a;pft4o->g0   =a;pft4o->b0   =a;
         pft4o++;
         np++;
			}
      for(i=0;i<PC_Mod1F_TD;i++)np++;

      for(i=0;i<PC_Mod1F_G;i++)np++;
      for(i=0;i<PC_Mod1F_GD;i++)np++;

      //for(i=0;i<PC_Mod1F_GT;i++)np++;
		pgt4	=	PMod1F_GT;
		pgt4o	=	(POLY_GT4 *)((u_long)PMod1F_GT+PolyBufferSize);
      r=128;g=128;b=128;
		for(i=0;i<PC_Mod1F_GT;i++)
			{
         pgt4->r0 =a;pgt4->g0 =a;pgt4->b0 =a;
         pgt4->r1 =a;pgt4->g1 =a;pgt4->b1 =a;
         pgt4->r2 =a;pgt4->g2 =a;pgt4->b2 =a;
         pgt4->r3 =a;pgt4->g3 =a;pgt4->b3 =a;
			pgt4++;

         pgt4o->r0   =a;pgt4o->g0   =a;pgt4o->b0   =a;
         pgt4o->r1   =a;pgt4o->g1   =a;pgt4o->b1   =a;
         pgt4o->r2   =a;pgt4o->g2   =a;pgt4o->b2   =a;
         pgt4o->r3   =a;pgt4o->g3   =a;pgt4o->b3   =a;
			pgt4o++;
         np++;
			}

      for(i=0;i<PC_Mod1F_GTD;i++)np++;
		}
   }
*/
void  RENDER_sp1()
   {
   u8 c  =  (G_cyc&255)>>1;

   RENDER_sprite.attribute =(1<<28) | (0<<24) | (1<<30);
   RENDER_sprite.x   =0;
   RENDER_sprite.y   =50;
   RENDER_sprite.w   =32;
   RENDER_sprite.h   =32;
   RENDER_sprite.tpage=25;
   RENDER_sprite.u   =0;
   RENDER_sprite.v   =64;
   RENDER_sprite.cx  =512;
   RENDER_sprite.cy  =510;
   RENDER_sprite.r =c;//lil endian!
   RENDER_sprite.g =c;
   RENDER_sprite.b =c;
   RENDER_sprite.mx  =32;
   RENDER_sprite.my  =32;
   RENDER_sprite.scalex =4096<<1;
   RENDER_sprite.scaley =4096<<1;
   RENDER_sprite.rotate =0;
   GsSortSprite( &RENDER_sprite, ptrwot, 1 );


    c  =  (255-(G_cyc&255))>>1;
   RENDER_sprite.attribute =(1<<28) | (0<<24) | (1<<30);
   RENDER_sprite.x   =0;
   RENDER_sprite.y   =50;
   RENDER_sprite.w   =32;
   RENDER_sprite.h   =32;
   RENDER_sprite.tpage=25;
   RENDER_sprite.u   =32;
   RENDER_sprite.v   =64;
   RENDER_sprite.cx  =512;
   RENDER_sprite.cy  =511;
   RENDER_sprite.r =c;//lil endian!
   RENDER_sprite.g =c;
   RENDER_sprite.b =c;
   RENDER_sprite.mx  =32;
   RENDER_sprite.my  =32;
   RENDER_sprite.scalex =4096<<1;
   RENDER_sprite.scaley =4096<<1;
   RENDER_sprite.rotate =0;
   GsSortSprite( &RENDER_sprite, ptrwot, 0 );

   }







// Added by mat 4 transparent lines

void RENDER_transLines()
{
#if 0


// Just do solid lines first

LINE_F2 line;
int i;
DR_TPAGE semiTrans;


setLineF2(&line);

line.r0 = 0;
line.g0 = 255;
line.b0 = 0;

for(i=0;i<40;i++)
	{
    line.x0 = i-20;
    line.y0 = -90;
    line.x1 = i-20;
    line.y1 = 0;

    GsSortPoly(&line, ptrwot, 0);
    }

//extern void SetDrawTPage(DR_TPAGE *p, int dfe, int dtd, int tpage);


//								 15bit,abr,0,0
setDrawTPage(&semiTrans,1,0,GetTPage(2,1,  640,0));

//setSemiTrans(&line,0);	 // 0.5 bk + 0.5 fr





for(i=0;i<40;i++)
	{

    line.x0 = i-20;
    line.y0 = 0;
    line.x1 = i-20;
    line.y1 = 90;

    GsSortPoly(&line, ptrwot, 0);

   GsSortPoly(&semiTrans, ptrwot, 0);
    }



#endif


#if 1



POLY_FT4 sline;
int i,j;
static int tbase = 0;

SetPolyFT4(&sline);


sline.r0 = 0;
sline.g0 = 64;
sline.b0 = 0;

sline.u0 = sline.u1 = sline.u2 = sline.u3 = 0;
sline.v0 = sline.v1 = sline.v2 = sline.v3 = 0;

//sline.clut = getClut(640,0);		// dont need to, 15-bit direct mode
sline.tpage = getTPage(2,0,640,0);  // 0.5+0.5

setSemiTrans(&sline,1);

sline.y0 = sline.y1 = -90;
sline.y2 = sline.y3 = sline.y0 + 8;

for(j=0;j<20;j++){
for(i=0;i<20;i++)
	{
    sline.x0 = (i*8)-80 +(SD_Sin((j+tbase)<<12)>>12);
//    sline.y0 = -90;

    sline.x2 = (i*8)-80 +(SD_Sin((j+tbase+1)<<12)>>12);
//    sline.y2 = 90;

    sline.x1 = sline.x0 + 1;
//    sline.y1 = sline.y0;

    sline.x3 = sline.x2 + 1;
//    sline.y3 = sline.y2;

    GsSortPoly(&sline, ptrwot, 0);

    }

    sline.y0 += 8;
    sline.y1 += 8;
    sline.y2 += 8;
    sline.y3 += 8;
}

tbase--;

#endif
}


u8    messages[9][128];
u16   messtime[8] ={0,0,0,0,0,0,0,0 };
void  RENDER_scrollmess();

extern void  TEXT_prstr(u8* pstr, u8,u8,u8);
extern s16   TEXT_x;
extern s16   TEXT_y;

void  RENDER_printmessages()
   {

   s16   f;
   TEXT_cursor( -236, -120 );
   for(f=0;f<8;f++)
      {
      if(messtime[f])
         {
         TEXT_prstr(messages[f], 128,200,100);
         //FntPrint("%s\n", messages[f] );
         messtime[f]--;
         if(messtime[f]==0)
            {
            RENDER_scrollmess();
            f--;
            }
         }
      }
   }

void  RENDER_message( u8* string )
   {
   s16   f;
   for(f=0;f<8;f++)if(messtime[f]==0)break;
   if(f==8)
      {
      RENDER_scrollmess();
      f--;
      }
   strncpy( messages[f], string, strlen(string) );
   messages[f][ strlen(string) ]=0;
   messtime[f] =  200;
   }

void  RENDER_scrollmess()
   {
   s16   f, g;
   for(f=0;f<7;f++)
      {
      for(g=0;g<128;g++)
         {
         messages[f][g] = messages[f+1][g];
         }
      messtime[f] = messtime[f+1];
      }
   messtime[7]=0;
   }

/*
void  RENDER_dynamo()
   {
   s16   offx[9]={0,0,1,1,1,0,-1,-1,-1};
   s16   offz[9]={0,1,1,0,-1,-1,-1,0,1};

   u32   *pmod ;
   s32   gx, gz,ggx, ggz, lx, lz, ly, dis;
   u32   *pface, nface;
   vec16 *pvert;
   u32   f, g, t;
   u16   idxv0, idxv1, idxv2, idxv3;
   vec32 v;

   lx =  OBJ_objects[0].p.vx>>8;
   ly =  OBJ_objects[0].p.vy>>8;
   lz =  OBJ_objects[0].p.vz>>8;

   gx  =  ((lx+32768)*20)>>16;
   gz  =  ((-lz+32768)*20)>>16;

   for(g=0;g<9;g++)
   {
   pmod =  MESH_modeladdr[0];

   pmod+=2;
   pvert =  (vec16*)*pmod;
   pmod+=4;

   ggx = gx+offx[g];
   ggz = gz+offz[g];

   if( (ggx>=0) && (ggx<20) && (ggz>=0) && (ggz<20) )
   if( MESH_map[ggz][ggx] !=0xffffffff )

   {
   pmod += 35*MESH_map[ggz][ggx];

   //F3

   pface =  *pmod++;
   nface =  *pmod++;
   //printf("%d\n",nface );

   //FD3
   pface =  *pmod++;
   nface =  *pmod++;
   //printf("%d\n",nface );

   //T3
   pface =  *pmod++;
   nface =  *pmod++;
   //for(f=0;f<nface;f++)
   for(f=0;f<1;f++)
      {
      idxv0  =  *((u16*)pface+0);
      idxv1  =  *((u16*)pface+1);
      idxv2  =  *((u16*)pface+2);

      /////////////////////////////////////
      v.vx  =  (( pvert[ idxv0 ].vx +
                  pvert[ idxv1 ].vx )>>1)-lx;

      v.vy  =  (( pvert[ idxv0 ].vy +
                  pvert[ idxv1 ].vy )>>1)-ly;

      v.vz  =  (( pvert[ idxv0 ].vz +
                  pvert[ idxv1 ].vz )>>1)-lz;


      dis   =  vqlen( v.vy, v.vx, v.vz)>>4;
      dis   =  255-dis;
      if(dis<0)dis=0;

      *(pface+5) &= 0xfe000000;
      *(pface+5) += dis+(dis<<8)+(dis<<16);
      /////////////////////////////////////

      pface+=6;
      }

   //printf("%d\n",nface );

   //TD3
   pface =  *pmod++;
   nface =  *pmod++;
   for(f=0;f<nface;f++)
      {
      idxv0  =  *((u16*)pface)+0;
      idxv1  =  *((u16*)pface)+1;
      idxv2  =  *((u16*)pface)+2;

      /////////////////////////////////////
      v.vx  =  (( pvert[ idxv0 ].vx +
                  pvert[ idxv1 ].vx )>>1)-lx;

      v.vy  =  (( pvert[ idxv0 ].vy +
                  pvert[ idxv1 ].vy )>>1)-ly;

      v.vz  =  (( pvert[ idxv0 ].vz +
                  pvert[ idxv1 ].vz )>>1)-lz;


      dis   =  vqlen( v.vx, v.vy, v.vz)>>4;
      dis   =  255-dis;
      if(dis<0)dis=0;

      *(pface+5) &= 0xfeffff00;
      *(pface+5) += dis;
      /////////////////////////////////////

      pface+=6;
      }
   //printf("%d\n",nface );

   //GF3
   pface =  *pmod++;
   nface =  *pmod++;
   //printf("%d\n",nface );

   //GFD3
   pface =  *pmod++;
   nface =  *pmod++;
   //printf("%d\n",nface );

   //GT3
   pface =  *pmod++;
   nface =  *pmod++;
   for(f=0;f<nface;f++)
      {
      idxv0  =  *((u16*)pface)+0;
      idxv1  =  *((u16*)pface)+1;
      idxv2  =  *((u16*)pface)+2;

      /////////////////////////////////////
      v.vx  =  pvert[ idxv0 ].vx-lx;
      v.vy  =  pvert[ idxv0 ].vy-ly;
      v.vz  =  pvert[ idxv0 ].vz-lz;

      dis   =  vqlen( v.vx, v.vy, v.vz)>>4;
      dis   =  255-dis;
      if(dis<0)dis=0;

      *(pface+5) &= 0xfeffff00;
      *(pface+5) += dis;
      /////////////////////////////////////

      /////////////////////////////////////

      v.vx  =  pvert[ idxv1 ].vx-lx;
      v.vy  =  pvert[ idxv1 ].vy-ly;
      v.vz  =  pvert[ idxv1 ].vz-lz;

      dis   =  vqlen( v.vx, v.vy, v.vz)>>4;
      dis   =  255-dis;
      if(dis<0)dis=0;

      *(pface+6) &= 0xfeffff00;
      *(pface+6) += dis;
      /////////////////////////////////////

      /////////////////////////////////////
      v.vx  =  pvert[ idxv2 ].vx-lx;
      v.vy  =  pvert[ idxv2 ].vy-ly;
      v.vz  =  pvert[ idxv2 ].vz-lz;

      dis   =  vqlen( v.vy, v.vx, v.vz)>>4;
      dis   =  255-dis;
      if(dis<0)dis=0;

      *(pface+7) &= 0xfeffff00;
      *(pface+7) += dis;
      /////////////////////////////////////

      pface+=8;
      }

   //printf("%d\n",nface );

   //GTD3
   pface =  *pmod++;
   nface =  *pmod++;
   for(f=0;f<nface;f++)
      {
      idxv0  =  *((u16*)pface)+0;
      idxv1  =  *((u16*)pface)+1;
      idxv2  =  *((u16*)pface)+2;

      /////////////////////////////////////
      v.vx  =  pvert[ idxv0 ].vx-lx;
      v.vy  =  pvert[ idxv0 ].vy-ly;
      v.vz  =  pvert[ idxv0 ].vz-lz;

      dis   =  vqlen( v.vx, v.vy, v.vz)>>4;
      dis   =  255-dis;
      if(dis<0)dis=0;

      *(pface+5) &= 0xfeffff00;
      *(pface+5) += dis;
      /////////////////////////////////////

      /////////////////////////////////////

      v.vx  =  pvert[ idxv1 ].vx-lx;
      v.vy  =  pvert[ idxv1 ].vy-ly;
      v.vz  =  pvert[ idxv1 ].vz-lz;

      dis   =  vqlen( v.vx, v.vy, v.vz)>>4;
      dis   =  255-dis;
      if(dis<0)dis=0;

      *(pface+6) &= 0xffffff00;
      *(pface+6) += dis;
      /////////////////////////////////////

      /////////////////////////////////////
      v.vx  =  pvert[ idxv2 ].vx-lx;
      v.vy  =  pvert[ idxv2 ].vy-ly;
      v.vz  =  pvert[ idxv2 ].vz-lz;

      dis   =  vqlen( v.vy, v.vx, v.vz)>>4;
      dis   =  255-dis;
      if(dis<0)dis=0;

      *(pface+7) &= 0xffffff00;
      *(pface+7) += dis;
      /////////////////////////////////////

      pface+=8;
      }
   //printf("%d\n",nface );

   //F4
   pface =  *pmod++;
   nface =  *pmod++;
   //printf("%d\n",nface );

   //FD4
   pface =  *pmod++;
   nface =  *pmod++;
   //printf("%d\n",nface );

   //T4
   pface =  *pmod++;
   nface =  *pmod++;
   for(f=0;f<nface;f++)
      {
      idxv0  =  *((u16*)pface+0);
      idxv1  =  *((u16*)pface+1);
      idxv2  =  *((u16*)pface+2);
      idxv3  =  *((u16*)pface+3);

      /////////////////////////////////////
      v.vx  =  (( pvert[ idxv0 ].vx +
                  pvert[ idxv1 ].vx +
                  pvert[ idxv2 ].vx +
                  pvert[ idxv3 ].vx )>>2)-lx;
      v.vy  =  (( pvert[ idxv0 ].vy +
                  pvert[ idxv1 ].vy +
                  pvert[ idxv2 ].vy +
                  pvert[ idxv3 ].vy )>>2)-ly;
      v.vz  =  (( pvert[ idxv0 ].vz +
                  pvert[ idxv1 ].vz +
                  pvert[ idxv2 ].vz +
                  pvert[ idxv3 ].vz )>>2)-lz;


      dis   =  vqlen( v.vy, v.vx, v.vz)>>4;
      dis   =  255-dis;
      if(dis<0)dis=0;

      *(pface+6) &= 0xfe000000;
      *(pface+6) += dis+(dis<<8)+(dis<<16);
      /////////////////////////////////////

      pface+=7;
      }
   //printf("%d\n",nface );

   //TD4
   pface =  *pmod++;
   nface =  *pmod++;
   for(f=0;f<nface;f++)
      {
      idxv0  =  *((u16*)pface)+0;
      idxv1  =  *((u16*)pface)+1;
      idxv2  =  *((u16*)pface)+2;
      idxv3  =  *((u16*)pface)+3;

      /////////////////////////////////////
      v.vx  =  (( pvert[ idxv0 ].vx +
                  pvert[ idxv1 ].vx +
                  pvert[ idxv2 ].vx +
                  pvert[ idxv3 ].vx )>>2)-lx;
      v.vy  =  (( pvert[ idxv0 ].vy +
                  pvert[ idxv1 ].vy +
                  pvert[ idxv2 ].vy +
                  pvert[ idxv3 ].vy )>>2)-ly;
      v.vz  =  (( pvert[ idxv0 ].vz +
                  pvert[ idxv1 ].vz +
                  pvert[ idxv2 ].vz +
                  pvert[ idxv3 ].vz )>>2)-lz;


      dis   =  vqlen( v.vy, v.vx, v.vz)>>4;
      dis   =  255-dis;
      if(dis<0)dis=0;

      *(pface+6) &= 0xfeffff00;
      *(pface+6) += dis;
      /////////////////////////////////////

      pface+=7;
      }
   //printf("%d\n",nface );

   //GF4
   pface =  *pmod++;
   nface =  *pmod++;
   //printf("%d\n",nface );
   for(f=0;f<nface;f++)
      {
      idxv0  =  *((u16*)pface)+0;
      idxv1  =  *((u16*)pface)+1;
      idxv2  =  *((u16*)pface)+2;
      idxv3  =  *((u16*)pface)+3;

      /////////////////////////////////////
      v.vx  =  pvert[ idxv0 ].vx-lx;
      v.vy  =  pvert[ idxv0 ].vy-ly;
      v.vz  =  pvert[ idxv0 ].vz-lz;

      dis   =  vqlen( v.vy, v.vx, v.vz)>>4;
      dis   =  255-dis;
      if(dis<0)dis=0;

      *(pface+2) &= 0xfeffff00;
      *(pface+2) += dis;
      /////////////////////////////////////

      /////////////////////////////////////

      v.vx  =  pvert[ idxv1 ].vx-lx;
      v.vy  =  pvert[ idxv1 ].vy-ly;
      v.vz  =  pvert[ idxv1 ].vz-lz;

      dis   =  vqlen( v.vy, v.vx, v.vz)>>4;
      dis   =  255-dis;
      if(dis<0)dis=0;

      *(pface+3) &= 0xffffff00;
      *(pface+3) += dis;
      /////////////////////////////////////

      /////////////////////////////////////
      v.vx  =  pvert[ idxv2 ].vx-lx;
      v.vy  =  pvert[ idxv2 ].vy-ly;
      v.vz  =  pvert[ idxv2 ].vz-lz;

      dis   =  vqlen( v.vy, v.vx, v.vz)>>4;
      dis   =  255-dis;
      if(dis<0)dis=0;

      *(pface+4) &= 0xffffff00;
      *(pface+4) += dis;
      /////////////////////////////////////

      /////////////////////////////////////
      v.vx  =  pvert[ idxv3 ].vx-lx;
      v.vy  =  pvert[ idxv3 ].vy-ly;
      v.vz  =  pvert[ idxv3 ].vz-lz;

      dis   =  vqlen( v.vy, v.vx, v.vz)>>4;
      dis   =  255-dis;
      if(dis<0)dis=0;

      *(pface+5) &= 0xffffff00;
      *(pface+5) += dis;
      /////////////////////////////////////

      pface+=7;
      }


   //GFD4
   pface =  *pmod++;
   nface =  *pmod++;
   for(f=0;f<nface;f++)
      {
      idxv0  =  *((u16*)pface)+0;
      idxv1  =  *((u16*)pface)+1;
      idxv2  =  *((u16*)pface)+2;
      idxv3  =  *((u16*)pface)+3;

      /////////////////////////////////////
      v.vx  =  pvert[ idxv0 ].vx-lx;
      v.vy  =  pvert[ idxv0 ].vy-ly;
      v.vz  =  pvert[ idxv0 ].vz-lz;

      dis   =  vqlen( v.vy, v.vx, v.vz)>>4;
      dis   =  255-dis;
      if(dis<0)dis=0;

      *(pface+2) &= 0xfeffff00;
      *(pface+2) += dis;
      /////////////////////////////////////

      /////////////////////////////////////

      v.vx  =  pvert[ idxv1 ].vx-lx;
      v.vy  =  pvert[ idxv1 ].vy-ly;
      v.vz  =  pvert[ idxv1 ].vz-lz;

      dis   =  vqlen( v.vy, v.vx, v.vz)>>4;
      dis   =  255-dis;
      if(dis<0)dis=0;

      *(pface+3) &= 0xffffff00;
      *(pface+3) += dis;
      /////////////////////////////////////

      /////////////////////////////////////
      v.vx  =  pvert[ idxv2 ].vx-lx;
      v.vy  =  pvert[ idxv2 ].vy-ly;
      v.vz  =  pvert[ idxv2 ].vz-lz;

      dis   =  vqlen( v.vy, v.vx, v.vz)>>4;
      dis   =  255-dis;
      if(dis<0)dis=0;

      *(pface+4) &= 0xffffff00;
      *(pface+4) += dis;
      /////////////////////////////////////

      /////////////////////////////////////
      v.vx  =  pvert[ idxv3 ].vx-lx;
      v.vy  =  pvert[ idxv3 ].vy-ly;
      v.vz  =  pvert[ idxv3 ].vz-lz;

      dis   =  vqlen( v.vy, v.vx, v.vz)>>4;
      dis   =  255-dis;
      if(dis<0)dis=0;

      *(pface+5) &= 0xffffff00;
      *(pface+5) += dis;
      /////////////////////////////////////

      pface+=7;
      }
   //printf("%d\n",nface );

   //GT4
   pface =  *pmod++;
   nface =  *pmod++;
   for(f=0;f<nface;f++)
      {
      idxv0  =  *((u16*)pface)+0;
      idxv1  =  *((u16*)pface)+1;
      idxv2  =  *((u16*)pface)+2;
      idxv3  =  *((u16*)pface)+3;

      /////////////////////////////////////
      v.vx  =  pvert[ idxv0 ].vx-lx;
      v.vy  =  pvert[ idxv0 ].vy-ly;
      v.vz  =  pvert[ idxv0 ].vz-lz;

      dis   =  vqlen( v.vy, v.vx, v.vz)>>4;
      dis   =  255-dis;
      if(dis<0)dis=0;

      *(pface+6) &= 0xfeffff00;
      *(pface+6) += dis;
      /////////////////////////////////////

      /////////////////////////////////////

      v.vx  =  pvert[ idxv1 ].vx-lx;
      v.vy  =  pvert[ idxv1 ].vy-ly;
      v.vz  =  pvert[ idxv1 ].vz-lz;

      dis   =  vqlen( v.vy, v.vx, v.vz)>>4;
      dis   =  255-dis;
      if(dis<0)dis=0;

      *(pface+7) &= 0xffffff00;
      *(pface+7) += dis;
      /////////////////////////////////////

      /////////////////////////////////////
      v.vx  =  pvert[ idxv2 ].vx-lx;
      v.vy  =  pvert[ idxv2 ].vy-ly;
      v.vz  =  pvert[ idxv2 ].vz-lz;

      dis   =  vqlen( v.vy, v.vx, v.vz)>>4;
      dis   =  255-dis;
      if(dis<0)dis=0;

      *(pface+8) &= 0xffffff00;
      *(pface+8) += dis;
      /////////////////////////////////////

      /////////////////////////////////////
      v.vx  =  pvert[ idxv3 ].vx-lx;
      v.vy  =  pvert[ idxv3 ].vy-ly;
      v.vz  =  pvert[ idxv3 ].vz-lz;

      dis   =  vqlen( v.vy, v.vx, v.vz)>>4;
      dis   =  255-dis;
      if(dis<0)dis=0;

      *(pface+9) &= 0xffffff00;
      *(pface+9) += dis;
      /////////////////////////////////////

      pface+=10;
      }
   //printf("%d\n",nface );

   //GTD4
   pface =  *pmod++;
   nface =  *pmod++;
   //printf("%d\n",nface );

   }
   }
   }
  */

#if 0
void  RENDER_normdeb()
   {
   u32   *pmod ;
   s32   gx, gz,ggx, ggz, lx, lz, ly, dis;
   u32   *pface, nface;
   vec16 *pvert;
   vec16 norm;
   u32   f, g, t;
   u16   idxv0, idxv1, idxv2, idxv3;
   vec32 v0,v1;
   vec32 d0,d1;
   u32   *pcolmod;
   u32   ntrigcol;
   u32   nquadcol;

   u32   *pcface;
   vec16   *pcnorm;

   lx =  OBJ_objects[0].p.vx>>8;
   ly =  OBJ_objects[0].p.vy>>8;
   lz =  OBJ_objects[0].p.vz>>8;

   gx  =  ((lx+32768)*20)>>16;
   gz  =  ((-lz+32768)*20)>>16;

   pmod =  MESH_modeladdr[0];
   pmod+=2;
   pvert =  (vec16*)*pmod;
   pmod+=4;

   ggx = gx;
   ggz = gz;

   if( (ggx>=0) && (ggx<20) && (ggz>=0) && (ggz<20) )
   if( MESH_map[ggz][ggx] !=0xffffffff )
      {

      pmod += 35*MESH_map[ggz][ggx];
      // pointer at tri info for obj

      pmod  += 32;
      pcolmod     =  *pmod++;
      ntrigcol    =  *pmod++;
      nquadcol    =  *pmod;

      for( f=0;f<ntrigcol;f++)
         {
         pcface   =  *pcolmod++;
         //pcnorm   =  ((*pcolmod++)&0xffffff)|0x80000000;
         pcnorm   =  *pcolmod++;


         idxv0  =  *((u16*)pcface+0);
         idxv1  =  *((u16*)pcface+1);
         idxv2  =  *((u16*)pcface+2);

         norm.vx  =  *((s16*)pcnorm+0);
         norm.vy  =  *((s16*)pcnorm+1);
         norm.vz  =  *((s16*)pcnorm+2);
         //printf( "normptr %d\n", (u32)pcface - (u32)MESH_modeladdr[0] );
//printf("normx %d\n", norm.vx);
//printf("normy %d\n", norm.vy);
//printf("normz %d\n", norm.vz);
         // got norm and points
         v0.vx  =  (pvert[ idxv0 ].vx + pvert[ idxv1 ].vx + pvert[ idxv2 ].vx )/3;
         v0.vy  =  (pvert[ idxv0 ].vy + pvert[ idxv1 ].vy + pvert[ idxv2 ].vy )/3;
         v0.vz  =  (pvert[ idxv0 ].vz + pvert[ idxv1 ].vz + pvert[ idxv2 ].vz )/3;
         v1.vx =  v0.vx +  -norm.vx;
         v1.vy =  v0.vy +  -norm.vy;
         v1.vz =  v0.vz +  -norm.vz;

         GPU_3dline( &v0, &v1, 25,0,255 );

         /*
         d0.vx =  pvert[ idxv1 ].vx - pvert[ idxv0 ].vx;
         d0.vy =  pvert[ idxv1 ].vy - pvert[ idxv0 ].vy;
         d0.vz =  pvert[ idxv1 ].vz - pvert[ idxv0 ].vz;

         d1.vx =  pvert[ idxv2 ].vx - pvert[ idxv1 ].vx;
         d1.vy =  pvert[ idxv2 ].vy - pvert[ idxv1 ].vy;
         d1.vz =  pvert[ idxv2 ].vz - pvert[ idxv1 ].vz;

         OuterProduct0( &d0, &d1, &v1 );
         v1.vx  = v0.vx+(-v1.vx>>11) ;
         v1.vy  = v0.vy+(-v1.vy>>11) ;
         v1.vz  = v0.vz+(-v1.vz>>11) ;

         GPU_3dline( &v0, &v1, 255,0,0 );
         */
         }

      for( f=0;f<nquadcol;f++)
         {
         pcface   =  *pcolmod++;
         pcnorm   =  ((*pcolmod++)&0xffffff)|0x80000000;


         idxv0  =  *((u16*)pcface+0);
         idxv1  =  *((u16*)pcface+1);
         idxv2  =  *((u16*)pcface+2);
         idxv3  =  *((u16*)pcface+3);

         norm.vx  =  *((u16*)pcnorm+0);
         norm.vy  =  *((u16*)pcnorm+1);
         norm.vz  =  *((u16*)pcnorm+2);
         //printf( "normptr %d\n", (u32)pcface - (u32)MESH_modeladdr[0] );

         // got norm and points
         v0.vx  =  (pvert[ idxv0 ].vx + pvert[ idxv1 ].vx + pvert[ idxv2 ].vx + pvert[ idxv3 ].vx)>>2;
         v0.vy  =  (pvert[ idxv0 ].vy + pvert[ idxv1 ].vy + pvert[ idxv2 ].vy + pvert[ idxv3 ].vy)>>2;
         v0.vz  =  (pvert[ idxv0 ].vz + pvert[ idxv1 ].vz + pvert[ idxv2 ].vz + pvert[ idxv3 ].vz)>>2;
         v1.vx =  v0.vx +  -norm.vx;
         v1.vy =  v0.vy +  -norm.vy;
         v1.vz =  v0.vz +  -norm.vz;

         GPU_3dline( &v0, &v1, 25,0,255 );


         d0.vx =  pvert[ idxv1 ].vx - pvert[ idxv0 ].vx;
         d0.vy =  pvert[ idxv1 ].vy - pvert[ idxv0 ].vy;
         d0.vz =  pvert[ idxv1 ].vz - pvert[ idxv0 ].vz;

         d1.vx =  pvert[ idxv2 ].vx - pvert[ idxv1 ].vx;
         d1.vy =  pvert[ idxv2 ].vy - pvert[ idxv1 ].vy;
         d1.vz =  pvert[ idxv2 ].vz - pvert[ idxv1 ].vz;

         OuterProduct0( &d0, &d1, &v1 );
         v1.vx  = v0.vx+(-v1.vx>>11) ;
         v1.vy  = v0.vy+(-v1.vy>>11) ;
         v1.vz  = v0.vz+(-v1.vz>>11) ;

         }
      }
   }
#endif

#if 0
void  RENDER_meshexamine()
   {
   u32   *pmod, f, g, numobjs, normlistsize  ;
   u32   normlist;
   vec16 n;
   s32   a;
   pmod =   MESH_modeladdr[1];

   printf( "flags    %d\n", *pmod++ );

   numobjs  =  *pmod++;
   printf( "numobjs  %d\n", numobjs );

   printf( "vertp    %d\n", *pmod++ );

   printf( "numvert  %d\n", *pmod++ );

   normlist =  *pmod++;
   printf( "normp    %d\n", (u32)normlist );

   normlistsize   =  *pmod++;
   printf( "numnorm  %d\n", normlistsize );


   normlist += (u32)(MESH_models);
   /*
   for(f=0;f<normlistsize;f++)
      {
      n.vx  =  *((s16*)normlist+0);
      n.vy  =  *((s16*)normlist+1);
      n.vz  =  *((s16*)normlist+2);

      a  =  n.vx*n.vx + n.vy*n.vy + n.vz*n.vz;
      a  =  SquareRoot0(a);
      printf( "norm %d,%d,%d,%d,%d\n", f, n.vx, n.vy, n.vz, a  );
      normlist+=8;
      }
   */
   //objinfo
   for( f=0;f<numobjs;f++)
      {

      u32   *collptr;
      u32   numtri;
      u32   numquad;

      pmod  += 32;

      collptr  = (*pmod++) + (u32)MESH_models;
      numtri   = *pmod++;
      numquad  = *pmod++;

      printf( "\nobj      %d\n", f );
      printf( "collptr  %d\n",collptr    );
      printf( "numtri   %d\n",numtri     );
      printf( "numquad  %d\n",numquad    );

      for(g=0;g<numtri;g++)
         {
         u32   ptrcf, ptrno;

         ptrcf =  *collptr++;
         ptrno =  *collptr++;
         ptrno += (u32)MESH_models;
         printf( "nx,%d\n", *(((s16*)ptrno)+0) );
         printf( "ny,%d\n", *(((s16*)ptrno)+1) );
         printf( "nz,%d\n", *(((s16*)ptrno)+2) );
         }
      }
   }
#endif
vec16 v0,v1,v2,v3;

#define SCALE  (8)
void  dinojnr0()
   {
   GsLINE   line;

   line.attribute=0;
   line.r   =0xff;
   line.g   =0x80;
   line.b   =0x1f;

   line.x0  =  v0.vx>>SCALE;
   line.y0  =  v0.vz>>SCALE;
   line.x1  =  v1.vx>>SCALE;
   line.y1  =  v1.vz>>SCALE;
   GsSortLine( &line, ptrwot, 0 );

   line.x0  =  v1.vx>>SCALE;
   line.y0  =  v1.vz>>SCALE;
   line.x1  =  v2.vx>>SCALE;
   line.y1  =  v2.vz>>SCALE;
   GsSortLine( &line, ptrwot, 0 );

   line.x0  =  v2.vx>>SCALE;
   line.y0  =  v2.vz>>SCALE;
   line.x1  =  v0.vx>>SCALE;
   line.y1  =  v0.vz>>SCALE;
   GsSortLine( &line, ptrwot, 0 );

   }

void  dinojnr1()
   {
   GsLINE   line;

   line.attribute=0;
   line.r   =0xff;
   line.g   =0x80;
   line.b   =0x1f;

   line.x0  =  v0.vx>>SCALE;
   line.y0  =  v0.vz>>SCALE;
   line.x1  =  v1.vx>>SCALE;
   line.y1  =  v1.vz>>SCALE;
   GsSortLine( &line, ptrwot, 0 );

   line.x0  =  v1.vx>>SCALE;
   line.y0  =  v1.vz>>SCALE;
   line.x1  =  v2.vx>>SCALE;
   line.y1  =  v2.vz>>SCALE;
   GsSortLine( &line, ptrwot, 0 );

   line.x0  =  v2.vx>>SCALE;
   line.y0  =  v2.vz>>SCALE;
   line.x1  =  v3.vx>>SCALE;
   line.y1  =  v3.vz>>SCALE;
   GsSortLine( &line, ptrwot, 0 );

   line.x0  =  v3.vx>>SCALE;
   line.y0  =  v3.vz>>SCALE;
   line.x1  =  v0.vx>>SCALE;
   line.y1  =  v0.vz>>SCALE;
   GsSortLine( &line, ptrwot, 0 );

   }
/*
void  RENDER_scanmodel()
   {

   u32   *pmod ;
   s32   gx, gz,ggx, ggz, lx, lz, ly, dis;
   u32   *pface, nface;
   vec16 *pvert;
   u32   f, g, t;
   u16   idxv0, idxv1, idxv2, idxv3;

   pmod =  MESH_modeladdr[2];

   pmod+=2;
   pvert =  (vec16*)*pmod;
   pmod+=4;

      {
      //pmod += 35*MESH_map[ggz][ggx];

      //F3
      pface =  *pmod++;
      nface =  *pmod++;
      for(f=0;f<nface;f++)
         {
         idxv0  =  *((u16*)pface+0);
         idxv1  =  *((u16*)pface+1);
         idxv2  =  *((u16*)pface+2);

         vmovs( &v0, &pvert[ idxv0 ] );
         vmovs( &v1, &pvert[ idxv1 ] );
         vmovs( &v2, &pvert[ idxv2 ] );

         dinojnr0();

         pface+=3;
         }

      //FD3
      pface =  *pmod++;
      nface =  *pmod++;
      for(f=0;f<nface;f++)
         {
         idxv0  =  *((u16*)pface+0);
         idxv1  =  *((u16*)pface+1);
         idxv2  =  *((u16*)pface+2);

         vmovs( &v0, &pvert[ idxv0 ] );
         vmovs( &v1, &pvert[ idxv1 ] );
         vmovs( &v2, &pvert[ idxv2 ] );

         dinojnr0();

         pface+=3;
         }

      //T3
      pface =  *pmod++;
      nface =  *pmod++;
      for(f=0;f<nface;f++)
         {
         idxv0  =  *((u16*)pface+0);
         idxv1  =  *((u16*)pface+1);
         idxv2  =  *((u16*)pface+2);

         vmovs( &v0, &pvert[ idxv0 ] );
         vmovs( &v1, &pvert[ idxv1 ] );
         vmovs( &v2, &pvert[ idxv2 ] );

         dinojnr0();

         pface+=6;
         }

      //TD3
      pface =  *pmod++;
      nface =  *pmod++;
      for(f=0;f<nface;f++)
         {
         idxv0  =  *((u16*)pface)+0;
         idxv1  =  *((u16*)pface)+1;
         idxv2  =  *((u16*)pface)+2;

         vmovs( &v0, &pvert[ idxv0 ] );
         vmovs( &v1, &pvert[ idxv1 ] );
         vmovs( &v2, &pvert[ idxv2 ] );

         dinojnr0();

         pface+=6;
         }

      //GF3
      pface =  *pmod++;
      nface =  *pmod++;
      for(f=0;f<nface;f++)
         {
         idxv0  =  *((u16*)pface)+0;
         idxv1  =  *((u16*)pface)+1;
         idxv2  =  *((u16*)pface)+2;

         vmovs( &v0, &pvert[ idxv0 ] );
         vmovs( &v1, &pvert[ idxv1 ] );
         vmovs( &v2, &pvert[ idxv2 ] );

         dinojnr0();

         pface+=5;
         }

      //GFD3
      pface =  *pmod++;
      nface =  *pmod++;
      for(f=0;f<nface;f++)
         {
         idxv0  =  *((u16*)pface)+0;
         idxv1  =  *((u16*)pface)+1;
         idxv2  =  *((u16*)pface)+2;

         vmovs( &v0, &pvert[ idxv0 ] );
         vmovs( &v1, &pvert[ idxv1 ] );
         vmovs( &v2, &pvert[ idxv2 ] );

         dinojnr0();

         pface+=5;
         }

      //GT3
      pface =  *pmod++;
      nface =  *pmod++;
      for(f=0;f<nface;f++)
         {
         idxv0  =  *((u16*)pface)+0;
         idxv1  =  *((u16*)pface)+1;
         idxv2  =  *((u16*)pface)+2;

         vmovs( &v0, &pvert[ idxv0 ] );
         vmovs( &v1, &pvert[ idxv1 ] );
         vmovs( &v2, &pvert[ idxv2 ] );

         dinojnr0();

         pface+=8;
         }

      //GTD3
      pface =  *pmod++;
      nface =  *pmod++;
      for(f=0;f<nface;f++)
         {
         idxv0  =  *((u16*)pface)+0;
         idxv1  =  *((u16*)pface)+1;
         idxv2  =  *((u16*)pface)+2;

         vmovs( &v0, &pvert[ idxv0 ] );
         vmovs( &v1, &pvert[ idxv1 ] );
         vmovs( &v2, &pvert[ idxv2 ] );

         dinojnr0();

         pface+=8;
         }

      //F4
      pface =  *pmod++;
      nface =  *pmod++;
      for(f=0;f<nface;f++)
         {
         idxv0  =  *((u16*)pface+0);
         idxv1  =  *((u16*)pface+1);
         idxv2  =  *((u16*)pface+2);
         idxv3  =  *((u16*)pface+3);

         vmovs( &v0, &pvert[ idxv0 ] );
         vmovs( &v1, &pvert[ idxv1 ] );
         vmovs( &v2, &pvert[ idxv2 ] );
         vmovs( &v3, &pvert[ idxv3 ] );

         dinojnr1();

         pface+=4;
         }

      //FD4
      pface =  *pmod++;
      nface =  *pmod++;
      for(f=0;f<nface;f++)
         {
         idxv0  =  *((u16*)pface+0);
         idxv1  =  *((u16*)pface+1);
         idxv2  =  *((u16*)pface+2);
         idxv3  =  *((u16*)pface+3);

         vmovs( &v0, &pvert[ idxv0 ] );
         vmovs( &v1, &pvert[ idxv1 ] );
         vmovs( &v2, &pvert[ idxv2 ] );
         vmovs( &v3, &pvert[ idxv3 ] );

         dinojnr1();

         pface+=4;
         }

      //T4
      pface =  *pmod++;
      nface =  *pmod++;
      for(f=0;f<nface;f++)
         {
         idxv0  =  *((u16*)pface+0);
         idxv1  =  *((u16*)pface+1);
         idxv2  =  *((u16*)pface+2);
         idxv3  =  *((u16*)pface+3);

         vmovs( &v0, &pvert[ idxv0 ] );
         vmovs( &v1, &pvert[ idxv1 ] );
         vmovs( &v2, &pvert[ idxv2 ] );
         vmovs( &v3, &pvert[ idxv3 ] );

         dinojnr1();

         pface+=7;
         }

      //TD4
      pface =  *pmod++;
      nface =  *pmod++;
      for(f=0;f<nface;f++)
         {
         idxv0  =  *((u16*)pface)+0;
         idxv1  =  *((u16*)pface)+1;
         idxv2  =  *((u16*)pface)+2;
         idxv3  =  *((u16*)pface)+3;

         vmovs( &v0, &pvert[ idxv0 ] );
         vmovs( &v1, &pvert[ idxv1 ] );
         vmovs( &v2, &pvert[ idxv2 ] );
         vmovs( &v3, &pvert[ idxv3 ] );

         dinojnr1();

         pface+=7;
         }

      //GF4
      pface =  *pmod++;
      nface =  *pmod++;
      for(f=0;f<nface;f++)
         {
         idxv0  =  *((u16*)pface)+0;
         idxv1  =  *((u16*)pface)+1;
         idxv2  =  *((u16*)pface)+2;
         idxv3  =  *((u16*)pface)+3;

         vmovs( &v0, &pvert[ idxv0 ] );
         vmovs( &v1, &pvert[ idxv1 ] );
         vmovs( &v2, &pvert[ idxv2 ] );
         vmovs( &v3, &pvert[ idxv3 ] );

         dinojnr1();

         pface+=7;
         }


      //GFD4
      pface =  *pmod++;
      nface =  *pmod++;
      for(f=0;f<nface;f++)
         {
         idxv0  =  *((u16*)pface)+0;
         idxv1  =  *((u16*)pface)+1;
         idxv2  =  *((u16*)pface)+2;
         idxv3  =  *((u16*)pface)+3;

         vmovs( &v0, &pvert[ idxv0 ] );
         vmovs( &v1, &pvert[ idxv1 ] );
         vmovs( &v2, &pvert[ idxv2 ] );
         vmovs( &v3, &pvert[ idxv3 ] );

         dinojnr1();

         pface+=7;
         }

      //GT4
      pface =  *pmod++;
      nface =  *pmod++;
      for(f=0;f<nface;f++)
         {
         idxv0  =  *((u16*)pface)+0;
         idxv1  =  *((u16*)pface)+1;
         idxv2  =  *((u16*)pface)+2;
         idxv3  =  *((u16*)pface)+3;

         vmovs( &v0, &pvert[ idxv0 ] );
         vmovs( &v1, &pvert[ idxv1 ] );
         vmovs( &v2, &pvert[ idxv2 ] );
         vmovs( &v3, &pvert[ idxv3 ] );

         dinojnr1();

         pface+=10;
         }

      //GTD4
      pface =  *pmod++;
      nface =  *pmod++;
      for(f=0;f<nface;f++)
         {
         idxv0  =  *((u16*)pface)+0;
         idxv1  =  *((u16*)pface)+1;
         idxv2  =  *((u16*)pface)+2;
         idxv3  =  *((u16*)pface)+3;

         vmovs( &v0, &pvert[ idxv0 ] );
         vmovs( &v1, &pvert[ idxv1 ] );
         vmovs( &v2, &pvert[ idxv2 ] );
         vmovs( &v3, &pvert[ idxv3 ] );

         dinojnr1();

         pface+=10;
         }
      }
   }
*/
/*
void  RENDER_scanmodel2()
   {
   s32   a;
   u32   *pmod ;
   s32   gx, gz,ggx, ggz, lx, lz, ly, dis;
   u32   *pface, nface;
   vec16 *pvert;
   u32   f, g, t,numobj;
   u16   idxv0, idxv1, idxv2, idxv3;

   pmod =  MESH_modeladdr[0];

   pmod++;
   numobj=*pmod++;
   pvert =  (vec16*)*pmod++;
sprintf(debbuf,"nvert %d",*pmod++);
RENDER_message(debbuf);
   pmod+=2;

   a  =  (G_cyc)%numobj;
   pmod += 35*(a);

   for(g=a;g<a+10;g++)
      {
      if(g==numobj)break;
      //F3
      pface =  *pmod++;
      nface =  *pmod++;
      for(f=0;f<nface;f++)
         {
         idxv0  =  *((u16*)pface+0);
         idxv1  =  *((u16*)pface+1);
         idxv2  =  *((u16*)pface+2);

         vmovs( &v0, &pvert[ idxv0 ] );
         vmovs( &v1, &pvert[ idxv1 ] );
         vmovs( &v2, &pvert[ idxv2 ] );

         dinojnr0();

         pface+=3;
         }

      //FD3
      pface =  *pmod++;
      nface =  *pmod++;
      for(f=0;f<nface;f++)
         {
         idxv0  =  *((u16*)pface+0);
         idxv1  =  *((u16*)pface+1);
         idxv2  =  *((u16*)pface+2);

         vmovs( &v0, &pvert[ idxv0 ] );
         vmovs( &v1, &pvert[ idxv1 ] );
         vmovs( &v2, &pvert[ idxv2 ] );

         dinojnr0();

         pface+=3;
         }

      //T3
      pface =  *pmod++;
      nface =  *pmod++;
      for(f=0;f<nface;f++)
         {
         idxv0  =  *((u16*)pface+0);
         idxv1  =  *((u16*)pface+1);
         idxv2  =  *((u16*)pface+2);

         vmovs( &v0, &pvert[ idxv0 ] );
         vmovs( &v1, &pvert[ idxv1 ] );
         vmovs( &v2, &pvert[ idxv2 ] );

         dinojnr0();

         pface+=6;
         }

      //TD3
      pface =  *pmod++;
      nface =  *pmod++;
      for(f=0;f<nface;f++)
         {
         idxv0  =  *((u16*)pface)+0;
         idxv1  =  *((u16*)pface)+1;
         idxv2  =  *((u16*)pface)+2;

         vmovs( &v0, &pvert[ idxv0 ] );
         vmovs( &v1, &pvert[ idxv1 ] );
         vmovs( &v2, &pvert[ idxv2 ] );

         dinojnr0();

         pface+=6;
         }

      //GF3
      pface =  *pmod++;
      nface =  *pmod++;
      for(f=0;f<nface;f++)
         {
         idxv0  =  *((u16*)pface)+0;
         idxv1  =  *((u16*)pface)+1;
         idxv2  =  *((u16*)pface)+2;

         vmovs( &v0, &pvert[ idxv0 ] );
         vmovs( &v1, &pvert[ idxv1 ] );
         vmovs( &v2, &pvert[ idxv2 ] );

         dinojnr0();

         pface+=5;
         }

      //GFD3
      pface =  *pmod++;
      nface =  *pmod++;
      for(f=0;f<nface;f++)
         {
         idxv0  =  *((u16*)pface)+0;
         idxv1  =  *((u16*)pface)+1;
         idxv2  =  *((u16*)pface)+2;

         vmovs( &v0, &pvert[ idxv0 ] );
         vmovs( &v1, &pvert[ idxv1 ] );
         vmovs( &v2, &pvert[ idxv2 ] );

         dinojnr0();

         pface+=5;
         }

      //GT3
      pface =  *pmod++;
      nface =  *pmod++;
      for(f=0;f<nface;f++)
         {
         idxv0  =  *((u16*)pface)+0;
         idxv1  =  *((u16*)pface)+1;
         idxv2  =  *((u16*)pface)+2;

         vmovs( &v0, &pvert[ idxv0 ] );
         vmovs( &v1, &pvert[ idxv1 ] );
         vmovs( &v2, &pvert[ idxv2 ] );

         dinojnr0();

         pface+=8;
         }

      //GTD3
      pface =  *pmod++;
      nface =  *pmod++;
      for(f=0;f<nface;f++)
         {
         idxv0  =  *((u16*)pface)+0;
         idxv1  =  *((u16*)pface)+1;
         idxv2  =  *((u16*)pface)+2;

         vmovs( &v0, &pvert[ idxv0 ] );
         vmovs( &v1, &pvert[ idxv1 ] );
         vmovs( &v2, &pvert[ idxv2 ] );

         dinojnr0();

         pface+=8;
         }

      //F4
      pface =  *pmod++;
      nface =  *pmod++;
      for(f=0;f<nface;f++)
         {
         idxv0  =  *((u16*)pface+0);
         idxv1  =  *((u16*)pface+1);
         idxv2  =  *((u16*)pface+2);
         idxv3  =  *((u16*)pface+3);

         vmovs( &v0, &pvert[ idxv0 ] );
         vmovs( &v1, &pvert[ idxv1 ] );
         vmovs( &v2, &pvert[ idxv2 ] );
         vmovs( &v3, &pvert[ idxv3 ] );

         dinojnr1();

         pface+=4;
         }

      //FD4
      pface =  *pmod++;
      nface =  *pmod++;
      for(f=0;f<nface;f++)
         {
         idxv0  =  *((u16*)pface+0);
         idxv1  =  *((u16*)pface+1);
         idxv2  =  *((u16*)pface+2);
         idxv3  =  *((u16*)pface+3);

         vmovs( &v0, &pvert[ idxv0 ] );
         vmovs( &v1, &pvert[ idxv1 ] );
         vmovs( &v2, &pvert[ idxv2 ] );
         vmovs( &v3, &pvert[ idxv3 ] );

         dinojnr1();

         pface+=4;
         }

      //T4
      pface =  *pmod++;
      nface =  *pmod++;
      for(f=0;f<nface;f++)
         {
         idxv0  =  *((u16*)pface+0);
         idxv1  =  *((u16*)pface+1);
         idxv2  =  *((u16*)pface+2);
         idxv3  =  *((u16*)pface+3);

         vmovs( &v0, &pvert[ idxv0 ] );
         vmovs( &v1, &pvert[ idxv1 ] );
         vmovs( &v2, &pvert[ idxv2 ] );
         vmovs( &v3, &pvert[ idxv3 ] );

         dinojnr1();

         pface+=7;
         }

      //TD4
      pface =  *pmod++;
      nface =  *pmod++;
      for(f=0;f<nface;f++)
         {
         idxv0  =  *((u16*)pface)+0;
         idxv1  =  *((u16*)pface)+1;
         idxv2  =  *((u16*)pface)+2;
         idxv3  =  *((u16*)pface)+3;

         vmovs( &v0, &pvert[ idxv0 ] );
         vmovs( &v1, &pvert[ idxv1 ] );
         vmovs( &v2, &pvert[ idxv2 ] );
         vmovs( &v3, &pvert[ idxv3 ] );

         dinojnr1();

         pface+=7;
         }

      //GF4
      pface =  *pmod++;
      nface =  *pmod++;
      for(f=0;f<nface;f++)
         {
         idxv0  =  *((u16*)pface)+0;
         idxv1  =  *((u16*)pface)+1;
         idxv2  =  *((u16*)pface)+2;
         idxv3  =  *((u16*)pface)+3;

         vmovs( &v0, &pvert[ idxv0 ] );
         vmovs( &v1, &pvert[ idxv1 ] );
         vmovs( &v2, &pvert[ idxv2 ] );
         vmovs( &v3, &pvert[ idxv3 ] );

         dinojnr1();

         pface+=7;
         }


      //GFD4
      pface =  *pmod++;
      nface =  *pmod++;
      for(f=0;f<nface;f++)
         {
         idxv0  =  *((u16*)pface)+0;
         idxv1  =  *((u16*)pface)+1;
         idxv2  =  *((u16*)pface)+2;
         idxv3  =  *((u16*)pface)+3;

         vmovs( &v0, &pvert[ idxv0 ] );
         vmovs( &v1, &pvert[ idxv1 ] );
         vmovs( &v2, &pvert[ idxv2 ] );
         vmovs( &v3, &pvert[ idxv3 ] );

         dinojnr1();

         pface+=7;
         }

      //GT4
      pface =  *pmod++;
      nface =  *pmod++;
      for(f=0;f<nface;f++)
         {
         idxv0  =  *((u16*)pface)+0;
         idxv1  =  *((u16*)pface)+1;
         idxv2  =  *((u16*)pface)+2;
         idxv3  =  *((u16*)pface)+3;

         vmovs( &v0, &pvert[ idxv0 ] );
         vmovs( &v1, &pvert[ idxv1 ] );
         vmovs( &v2, &pvert[ idxv2 ] );
         vmovs( &v3, &pvert[ idxv3 ] );

         dinojnr1();

         pface+=10;
         }

      //GTD4
      pface =  *pmod++;
      nface =  *pmod++;
      for(f=0;f<nface;f++)
         {
         idxv0  =  *((u16*)pface)+0;
         idxv1  =  *((u16*)pface)+1;
         idxv2  =  *((u16*)pface)+2;
         idxv3  =  *((u16*)pface)+3;

         vmovs( &v0, &pvert[ idxv0 ] );
         vmovs( &v1, &pvert[ idxv1 ] );
         vmovs( &v2, &pvert[ idxv2 ] );
         vmovs( &v3, &pvert[ idxv3 ] );

         dinojnr1();

         //pface+=10;
         }
      pmod++;//colp
      pmod++;//numtris
      pmod++;//numquads
      }
   }
*/

void  RENDER_arrow()
   {
//   u32   f;
//   u16   g;
   /*
   GsLINE   line;
   vec16 pts[4]={{0,0,255},{255,0,0},{-255,0,0},{0,0,-255}};

   vrot( &pts[0].vx, &pts[0].vz, G_cyc<<4 );


   line.attribute=0;
   line.r   =0xff;
   line.g   =0xff;
   line.b   =0xff;

   line.x0  = pts[0].vx;
   line.y0  = pts[0].vz;
   line.x1  = pts[1].vx;
   line.y1  = pts[1].vz;
   GsSortLine( &line, ptrwot, 0 );

   line.x0  = pts[0].vx;
   line.y0  = pts[0].vz;
   line.x1  = pts[2].vx;
   line.y1  = pts[2].vz;
   GsSortLine( &line, ptrwot, 0 );

   line.x0  = pts[0].vx;
   line.y0  = pts[0].vz;
   line.x1  = pts[3].vx;
   line.y1  = pts[3].vz;
   GsSortLine( &line, ptrwot, 0 );
   */

//   G_cyc  =  g<<16;
   }
/*
void  RENDER_sprite( OBJ_STRUCT* obj )
   {
   vec16 p;
   s32   iz;

   p.vx  =  obj->vx>>8;
   p.vy  =  obj->vy>>8;
   p.vz  =  obj->vz>>8;

   vsub( &p, &CAM_camp[CAM_c] );
   vsetrotmatrix( &CAM_camm[CAM_c]);
   vapplymatrix32( &CAM_camm[CAM_c], &p, &p );
   p.vx   =  (p.vx*25)>>4;//aspect correct

   iz  = (0xffff/z) >> (1+OT_LENGTH);

   RENDER_sprite.attribute =(1<<6) | (0<<28) | (1<<24) | (0<<30);
   RENDER_sprite.x   =p.x;
   RENDER_sprite.y   =p.y;
   RENDER_sprite.w   =64;
   RENDER_sprite.h   =128;
   RENDER_sprite.tpage=28;
   RENDER_sprite.u   =0;
   RENDER_sprite.v   =0;
   RENDER_sprite.cx  =768;
   RENDER_sprite.cy  =383;
   RENDER_sprite.r   =128;
   RENDER_sprite.g   =128;
   RENDER_sprite.b   =128;
   RENDER_sprite.mx  =0;
   RENDER_sprite.my  =0;
   RENDER_sprite.scalex =iz;
   RENDER_sprite.scaley =iz;
   RENDER_sprite.rotate =0;
   GsSortSprite( &RENDER_sprite, ptrwot, 0 );
   }
*/

void  RENDER_crosshair()
   {
   s32   offx  =  0;//OBJ_players[0].crossx360;
   GsLINE   line;
   line.attribute=0;
   line.r   =0xff;
   line.g   =0xff;
   line.b   =0x0;

   line.x0  = -15    +offx;
   line.y0  =   -10;
   line.x1  =  15    +offx;
   line.y1  =   -10;
   GsSortLine( &line, ptrwot, 0 );

   line.x0  =   0    +offx;
   line.y0  = -20;
   line.x1  =   0    +offx;
   line.y1  =  0;
   GsSortLine( &line, ptrwot, 0 );

   }