// sound stuff
#define MAXNUMSFXOBJ 32

void     SOUND_update();
s16      SOUND_sfx_dynamic( u8 sfxnum, u16 object, u8 vol );
s16      SOUND_sfx( u8 sfxnum );
s16      SOUND_sfx_p( u8 sfxnum, u8 p );
void     SOUND_sfx_static( u8 sfxnum, s16 x, s16 z, u8 vol );
void     SOUND_examinecd();
void     SOUND_playcdtrack();
void     SOUND_stopcdtrack( );
void     SOUND_init();
void     SOUND_killobjects();
void     SOUND_killobject( s16 obj);
void     SOUND_debug();
void     SOUND_setvol(u8 v);

extern   s32   SOUND_cdtrack;
extern   s32   SOUND_tottracks;

extern   s16 vab1;    /* vab data id */

typedef  struct
   {
   u8    name[6];   //for debug
   u16   pitch;
   u16   vol;
   u8    typeflags;
   }SFXINFOSTRUCT;

typedef  struct
   {
   u8    stat;    //ON/OFF
   u8    sfxnum;  //prog from VAB
   u16   pitchH;  //pitch
   u16   pitchL;  //pitch
   s16   vol;
   s16   type;    //type (doppler, 3dvol, contantmonitor)
   s16   ownerobj;//where to get pos and vel -1 = see next
   s16   px;      //if not attached remember position
   s16   pz;
   s8    chan;    //channelnum -1=none
   s16   dist;
   // padmeout
   }SFXOBJSTRUCT;


extern SFXOBJSTRUCT sfxobj[MAXNUMSFXOBJ];
extern   int   SOUND_tracklist[];

// new stuff
s8 S2_sfxdynamic( u8 Sfx, s16 x, s16 z, s16 Obji, u8  Vol, s32 Pitch );


// pile of shit
//extern u_char	param[4];
//extern u_char   result[8];