#include <sys/types.h>
#include <libetc.h>
#include <libgte.h>
#include <libgpu.h>
#include <libgs.h>
#include <libcd.h>
#include <libapi.h>
#include <libsn.h>
#include <libsnd.h>
#include <libspu.h>
#include <gtemac.h>
#include <inline_c.h>
#include <ctrller.h>
#include	<libmath.h>
#include "..\frontend.h"
#include	"rand.h"
#include "..\sdlib\sdfunc.h"
#include "..\header.h"
#include "..\objects.h"
#include "..\render.h"
#include "..\collide.h"
#include "mathpsx.h"
#include "soundpsx.h"
#include "..\sim.h"
#include "..\frontend.h"
#include "..\ctrller.h"
#include "..\gameloop.h"
#include "..\hue.h"
#include "..\state.h"
#include "..\memcard.h"
#include "..\menu.h"
#include "..\loadit.h"
#include "..\wake.h"
#include "..\poon.h"
#include "..\cdlib.h"
#include "..\action.h"
#include "loadpsx.h"
#include "gpupsx.h"
#include <libpad.h>
extern int emu;

#if CDMASTER
#define  READCD   1
#define  READPC   0
#else
#define  READCD   0
#define  READPC   1
#endif

#if READPC
// !! This needs to be in a file without .c extension !!
#include "..\cdname.def"
#endif

#if READCD
#include "..\fileaddr.h"
#endif

#if CDMASTER
#define  READCD   1
#define  READPC   0
#else
#define  READCD   0
#define  READPC   1
#endif

#if READPC
// !! This needs to be in a file without .c extension !!
#include "..\cdname.def"
#endif

#if READCD
#include "..\fileaddr.h"
#endif


void	drawbar( s32 col, s32 f, s32 amount );
void  TWEAK_sim();
void  TWEAK_sound();
void  TWEAK_linetest();
void  TWEAK_sound2();
void  TWEAK_misc();
void  TWEAK_level();
void  TWEAK_test();
void  TWEAK_memcard(void);
void  TWEAK_plot(s16 x,s16 y);
extern	APAD	SD_PadData[8];
extern   GsOT        *ptrwot;//jof
extern   s8    TWEAK_cgrid;

extern   POLY_F4  RENDER_POLYF4;
//extern   POLY_F3  RENDER_POLYF3;
//extern   POLY_G4  RENDER_POLYG4;
//extern   POLY_G3  RENDER_POLYG3;
//extern   SFXINFOSTRUCT  sfxinfo[256];


s32   valmin[11]={
	-20,
	0,
	10,
	10,
	0,
	0,
	10,
	0,
	0,
   0,
   0
   };

s32   valmax[11]={
	20,
	200,
	200,
	200,
	200,
	1000000,
	1000,
	2000,
	1000,
   200,
   256
	};

s32   valdiff[12];

s32	crafteditnum=0;
s32	fieldeditnum=0;
SpuVoiceAttr   attr;

extern   s16 vab1;    /* vab data id */

SpuDecodeData wave;

#if 0
RECT rct;
u_short buf[1024] [512];
int doScreen = 0;
#endif

s16   tweakpage=0;
void	TWEAK_tweak()
   {
   switch (tweakpage)
      {
      case 0:TWEAK_sim();break;
      case 1:TWEAK_sound();break;
      case 2:TWEAK_linetest();break;
      case 3:TWEAK_level();break;
      case 4:TWEAK_test();break;
      case 5:TWEAK_memcard();break;
      }

   if( SD_PadData[4].push&PAD_RU)
      {
      if(tweakpage)tweakpage--;
      SsUtAllKeyOff(0);
      }

   if( SD_PadData[4].push&PAD_RD)
      {
      if(tweakpage<5)tweakpage++;
      SsUtAllKeyOff(0);
      }

#if 0
	if(doScreen)
    	{
        rct.x = 0;
        rct.y = 0;
        rct.w = 1024;
        rct.h = 512;
        StoreImage(&rct,buf);
        doScreen = 0;
        }
#endif


   }

void  TWEAK_sim()
	{
	s32	f;
	SIM_crafttype		*cr	=	&crafts[ crafteditnum ];

   for(f=0;f<30;f++)
      {
   //   TWEAK_plot(SIM_rp[f].vx>>8,SIM_rp[f].vz>>8);
      }

   for(f=0;f<11;f++)
		{
		valdiff[f]	=	(valmax[f]-valmin[f])>>8;
		if( valdiff[f] <1 )valdiff[f]=1;
		}

   if( SD_PadData[4].push&PAD_LU)
			{
			if(fieldeditnum)fieldeditnum--;
			}

   if( SD_PadData[4].push&PAD_LD)
			{
         if(fieldeditnum<11)fieldeditnum++;
			}

   if( (SD_PadData[4].push&PAD_RL)  )
			{
			if(crafteditnum)crafteditnum--;
			}

   if( (SD_PadData[4].push&PAD_RR)  )
			{
			if(crafteditnum<8)crafteditnum++;
			}

	if( !(SD_PadData[4].data&PAD_LR) )
			{
			switch( fieldeditnum )
				{
				case 0 :	cr->susspringtop 		+= valdiff[ fieldeditnum ];break;
				case 1 :	cr->susspringbot 		+= valdiff[ fieldeditnum ];break;
				case 2 :	cr->susspringtopdim 	+= valdiff[ fieldeditnum ];break;
				case 3 :	cr->susspringbotdim 	+= valdiff[ fieldeditnum ];break;
				case 4 :	cr->steerrate		 	+= valdiff[ fieldeditnum ];break;
				case 5 :	cr->grip					+= valdiff[ fieldeditnum ];break;
				case 6 :	cr->thrust				+= valdiff[ fieldeditnum ];break;
				case 7 :	cr->airdrag				+= valdiff[ fieldeditnum ];break;
            case 8 : cr->ywdamp           += valdiff[ fieldeditnum ];break;
				case 9 :	cr->roll					+= valdiff[ fieldeditnum ];break;
            case 10: cr->imax             += valdiff[ fieldeditnum ];break;
            }

			}

	if( !(SD_PadData[4].data&PAD_LL) )
			{
			switch( fieldeditnum )
				{
				case 0 :	cr->susspringtop 		-= valdiff[ fieldeditnum ];break;
				case 1 :	cr->susspringbot 		-= valdiff[ fieldeditnum ];break;
				case 2 :	cr->susspringtopdim 	-= valdiff[ fieldeditnum ];break;
				case 3 :	cr->susspringbotdim 	-= valdiff[ fieldeditnum ];break;
				case 4 :	cr->steerrate		 	-= valdiff[ fieldeditnum ];break;
				case 5 :	cr->grip					-= valdiff[ fieldeditnum ];break;
				case 6 :	cr->thrust				-= valdiff[ fieldeditnum ];break;
				case 7 :	cr->airdrag				-= valdiff[ fieldeditnum ];break;
				case 8 :	cr->ywdamp				-= valdiff[ fieldeditnum ];break;
				case 9 :	cr->roll					-= valdiff[ fieldeditnum ];break;
            case 10: cr->imax             -= valdiff[ fieldeditnum ];break;
				}
			}


	FntPrint("TWEAKLAND: craft=%d\n", crafteditnum);

	FntPrint("sptop    %d\n", cr->susspringtop);
 	drawbar( 0, 0, cr->susspringtop);

	FntPrint("spbot    %d\n", cr->susspringbot);
 	drawbar( 1, 1, cr->susspringbot);

	FntPrint("sptopdim %d\n", cr->susspringtopdim);
 	drawbar( 2, 2, cr->susspringtopdim);

	FntPrint("spbotdim %d\n", cr->susspringbotdim);
 	drawbar( 3, 3, cr->susspringbotdim);

	FntPrint("strate   %d\n", cr->steerrate);
 	drawbar( 4, 4, cr->steerrate);

	FntPrint("grip     %d\n", cr->grip);
 	drawbar( 5, 5, cr->grip);

	FntPrint("thrust   %d\n", cr->thrust);
 	drawbar( 6, 6, cr->thrust);

	FntPrint("airdrag  %d\n", cr->airdrag);
 	drawbar( 7, 7, cr->airdrag);

	FntPrint("ywdamp   %d\n", cr->ywdamp);
 	drawbar( 8, 8, cr->ywdamp);

	FntPrint("roll     %d\n", cr->roll);
 	drawbar( 9, 9, cr->roll);

   FntPrint("imax     %d\n", cr->imax);
   drawbar(10,10, cr->imax);

   FntPrint("\n");


   for(f=0;f<MAXNUMOBJS;f++)
      {
      if( OBJ_objects[f].stat==ON )
         {
         //FntPrint("obI:%d, %s, own%d \n", f,OBJ_typeinfo[ OBJ_objects[f].type ].name, OBJ_objects[f].owner );
         }
      }
	}

void  drawbar( s32 col, s32 f, s32 amount )
	{
	s32	xl	= -120;
	s32	yu	=  -111 +col*8;
	s32	yb	=  -111 +col*8+7;
	s32	sl;

	sl	=	((amount-valmin[f])<<8)/(valmax[f]-valmin[f]);

	RENDER_POLYF4.x0	=	xl;	  	RENDER_POLYF4.y0	=	yu;
	RENDER_POLYF4.x1	=	xl+256;	RENDER_POLYF4.y1	=	yu;
	RENDER_POLYF4.x2	=	xl;	  	RENDER_POLYF4.y2	=	yb;
	RENDER_POLYF4.x3	=	xl+256;	RENDER_POLYF4.y3	=	yb;
	RENDER_POLYF4.r0	=	10; 		RENDER_POLYF4.g0	=	10;	RENDER_POLYF4.b0	=	100;
	if( col== fieldeditnum)
		{
		RENDER_POLYF4.r0	=	0; 	  	RENDER_POLYF4.g0	=	60;	RENDER_POLYF4.b0	=	60;
		}
   GsSortPoly( &RENDER_POLYF4, ptrwot, 11 );

	RENDER_POLYF4.x0	=	xl;	  	RENDER_POLYF4.y0	=	yu;
	RENDER_POLYF4.x1	=	xl+sl;	RENDER_POLYF4.y1	=	yu;
	RENDER_POLYF4.x2	=	xl;	  	RENDER_POLYF4.y2	=	yb;
	RENDER_POLYF4.x3	=	xl+sl; 	RENDER_POLYF4.y3	=	yb;
	RENDER_POLYF4.r0	=	0; 	  	RENDER_POLYF4.g0	=	200;	RENDER_POLYF4.b0	=	200;
	if( col== fieldeditnum)
		{
		RENDER_POLYF4.r0	=	200; 	  	RENDER_POLYF4.g0	=	10;	RENDER_POLYF4.b0	=	10;
		}
   GsSortPoly( &RENDER_POLYF4, ptrwot, 10 );
	}


s16   SFX=1;
s16   pan=0;
s16   cdvol=64;

s16   edfie=0;

void  TWEAK_sound()
   {
   s16   f;
//	s16 pan0, pan1;
//   static   s16   c1,c2;
   u8    status[24];
   FntPrint("SOUND LAND\n" );
   FntPrint("tot tracks  : %d\n", SOUND_tottracks );

   FntPrint(" CD track    : %d\n", SOUND_cdtrack );
   FntPrint(" cdvol       : %d\n", cdvol );
   FntPrint(" sfx(%d)\n", SFX );


   if( !(SD_PadData[4].data&PAD_LU) && !(SD_PadData[4].old&PAD_LU) )
			{
         if(edfie)edfie--;
			}

   if( !(SD_PadData[4].data&PAD_LD) && !(SD_PadData[4].old&PAD_LD) )
			{
         if(edfie<10)edfie++;
			}

  TWEAK_plot(-245, -100 +8*edfie );

   if( !(SD_PadData[4].data&PAD_LR) && !(SD_PadData[4].old&PAD_LR) )
			{
         switch( edfie )
				{
//            case 0 : SOUND_cdtrack  += 1;SOUND_tracklist[0]=SOUND_cdtrack;SOUND_playcdtrack();  break;
            case 0 : SOUND_cdtrack++;CDLIB_Play(SOUND_cdtrack);  break;
            case 1 : cdvol          += 1;SsSetSerialVol(SS_SERIAL_A, cdvol, cdvol );break;
            case 2 : SFX            += 1;SsUtAllKeyOff(0);     break;
            case 5 :
//             LOAD_readPCfile( sfxinfo , "c:\\360\\feel.moo" );
               break;
            case 6 :

               break;
            }
			}

   if( !(SD_PadData[4].data&PAD_LL) && !(SD_PadData[4].old&PAD_LL) )
			{
         switch( edfie )
				{
            case 0 : SOUND_cdtrack  -= 1;SOUND_tracklist[0]=SOUND_cdtrack;SOUND_playcdtrack();  break;
            case 1 : cdvol          -= 1;SsSetSerialVol(SS_SERIAL_A, cdvol, cdvol );break;
            case 2 : SFX            -= 1;SsUtAllKeyOff(0);     break;
            }
			}


   SpuGetAllKeysStatus( status );
   if( status[23]==0   )
      {
      SsUtKeyOnV(23,vab1,SFX,0,35,0,120,120);
      //SsUtKeyOnV(23,vab1,SFX,0,36,0,100,100);
      }

   SpuReadDecodeData( &wave,  SPU_ALL );
   // cd left
   for(f=0;f<200;f++)
      {
      s16   yu =  (wave.cd_left[f]>>8)+50;
      s16   yb =  50;
      s16   xl =  f-200;

      RENDER_POLYF4.x0  =  xl;    RENDER_POLYF4.y0  =  yu;
      RENDER_POLYF4.x1  =  xl+1;  RENDER_POLYF4.y1  =  yu;
      RENDER_POLYF4.x2  =  xl;    RENDER_POLYF4.y2  =  yb;
      RENDER_POLYF4.x3  =  xl+1;  RENDER_POLYF4.y3  =  yb;
      RENDER_POLYF4.r0  =  newhue2rgb[G_cyc&255].r;
      RENDER_POLYF4.g0  =  newhue2rgb[G_cyc&255].g;
      RENDER_POLYF4.b0  =  newhue2rgb[G_cyc&255].b;
      GsSortPoly( &RENDER_POLYF4, ptrwot, 12 );
      }

   }

void  TWEAK_plot(s16 x,s16 y)
   {
   RENDER_POLYF4.x0  =  x;    RENDER_POLYF4.y0  =  y;
   RENDER_POLYF4.x1  =  x+1;  RENDER_POLYF4.y1  =  y;
   RENDER_POLYF4.x2  =  x;    RENDER_POLYF4.y2  =  y+1;
   RENDER_POLYF4.x3  =  x+1;  RENDER_POLYF4.y3  =  y+1;
   RENDER_POLYF4.r0  =  255;      RENDER_POLYF4.g0  =  255;   RENDER_POLYF4.b0  =  255;
   GsSortPoly( &RENDER_POLYF4, ptrwot, 1 );
   }

void  TWEAK_sound2()
   {
   static   vec32 car={0,0,50};
   static   u8    nextfrcomp=0;
   vec32  carv={0,0,0};
   u8    status[24];
   s16   ang,  voll, volr, dist, delay;
//   s16 sinw;
   s16   unit256x, unit256z, velcomp;

   if( !(SD_PadData[0].data&PAD_LL) )
      {
      carv.vx-=2;
      }
   if( !(SD_PadData[0].data&PAD_LR) )
      {
      carv.vx+=2;
      }
   if( !(SD_PadData[0].data&PAD_LU) )
      {
      carv.vz+=2;
      }
   if( !(SD_PadData[0].data&PAD_LD) )
      {
      carv.vz-=2;
      }

   car.vx   += carv.vx;
   car.vy   += carv.vy;
   car.vz   += carv.vz;


   FntPrint("3d sound pro\n");
   TWEAK_plot( car.vx, car.vz );
   TWEAK_plot( 0, 0 );

   ang   =  vatan2( car.vx, abs(car.vz) );
   unit256x =  -rsin( ang )>>4;
   unit256z =  -rcos( ang )>>4;


   delay =  (ang*24)>>10;
   dist  =  127-(vqlen2( car.vx, car.vz )>>1);
   voll  =  ((64+(ang>>5))*dist)>>7;
   volr  =  ((64-(ang>>5))*dist)>>7;
   velcomp  =  (carv.vx*unit256x  +  carv.vz*unit256z);
   SsUtPitchBend( 0, vab1, 0, 0, 64+(velcomp>>4));
   SsUtPitchBend( 1, vab1, 0, 0, 64+(velcomp>>4));

   if(nextfrcomp)
      {
      SsUtPitchBend( 1, vab1, 101, 0, 64);
      nextfrcomp=0;
      }

   SpuGetAllKeysStatus( status );
   if( status[0]==0 )
      {
      SsUtKeyOnV(0,vab1,0,0,36,0,0,volr);
      SsUtKeyOnV(1,vab1,0,0,36,0,voll,0);
      if( !(SD_PadData[0].data&PAD_START))SsUtPitchBend( 1, vab1, 101, 0, 64+delay);
      nextfrcomp  =  1;
      }

   SsUtSetVVol(0,0,volr);
   SsUtSetVVol(1,voll,0);


   FntPrint( "ang %d\n", ang );
   FntPrint( "deb0 %d\n", deb0<<4 );


   //FntPrint("tot tracks  : %d\n", SOUND_tottracks);
   //FntPrint("SFX         : %d\n", SFX);
   //FntPrint("pan         : %d\n", pan);
   }

#define  i0 1
#define  i1 0
#define  i2 2

void  TWEAK_misc()
   {
   GsSPRITE RENDER_sprite;
   RECT  rect;
    //GsDrawOt(&Wot2[outbuf_idx]);

   rect.x   =  0;
   rect.y   =  0;
   rect.w   =  1024;
   rect.h   =  512;
   //DrawSync(0);
   GsSetClip( &rect );
   GsSetDrawBuffOffset();
   /*
   RENDER_sprite.attribute =(0<<28) | (1<<24) | (0<<30);
   RENDER_sprite.x   =-256+512;
   RENDER_sprite.y   =-128;
   RENDER_sprite.w   =128;
   RENDER_sprite.h   =128;
   RENDER_sprite.tpage=28;
   RENDER_sprite.u   =0;
   RENDER_sprite.v   =128;
   RENDER_sprite.cx  =768;
   RENDER_sprite.cy  =383;
   RENDER_sprite.r   =G_cyc&255;
   RENDER_sprite.g   =G_cyc&255;
   RENDER_sprite.b   =G_cyc&255;
   RENDER_sprite.mx  =0;
   RENDER_sprite.my  =0;
   RENDER_sprite.scalex =4096;
   RENDER_sprite.scaley =4096;
   RENDER_sprite.rotate =0;
   */
   RENDER_sprite.attribute =(0<<28) | (1<<24) | (0<<30);
   RENDER_sprite.x   =576;
   RENDER_sprite.y   =40;
   RENDER_sprite.w   =64;
   RENDER_sprite.h   =64;
   RENDER_sprite.tpage=27;
   RENDER_sprite.u   =0;
   RENDER_sprite.v   =0;
   RENDER_sprite.cx  =768;
   RENDER_sprite.cy  =383;
   RENDER_sprite.r   =G_cyc&255;
   RENDER_sprite.g   =G_cyc&255;
   RENDER_sprite.b   =G_cyc&255;
   RENDER_sprite.mx  =0;
   RENDER_sprite.my  =0;
   RENDER_sprite.scalex =4096;
   RENDER_sprite.scaley =4096;
   RENDER_sprite.rotate =0;
   if(outbuf_idx==1)
      {
      GsSortSprite( &RENDER_sprite, &Wot2[outbuf_idx], 0 );
      GsDrawOt(&Wot2[outbuf_idx]);
      }
   rect.x   =  0;
   rect.y   =  0;
   rect.w   =  512;
   rect.h   =  256;
   //DrawSync(0);
   GsSetClip( &rect );
   GsSetDrawBuffOffset();
   /*
   RENDER_sprite.attribute =(0<<28) | (0<<24) | (1<<25) | (0<<30);
   RENDER_sprite.x   =0;
   RENDER_sprite.y   =0;
   RENDER_sprite.w   =128;
   RENDER_sprite.h   =128;
   RENDER_sprite.tpage=8;
   RENDER_sprite.u   =0;
   RENDER_sprite.v   =0;
   RENDER_sprite.cx  =768;
   RENDER_sprite.cy  =383;
   RENDER_sprite.r   =128;
   RENDER_sprite.g   =128;
   RENDER_sprite.b   =128;
   RENDER_sprite.mx  =0;
   RENDER_sprite.my  =0;
   RENDER_sprite.scalex =4096;
   RENDER_sprite.scaley =4096;
   RENDER_sprite.rotate =0;//G_cyc<<12;
   GsSortSprite( &RENDER_sprite, ptrwot, 0 );
    */
   }

void  TWEAK_level()
   {
   u8 gch[6];
   static u8 cursel=0;
   s16   f;

   for(f=0;f<6;f++)gch[f]=' ';
   gch[cursel]='>';

   FntPrint("%cvsync     %d\n", gch[0], STATE.vsync);
   FntPrint("%ctimebar   %d\n", gch[1], STATE.timebar);
   FntPrint("%cres       %d\n", gch[2], STATE.res);
   FntPrint("%cgrid      %d\n", gch[3], TWEAK_cgrid);
   FntPrint("%ccr0       %d\n", gch[4], OBJ_players[0].crafttype);
   FntPrint("%ccr1       %d\n", gch[5], OBJ_players[1].crafttype);

   if( !(SD_PadData[4].data&PAD_LU) &&
       !(SD_PadData[4].old&PAD_LU) )
		{
      if(cursel)cursel--;
		}
   if( !(SD_PadData[4].data&PAD_LD) &&
       !(SD_PadData[4].old&PAD_LD) )
		{
      if(cursel<6)cursel++;
		}

   if( !(SD_PadData[4].data&PAD_START) &&
       !(SD_PadData[4].old&PAD_START) )
		{
      switch(cursel)
         {
         case 0 :STATE.vsync     = !STATE.vsync;
            break;

         case 1 :STATE.timebar  = !STATE.timebar;
            break;

         case 2 :STATE.res     = !STATE.res;
            if(STATE.res==0)
               SD_Init(1,512,256);
               SD_ViewInit(0,0,0,0,0,0,225);
            if(STATE.res==1)
               SD_Init(1,384,256);
               SD_ViewInit(0,0,0,0,0,0,225);
            break;

         case 3 :TWEAK_cgrid     = !TWEAK_cgrid;
            break;

         case 4 :OBJ_players[0].crafttype=   7&(++OBJ_players[0].crafttype);
            break;
         case 5 :OBJ_players[1].crafttype=   7&(++OBJ_players[1].crafttype);
            break;
         }
		}
   }

void  TWEAK_test()
   {
   // N64 testing program for Mat
   static  s8     model=0;
   static  s32     cnt=0;
   static  mat16   objm;//matrix describing rotation and position oof ship
   mat16   angvelmat;//matrix describing ang vel of ship(made from vector)
   vec16   angvelvec={0,0,0};//vector describing ang vel of ship

   FntPrint( "Mod:%d\n",model );
   if( (SD_PadData[4].push&PAD_RR) && (model<33))
      {
      model++;
      }

   if( (SD_PadData[4].push&PAD_RL) && (model>0))
      {
      model--;
      }

   if(cnt==0)
      {
      // set up orig pos/rot
      objm.t[0]  =  0;
      objm.t[1]  =  0;
      objm.t[2]  =  250;

      objm.m[0][0]=4096;
      objm.m[0][1]=0;
      objm.m[0][2]=0;

      objm.m[1][0]=0;
      objm.m[1][1]=4096;
      objm.m[1][2]=0;

      objm.m[2][0]=0;
      objm.m[2][1]=0;
      objm.m[2][2]=4096;
      /////////////////////
      }

   if( !(SD_PadData[4].data&PAD_LL) )angvelvec.vy=-400;
   if( !(SD_PadData[4].data&PAD_LR) )angvelvec.vy= 400;
   if( !(SD_PadData[4].data&PAD_LU) )angvelvec.vx= 400;
   if( !(SD_PadData[4].data&PAD_LD) )angvelvec.vx=-400;


   // set up ang vel
   msetmatrotvect( &angvelmat, &angvelvec );
   /////////////////

   // apply ang vel to rot
   vmulmatrix2( &angvelmat, &objm );
   ///////////////////////

   vsetrotmatrix( &objm );
   vsettransmatrix( &objm );

   GPU_rendersdmodel( model, 0 );
   //RENDER_swirl();
   cnt++;
   }

u8 testbuf[128];

void TWEAK_memcard(void)
	{
//	static char *placeText[8] =
//		{"1st","2nd","3rd","4th","5ft","6th","7th","8th"};
	u8 gch[9];
	static u8 cursel=0;
	s16 f;
	int i;
	static int wakeEnable = 0;

	for(f=0;f<9;f++)
		gch[f] = f==cursel?'>':' ';

	FntPrint("memory card land\n");
    FntPrint(" %cquit game\n",gch[0]);
    FntPrint(" %cmainmode var %d\n",gch[1],racePosition);
	FntPrint(" %cenable access to all levels\n",gch[2]);
	FntPrint(" %cset access to defaults\n",gch[3]);
	FntPrint(" %c%s wake\n",gch[4],wakeEnable?"disable":"enable");
    FntPrint("\n");

	FntPrint("    World access : %c %c %c %c %c\n",
	    WorldAvailable[0]?'o':'-',
	    WorldAvailable[1]?'o':'-',
   		WorldAvailable[2]?'o':'-',
	    WorldAvailable[3]?'o':'-',
	    WorldAvailable[4]?'o':'-');

	FntPrint("\n");

	for(f=0;f<5;f++)
		FntPrint("    World %d : %c %c %c %c\n",f,
			TrackAvailable[f] [0]?'o':'-',
			TrackAvailable[f] [1]?'o':'-',
			TrackAvailable[f] [2]?'o':'-',
			TrackAvailable[f] [3]?'o':'-');

	FntPrint("\n");
    FntPrint(" %cstart action replay\n",gch[5]);
    FntPrint(" %cstart pause menu\n",gch[6]);
    FntPrint(" %c%s all menu\n",gch[7],menuEnableFlag?"disable":"enable");
    FntPrint(" %clock pad  p0=%d p1=%d\n",gch[8],*PadAnalog0,*PadAnalog1);
	FntPrint("    EXE MODE: %s",emu==1?"PS-X":"EMU e.g. BLEEM");

    if(!(SD_PadData[4].data&PAD_LU)&&!(SD_PadData[4].old&PAD_LU))
		{
		if(cursel)		cursel--;
		}

	if(!(SD_PadData[4].data&PAD_LD)&&!(SD_PadData[4].old&PAD_LD))
		{
		if(cursel<8)	cursel++;
		}

	if(cursel==1)
		{
		if(!(SD_PadData[4].data&PAD_LL)&&!(SD_PadData[4].old&PAD_LL))
			racePosition = (racePosition-1)&0x03;
		if(!(SD_PadData[4].data&PAD_LR)&&!(SD_PadData[4].old&PAD_LR))
			racePosition = (racePosition+1)&0x03;
		}

	if(!(SD_PadData[4].data&PAD_START)&&!(SD_PadData[4].old&PAD_START))
		{
		switch(cursel)
			{
			case 0:
				menuState = MN_Start;
				GAMELOOP_state = GLgame;
				break;

			case 1:
				break;

			case 2:
				for(i=0;i<5;i++)
					WorldAvailable[i] = TrackAvailable[i] [0] = TrackAvailable[i] [1] = TrackAvailable[i] [2] = TrackAvailable[i] [3] = 1;
				break;

			case 3:
				WorldAvailable[0] = 1;	WorldAvailable[1] = 1;	WorldAvailable[2] = 0;	WorldAvailable[3] = 0;	WorldAvailable[4] = 0;
				TrackAvailable[0] [0] = 1;	TrackAvailable[0] [1] = 1;	TrackAvailable[0] [2] = 0;	TrackAvailable[0] [3] = 0;
				TrackAvailable[1] [0] = 1;	TrackAvailable[1] [1] = 1;	TrackAvailable[1] [2] = 0;	TrackAvailable[1] [3] = 0;
				TrackAvailable[2] [0] = 1;	TrackAvailable[2] [1] = 0;	TrackAvailable[2] [2] = 0;	TrackAvailable[2] [3] = 0;
				TrackAvailable[3] [0] = 1;	TrackAvailable[3] [1] = 0;	TrackAvailable[3] [2] = 0;	TrackAvailable[3] [3] = 0;
				TrackAvailable[4] [0] = 1;	TrackAvailable[4] [1] = 1;	TrackAvailable[4] [2] = 1;	TrackAvailable[4] [3] = 1;
				break;

			case 4:
				globalWakeDisable = wakeEnable;
                wakeEnable ^= 1;
                break;

/*
			case 2:
                MEMCARD_save(&testbuf,128);
				break;

			case 3:
                MEMCARD_load(&testbuf,128);
				break;
*/

			case 5:
				arStart();
				
//				GAMELOOP_state = GLloadmenu;

//	            STATE.currlevel =  sel;
	            LOAD_level();
	            GAMELOOP_state=GLfadeouttogame;
				
				break;
	 		
			case 6:
                menuState = MN_Pause;
				GAMELOOP_state = GLgame;
				break;
	 		
			case 7:
                menuEnableFlag ^= 1;
				break;

			case 8:
                PadSetMainMode(0,1,racePosition);
				break;
			}
	 	}
	}

extern   u32   *GameMode;
void  TWEAK_linetest()
   {
   s16   scale =8;
   s16   i;
   FntPrint("cha-maaf \n");

   for(i=0;i<RACE_rpnum;i++)
      {
      TWEAK_plot( RACE_points[i].vx>>scale, RACE_points[i].vz>>scale );
      }

   for(i=0;i<8;i++)
      {
      //if( OBJ_objects[i].type!=OTcraft )continue;
      if((G_cyc&4))
         TWEAK_plot( OBJ_objects[i].p.vx>>(scale+8), OBJ_objects[i].p.vz>>(scale+8) );
      }

   G_cyc++;
   }


/*
      dl.vz =  (l1.vz-l0.vz);

      cps0   =  (l0.vx-s0.vx)*(s1.vz-s0.vz) - (l0.vz-s0.vz)*(s1.vx-s0.vx);
      cps1   =  (l1.vx-s0.vx)*(s1.vz-s0.vz) - (l1.vz-s0.vz)*(s1.vx-s0.vx);

      cpl0   =  (s0.vx-l0.vx)*(l1.vz-l0.vz) - (s0.vz-l0.vz)*(l1.vx-l0.vx);
      cpl1   =  (s1.vx-l0.vx)*(l1.vz-l0.vz) - (s1.vz-l0.vz)*(l1.vx-l0.vx);

 */
