//---------------------------------------------------
//
// Save game data - header file
//




typedef struct 
{
// PlayStation header details

	char	Magic[2];
	char	Type;
	char	Slots;
	char	TextName[64];
	char	pad[28];
	short	CLUT[16];
	short	Image1[64];

	HSCORE	SHighScore;
	unsigned long UnHideVehicle9;	
	unsigned long UnHideVehicle6;
	unsigned long PadConfig;	
	unsigned long WorldAvailable[5];	
	unsigned long TrackAvailable[4][4];	
	
	unsigned long ArcadePos;
	char	Pad8K[8192];
}SaveDataStruct;


extern SaveDataStruct SaveData;


