#if SCREENSHOT

#include <sys/types.h>
#include <libetc.h>	   
#include <libgte.h>	   
#include <libgpu.h>	   
#include <libgs.h>	   
#include <libsn.h>
#include <inline_c.h>
#include <libsnd.h>
#include <libspu.h>
#include <ctrller.h> 

#include "..\header.h"
#include "..\gameloop.h"
#include "sdtypes.h"
#include "screen.h"

#define	SSHOT_W		512
#define SSHOT_H		256
#define SSHOT_OX	256
#define	SSHOT_OY	0

extern   APAD     SD_PadData[8];

u_char hdr[20] =
	{
    0x10,0x00,0x00,0x00,0x02,0x00,0x00,0x00,0x0C,0x00,0x08,0x00,0x00,0x00,0x00,0x00,(SSHOT_W&0xff),((SSHOT_W>>8)&0xff),(SSHOT_H&0xff),((SSHOT_H>>8)&0xff)
    };

RECT rct;
u_short buf[SSHOT_W] [SSHOT_H];

void writePCfile2(void *m0,void *m1,char *f,u32 len0,u32 len1)
	{
	int l;
	int fh = PCcreat(f,0);
//	int fh = PCopen(f,2,0);
	//mprintf("Writing to %s\n",f);
	if(fh==-1)
		mprintf("DEBUG: Error opening pc files (%s)\n",f);
	else
		{
		l = PCwrite(fh,m0,len0);
		if(l!=len0)
         {
         mprintf("DEBUG: Error writing pc files (%s)\n",f);
         RENDER_message("DEBUG: Error writing pc files ");
         }
		l = PCwrite(fh,m1,len1);
		if(l!=len1)
         {
         mprintf("DEBUG: Error writing pc files (%s)\n",f);
         RENDER_message("DEBUG: Error writing pc files ");
         }
      PCclose(fh);
		}
	}

void screenshot(void)
{
static int scnum = 0;
static int frNum = 0;
char fn[128];

pollhost();

frNum=1;

//if((SD_PadData[4].push&PAD_FRT))
if(((SD_PadData[7].push&PAD_RD))||((frNum&0x3f)==0))
	{
    mprintf("Dumping screen shot (%d)",scnum);
    
	rct.x = SSHOT_OX;	// not fb
	rct.y = SSHOT_OY;
	rct.w = SSHOT_W;
	rct.h = SSHOT_H;
	
	DrawSync(0);
	
	StoreImage(&rct,(u32 *)buf);
    
    sprintf(fn,"z:\\360\\360_%04d.tim",scnum++);
    
    writePCfile2(hdr,buf,fn,20,SSHOT_W*SSHOT_H*2);
    
    mprintf(" - Completed.\n");
    }
}

#else

void screenShot(void)
{
}

#endif
