#ifndef __subdiv_
#define __subdiv_

#define SplitScreenF 1			// number of players 1,2,3 or 4

// Sub divide packet types
#define ForceSubDiv	0

#define	ForceSubVal 0x0502

#define	SubSubOn 1			// not used anymore info&0x0400 is 4/16 flag

#define	SeeSplit 0			// debug options
#define	SeeLines 0
#define SeePolyFilla 0


#define MAX_POLY_WIDTH (1023/2)	// max polygon distance X
#define MAX_POLY_HIGHT (511/2)	// max polygon distance Y 

extern	Sint32	clipflag3;	// only used for pollyfilla

//tris
typedef struct
{
Uint16	vt0,vt1;
Uint16	vt2,info;
Uint8	r0, g0, b0, p0;	
}F3_Packet;

typedef struct
{
Uint16	vt0,vt1;
Uint16	vt2,info;
Uint8	r0, g0, b0, p0;	
Uint8	r1, g1, b1, p1;	
Uint8	r2, g2, b2, p2;	
}GF3_Packet;


typedef struct
{
Uint16	vt0,vt1;
Uint16	vt2,info;
Uint8	u0,v0;
Uint16	clut;
Uint8	u1,v1;
Uint16	tpage;
Uint8	u2,v2;
Uint16	pad;
Uint8	r0, g0, b0, p0;	
}T3_Packet;

typedef struct
{
Uint16	vt0,vt1;
Uint16	vt2,info;
Uint8	u0,v0;
Uint16	clut;
Uint8	u1,v1;
Uint16	tpage;
Uint8	u2,v2;
Uint16	pad;
Uint8	r0, g0, b0, p0;	
Uint8	r1, g1, b1, p1;	
Uint8	r2, g2, b2, p2;	
}GT3_Packet;

// quads
typedef struct
{
Uint16	vt0,vt1;
Uint16	vt2,vt3;
Uint8	r0, g0, b0, p0;	
Uint16	info,pad;
}F4_Packet;

typedef struct
{
Uint16	vt0,vt1;
Uint16	vt2,vt3;
Uint8	r0, g0, b0, p0;	
Uint8	r1, g1, b1, p1;	
Uint8	r2, g2, b2, p2;	
Uint8	r3, g3, b3, p3;	
Uint16	info,pad;
}GF4_Packet;


typedef struct
{
Uint16	vt0,vt1;
Uint16	vt2,vt3;
Uint8	u0,v0;
Uint16	clut;
Uint8	u1,v1;
Uint16	tpage;
Uint8	u2,v2;
Uint16	info;
Uint8	u3,v3;
Uint16	pad;
Uint8	r0, g0, b0, p0;	
}T4_Packet;

typedef struct
{
Uint16	vt0,vt1;
Uint16	vt2,vt3;
Uint8	u0,v0;
Uint16	clut;
Uint8	u1,v1;
Uint16	tpage;
Uint8	u2,v2;
Uint16	info;
Uint8	u3,v3;
Uint16	pad;
Uint8	r0, g0, b0, p0;	
Uint8	r1, g1, b1, p1;	
Uint8	r2, g2, b2, p2;	
Uint8	r3, g3, b3, p3;	
}GT4_Packet;

#endif