#define	SMARTYPANTS		0


#if SMARTYPANTS

// 8kb ram stack
//#define DCACHE_OFFSET       0x801F4FFC

#define DCACHE_OFFSET       0x1f8003fc

extern unsigned long dcacheShadow[];
extern unsigned long stackRamP;
extern unsigned long dcacheDirty;
extern unsigned long dcacheCount;

extern unsigned long _cachedata_size[];
extern unsigned long _cachedata_obj[];

#define	stackCache()	\
	{		\
	register u32 dc;	\
	register u32 *dst = dcacheShadow;	\
    register u32 *src = (u32 *)0x1f800300; \
    for(dc=0;dc<36;dc++)   \
		*dst++ = *src++;	\
	}		\
	stackRamP = SetSp(DCACHE_OFFSET)

#define	stackRam()	\
	SetSp(stackRamP);	\
	{		\
	register u32 dc;	\
	register u32 *src = dcacheShadow;	\
    register u32 *dst = (u32 *)0x1f800300; \
    for(dc=0;dc<36;dc++)   \
		*dst++ = *src++;	\
	}		
/*
#define	stackCache()	\
	EnterCriticalSection();	\
	{		\
	register u32 dc;	\
	register u32 *dst = dcacheShadow;	\
	register u32 *src = _cachedata_obj;	\
    register u32 n = (((u32)_cachedata_size)>>2); \
    for(dc=0;dc<n;dc++)   \
		*dst++ = *src++;	\
	}		\
	stackRamP = SetSp(DCACHE_OFFSET);	\
	ExitCriticalSection();

#define	stackRam()	\
	EnterCriticalSection();	\
	SetSp(stackRamP);	\
	ExitCriticalSection();	\
	{		\
	register u32 dc;	\
	register u32 *src = dcacheShadow;	\
	register u32 *dst = _cachedata_obj;	\
    register u32 n = (((u32)_cachedata_size)>>2); \
    for(dc=0;dc<n;dc++)   \
		*dst++ = *src++;	\
	}		
*/


#else

#define stackRam()
#define	stackCache()

#endif
