// all game info can(?) be devived from this information, and OBJ_players.
// some of this info needs to be saved to memory card.
// how does a game terminate and enter the frontend?

typedef struct{
   s8    language;            // NOTUSED
   s8    MEMCARD_ckeckok;     // NOTUSED
   s8    resolution;          // 0: 512*256 NOTUSED
   s8    numscreens;          // 1-4
   s8    numplayers;          // Number of human players 1 or 2, 0=demo
   s8    gametype;            // 0-battle 1-tourn 2-time 3-arcad
   s8    currlevel;           // 0-16.
   s8    mcurrlevel;          // 0b00000wll.
   s8    cheatingbastard;     // OFF/ON NOTUSED
   s8    arena_mode;          // 1 = in Arena, 0 = in Track section of game.NOTUSED
   s8    SOUND_musicvol;      // NOTUSED
   s8    SOUND_sfxvol;        // NOTUSED
   s8    stereo;              // NOTUSED
   s8    vsync;               // syncing to v-blank?
   s8    timebar;             // debug timing bar
   s8    res;                 // resolution
   s32   raceclock;           // (-n) = wait for start
   s8    lap;                 // lap 1-3
   s8    ctype[9];            // craft type
   //s32   finishtimes[track][laps][3];// NOTUSED plyr
   //s32   frag10times[];
   // u8 name[3]
   s32   score[9];
   s8    newvc;
   u8    padconfig;

   // Mats finished this level flag
   u8 finishedLevel;

	// number of players
	u8 wankers;
   u8 demomode;

	u8 rumble;

}STATESTRUCT;


extern   STATESTRUCT STATE;

void  STATE_initstatesonboot();

enum{
   GTbattle,
   GTtournament,
   GTtime,
   GTarcade
   };