//
// ACTION.H  -  Action replay header file
//
// Author: Mathew Twigg
// Created 24/03/1999
//

//#define	MAX_AR_FRAMES		(25)
#define	MAX_AR_FRAMES		(25*60)
//#define	MAX_AR_FRAMES		(25*60*30)

typedef struct
	{
//	u16 paddata[8];
    s32 G_cyc;
	STATESTRUCT STATE;
	u8 pType[8];
	int nPlayer;
	}AR_START;

typedef struct
	{
	u32 SIM_input_data;
	u32 SIM_input_push;
	u32 SIM_input_id;
	s8 SIM_input_an1x;
/*
	s8 SIM_input_an1y;
	s8 SIM_input_an2x;
	s8 SIM_input_an2y;
*/
	}AR_FRAME;

extern AR_START arInitialState;
extern AR_FRAME arBuffer[MAX_AR_FRAMES] [6];

extern vec32 arPos[MAX_AR_FRAMES];

extern u32 arIndex;
//extern APAD AR_PadData[8];
//extern APAD AR_PadData2[8];
extern u8 arState;

void arSaveInitialState(void);
void arStart(void);
void arRecord(void);
void arPlay(void);
void arRestoreInitialState(void);

enum{
	AR_INIT = 0,
	AR_RECORD = 1,
	AR_PLAY = 2,
	};

void arDebug(void);

typedef struct
	{
	OBJ_STRUCT s;
	OBJ_PLAYERSTRUCT p;
	s32 G_cyc;
	}ARDEB;
