/*
360 - Fade stuff
*/

#include <sys/types.h>
#include <libetc.h>
#include <libgte.h>
#include <libgpu.h>
#include <libgs.h>
#include <libsn.h>
#include <gtemac.h>
#include <inline_c.h>
#include <libsn.h>
#include <libgs.h>

#include "fade.h"

void SD_InitDraw();

#define u8 unsigned char
#include "hue.h"

extern GsOT *MWotPtr;
extern POLY_FT3 ft3;

signed short fadeValue;      // 255 = black, 0 = off

#if PAL
POLY_F4 fadePoly =
	{
	0x05000000,
	0,0,0,0x28,
	0-256  ,0-128,
	512-256,0-128,
	0-256  ,256-128,
	512-256,256-128
	};
#else
POLY_F4 fadePoly =
    {
	0x05000000,
	0,0,0,0x28,			// 0x28 | 0x02
	0-256  ,0-120,
	512-256,0-120,
	0-256  ,240-120,
	512-256,240-120
	};
#endif

void fade(void)
	{	
	if(!fadeValue)
		return;

/*
	static int f;
	f+=3;
	
    fadePoly.r0 = (newhue2rgb[f&0xff].r>>1);
    fadePoly.g0 = (newhue2rgb[f&0xff].g>>1);
    fadePoly.b0 = (newhue2rgb[f&0xff].b>>1);
*/
/*
    fadePoly.r0 = fadeValue;
    fadePoly.g0 = 0;//fadeValue;
    fadePoly.b0 = fadeValue;
*/
    fadePoly.r0 = fadeValue;
    fadePoly.g0 = fadeValue;
    fadePoly.b0 = fadeValue;

	setSemiTrans(&fadePoly,1);
	
    GsSortPoly(&fadePoly,MWotPtr,0);

	SetPolyFT3(&ft3);
	setSemiTrans(&ft3,1);
	
    ft3.x0 = -280;
	ft3.x1 = -278;
	ft3.x2 = -280;

    ft3.y0 = 0;
    ft3.y1 = 0;
    ft3.y2 = 5;
	
    ft3.tpage = GetTPage(0,2,0,0);
    ft3.clut = GetClut(0,0);

    GsSortPoly(&ft3,MWotPtr,0);
    }
/*
extern GsOT MWot[2];
extern int outbuf_idx;

void fade4(void)
	{
	RECT clip;

    fadePoly.r0 = fadeValue;
    fadePoly.g0 = fadeValue;
    fadePoly.b0 = fadeValue;

	SD_InitDraw();    // clear OT, reset GPU packet area pointer , set double buffer index
    GsSortPoly(&fadePoly,&MWot[outbuf_idx],0);
    VSync(0);
	DrawSync(0);

//	ResetGraph(1);	// new
//    GsSwapDispBuff();				// Swap double buffer

	POSITION.offy = 128;
	POSITION.offx = 256;
	GsSetDrawBuffOffset();
	clip.x = 0;
	clip.y = 0;
	clip.w = 512;
	clip.h = 256;
	GsSetClip(&clip);
	GsDrawOt(&MWot[outbuf_idx]);
    }
*/
