#include "mprintf.h"

/*typedef struct
{
	s32				id;
	s32				in_use;
	s32				timer;
	s32				fx_count;
	s32				total_fx;

	s32				level;
	s32				init_point1;
	s32				init_point2;
	s32				finished;
	s32				no_completed;
	s32				fx_id[4];

}FX_CTRL_STRUCT;
*/
typedef struct
{
	s32			type;
	s32			timer;
	s32			power;
	s16			quantity;
	s32			AI_index;

}OBJ_ATTRIB;//cheeky fucker with your dodgy indentations!


typedef struct
{
	s8		index;						//Index into pickup_list where current is held
	s8		current;					//type of currently selected weapon
	s8		total;
	s16		pickup_list[MAXPICKUPS];	//Array of pickups held by player
	s16		quantity[MAXPICKUPS];


}OBJ_PICKUP;


typedef	struct
	{
   u16      	index;   // 0-MAXNUMOBJECTS
   vec32    	p;       // position
   vec32       v;       // velocity
   vec16       r;       // euler orientation
   //vec16       w;       // ang vel
   u8          type;    // see OTtypes
   u8          stat;    // 0-unused:1-used
   u8          deleteme;// 0-ok:1-to be deleted eof frame
   s32      	m0;      // misc0
   s32      	m1;      // misc1
   s8       	owner;   // who created this object( 0-7 )
   u32         *link;    // colision grid link;
   s32         fx_id;   //id of fire structure child structure if present(EXP_FIRE_STRUCT)
   OBJ_ATTRIB	pkup_data;   //Pickup information, i.e. staus of torpedo etc...	Set ONLY if object
   							//is a pickup!
//   s32			sfx_true;
//   s32			fx_type;

//   FX_CTRL_STRUCT *ctrl_ptr;//for use when exploding default wepaons,

   }OBJ_STRUCT;      // ensure byte count /4 (use pad)

typedef struct {

s8				in_use;
s8				player_num;

s8				position;
s8				lap;
s16				kills;
u32				lap_time;
u32				total_time;

}PLAYER_STAT;

typedef	struct
	{
   u8    rendertype;    // facing sprite or sdmodelNOTUSEDYET
   u8    rendermodel;  // index of sprite/modelNOTUSEDYET
   u16   mass;          // mass ( moved from OBJ_STRUCT)NOTUSEDYET
   u32   coldim;        // size of collision sphere/ half width
   void  (*COL_pfunct)();
   }OBJ_TYPEINFO;

typedef	struct
	{
   u8          crafttype;
   s8          plyrnum;    //i.d. of player
   mat16       SIM_objmat; // rotation matrix for craft model
   mat16       dispmatrix;
   vec16       wvect;      // angular velocity axis
   s32         compold;    // ?
   s32         firerep;    // fire repeat counter
   s32         steerang;   // Dw/Dt
   s32         steervel;   // DwDw/Dt
   s32         latgrip;    // lateral grip val
   s32         latslip;    // lateral slip val
   s32         throttle;   // thrust
   s32         throttlevel;// Dthr/Dt
   s32         leno[4];    // spring len from old len
   vec32       oldp;       // ?
   u32         SIM_input_data;        // pad.data
   u32         SIM_input_push;   //oldpad.data( for debounce)
   u32         SIM_input_id;
   s8         SIM_input_an1x;
   s8         SIM_input_an1y;
   s8         SIM_input_an2x;
   s8         SIM_input_an2y;
   s32			speed;
   u8          stat;       // 0-unused:1-used NOTUSEDYET
   s16         stability;  // stability( used just after collision)
   OBJ_STRUCT  *pobj;      // pointer to graphic OBJ
   OBJ_PICKUP  pickups;	   //Data about pickups held by player currently.
   PLAYER_STAT	stats;

   s32			fx_timer;
   s32			shield_id;
   u8          weapon_level;        //power-up level for machine gun, 0-9
   s16		   ammo;
   s32		   armour_level;		//current level of armour
   s8			smoking;

	s32			shield_strength;
   s8          flamer_in_use;
   s8          plasma_in_use;
   s32         mode360;
   s32         ang360;
   s32         crossx360;
   u8          computer;   // 1=com 0=human 2=actionrep(?)
   s16         turbo;
   s16         rp0; // last    racepoint
   s16         rp1; // curr    racepoint
   s16         rp2; // next    racepoint
   s32		   timer;

   short	   hunting;
   short	   hunted;
   short	   no_enemys;

   u8		   collision_flag;

}OBJ_PLAYERSTRUCT;     // ensure byte count /4 (use pad)


extern	OBJ_PLAYERSTRUCT	OBJ_players[MAXNUMPLAYERS];
extern	OBJ_STRUCT			OBJ_objects[MAXNUMOBJS];
extern   OBJ_TYPEINFO      OBJ_typeinfo[];

void	OBJ_moveall();
s32	OBJ_newobj( s16 type );
void	OBJ_delobj( s32	n );
void  OBJ_initplayer( u16  n, u8 crtype, u8 computer );
void  OBJ_re_initplayer( u16  n, u8 crtype, u8 computer );
void  OBJ_initobjlist();
void  OBJ_delobjs();

void  OBJ_initobjarray(void);

void OBJ_damage_player(OBJ_PLAYERSTRUCT *plyr_ptr, OBJ_STRUCT *obj_ptr, s8 plasma);

// obj types( 3d model, sc fr facing spr, rot sprite,  line )
// generic object info()
//NOTE! change initialisation in  objects.c, if changing below!!
enum {
    /* 0*/  OTcraft,                 //0
	/* 1*/	OTpickup,
    /*13*/  OTbullet,
    /*14*/  OTtracer,
    /*15*/  OTrocket_set,
    /*16*/  OTrocket,
    /*17*/  OTtorpedo,
    /*18*/  OThigh_octane,
    /*19*/  OTmissile,
    /*20*/  OTmine,
    /*21*/  OTburst,
    /*22*/  OTshield,
    /*23*/  OTshield_effect,
    /*24*/  OTflame,
    /*25*/  OTcluster,
    /*26*/  OTfragment,
    /*27*/  OTgas,
    /*28*/  OTgas_cloud,
    /*29*/  OTlightning,
    /*30*/  OTion,
    /*31*/  OTexplosion_flame,
    /*32*/  OTexplosion_cluster,
    /*33*/  OTexplosion_gas,
    /*34*/  OTexplosion_lightning,
    /*35*/  OTexplosion_fire,
    /*36*/  OTexplosion,
    /*37*/  OTfog,
    /*38*/  OTsmoke_fx,
			OTstart_pt,
			OTlevel_fx
     };

// Rendering Type
enum{
   RTfsprite,
   RTeulemod,
   RTmatrmod,
   RTprecmat,
   RTnull
   };

// Collision Group
//#define   CGplayer (1 << 0)
//#define   CGpickup (1 << 1)
//#define   CGprojec (1 << 2)
//#define   CGnocoll (1 << 3)

enum{
   CGplayer,
   CGpickup,
   CGprojec,
   CGnocoll,
   CGflame
   };

extern int steer_mode;	// arse
extern s16   delobji;
extern s16   delobjl[50];
