///////////////////////////////////////////////////////////////////////////////////////////////
//		Sprite.
///////////////////////////////////////////////////////////////////////////////////////////////
//		Started:		3/9/98
//		Geeza:		J.coelho
//		PSX:			Yay
//		N64:			Nay.
//    Notes:      3d PSX sprite functions
///////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////
// Globals
///////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////
// Private
///////////////////////////////////////////////////////////////////////////////////////////////
#define  STsemitranson  (1<<30)
#define  ST8bitclut     (1<<24)

typedef	struct
		{
		u32	attr;
		u16	w;
		u16	h;
		u16	tpage;
	  	u16	u;
  	  	u16	v;
  	  	u16	cx;
  	  	u16	cy;
  	  	u8		r;
  	  	u8		g;
  	  	u8		b;
  	  	u16	mx;
  	  	u16	my;
  	  	u16	scalex;
  	  	u16	scaley;
		}SPR_INFO;

SPR_INFO SPR_sprite[10];
/*
SPR_info[ SPRplasma ].attr =
SPR_info[ SPRplasma ].w		=;
SPR_info[ SPRplasma ].h		=;
SPR_info[ SPRplasma ].tpage=;
SPR_info[ SPRplasma ].u		=;
SPR_info[ SPRplasma ].v		=;
SPR_info[ SPRplasma ].cx	=;
SPR_info[ SPRplasma ].cy	=;
SPR_info[ SPRplasma ].r		=;
SPR_info[ SPRplasma ].g		=;
SPR_info[ SPRplasma ].b		=;
SPR_info[ SPRplasma ].mx	=;
SPR_info[ SPRplasma ].my	=;
SPR_info[ SPRplasma ].scalex=;
SPR_info[ SPRplasma ].scaley=;
*/
///////////////////////////////////////////////////////////////////////////////////////////////
// Functions
///////////////////////////////////////////////////////////////////////////////////////////////

void	SPR_render3dsprite( s16 sx, s16 sy, s16 z, u16 sprnum )
	{
	SPR_INFO	*pspr	=	&SPR_info[ sprnum ] );

	sc	=	0x1fffff/z;
   RENDER_sprite.attribute =(1<<28) | (0<<24) | STsemitranson;
	RENDER_sprite.x	=sx0;
	RENDER_sprite.y	=sy0;
	RENDER_sprite.w	=64;
	RENDER_sprite.h	=64;
	RENDER_sprite.tpage=25;
	RENDER_sprite.u	=0;
  	RENDER_sprite.v	=0;
  	RENDER_sprite.cx	=512;
  	RENDER_sprite.cy	=253;
  	RENDER_sprite.r	=( hue2rgb[(G_cyc<<4)&255]     )&255;//lil endian!
  	RENDER_sprite.g	=( hue2rgb[(G_cyc<<4)&255]>>8  )&255;
  	RENDER_sprite.b	=( hue2rgb[(G_cyc<<4)&255]>>16 )&255;
  	RENDER_sprite.mx	=32;
  	RENDER_sprite.my	=32;
  	RENDER_sprite.scalex	=sc;
  	RENDER_sprite.scaley	=sc;
  	RENDER_sprite.rotate	=0;
	GsSortSprite( &RENDER_sprite, &Wot[outbuf_idx], z>>otzshift );
	}