#include <sys/types.h>
#include <stdio.h>
#include <libetc.h>	   
#include <libgte.h>	   
#include <libgpu.h>	   
#include <libgs.h>	   
#include <libsn.h>
#include <inline_c.h>
#include <libsnd.h>
#include <libspu.h>
#include <ctrller.h> 
#include <libpad.h>
#include <libapi.h>
#include <rand.h>

#include "header.h"
#include "loadit.h"
#include "text.h"
#include "psx\gpupsx.h"

extern GsOT *MWotPtr;

RGBP wTxtColour[5] =
	{
	{192,192,192},
	{220,220,0},
	{0,0,0},			// Hue ?
	{255,100,11}, //0,150,11},
    {255,100,11}
//	{96,96,96}
	};

void WTXT_init(void)
	{
	sprite.attribute = (1<<28)|(0<<24)|(1<<30); // (1<<27) ?
	sprite.tpage = WTXT_TPAGE;
	sprite.cx = 752;
	sprite.cy = 442;
	sprite.mx = 0;
	sprite.my = 0;
	sprite.scalex = 4096;
	sprite.scaley = 4096;
	sprite.rotate = 0;
	}

void WTXT_test(void)
	{
/*
    static WTXT w1 = {0,0,0,0,-230,-50,{"\01abcdefghijklmnopqrstuvwxyz","","","",""}};
    static WTXT w2 = {0,0,0,0,-230,-30,{"\01""0123456789","","","",""}};
    static WTXT w3 = {0,0,0,0,-230,-10,{"\01!%&*():'#.,<>-/?","","","",""}};
    static WTXT w4 = {0,0,0,0,-230, 10,{"\01\03\04\05\06\07\10\11\12\13\14\15\16\17\20\21\22\23\24\25\26","","","",""}};
    static WTXT w5 = {0,0,0,0,-230, 30,{"\02abcdefghijklmnopqrstu","","","",""}};
    static WTXT w6 = {0,0,0,0,-230, 50,{"\02vwxyzXOST.?!","","","",""}};
    static WTXT w7 = {0,0,0,0,-230, 70,{"\02""0123456789","","","",""}};

    static WTXT w8 = {0,0,0,0,0, -90,{"\01left","","","",""}};
    static WTXT w9 = {0,0,1,0,0, -80,{"\01right","","","",""}};
    static WTXT wa = {0,0,2,0,0, -70,{"\01center","","","",""}};

    static WTXT wb = {0,0,0,0,-230, 90,{"\01a\03b\04g\05i\06j\07k\08l\10q\11s\12t\13u\14","","","",""}};
    
	WTXT_print(&w1);
	WTXT_print(&w2);
	WTXT_print(&w3);
	WTXT_print(&w4);
	WTXT_print(&w5);
	WTXT_print(&w6);
	WTXT_print(&w7);

	WTXT_print(&w8);
	WTXT_print(&w9);
	WTXT_print(&wa);
	WTXT_print(&wb);
*/
	}

void WTXT_print(register WTXT *w)
	{
	int wbx[7];
	int wby[7];
	int wbb[7];
	int slen;
	
	register int px;
	register int i;
	register int x;
	register int y;
	register int s;

	if(w->wobble)
		{
		for(s=0;s<w->wobble;s++)
			{
			wbx[s] = WTXT_optirand(w->wRad);
			wby[s] = WTXT_optirand(w->wRad);
		
//            wbb[s] = ;
			}
		}

    wbb[0] = 88;
    wbb[1] = 64;
    wbb[2] = 40;
    wbb[3] = 16;

	x = 0;
    y = 0;
	s = 0;

	// Calculate length of string in pixels
	px = WTXT_optistrlen(w->txt[*Language]);
	if(w->align!=0)		// no need for left alignes stuff
	for(i=0;i<px;i++)
		{
		register int c;
		
        c = w->txt[*Language] [i];
		
		if(c==1)
			{
			s = 0;
			continue;
			}
		if(c==2)
			{
			s = 0;//1;
			continue;
			}

		if(c==' ')
			{
			if(s==0)
				x += 4;
			else
				x += 8;
			continue;
			}

		if(s==0)
			c = wTxtTableSm[c];
		else
			c = wTxtTableLg[c];

        x += wTxtChar[c].w + 2;
        }

    slen = x - 2;

	switch(w->align)
		{
		case 0:		// Left
			x = w->x;
			break;
		case 1:		// Right
			x = w->x - slen;
			break;
		case 2:		// Center
			x = w->x - (slen>>1);
			break;
		}

	y = w->y;
	s = 0;
	
	for(i=0;i<px;i++)
		{
		register int c;
		
        c = w->txt[*Language] [i];
        
		if(c==1)
			{
			s = 0;
			continue;
			}
		if(c==2)
			{
			s = 0;//1;
			continue;
			}

		if(c==' ')
			{
			if(s==0)
				x += 4;
			else
				x += 8;
			continue;
			}

		if(s==0)
			c = wTxtTableSm[c];
		else
			c = wTxtTableLg[c];

		if(w->wobble)
			{
			register int l;
			
	        sprite.w = wTxtChar[c].w;
	        sprite.h = wTxtChar[c].h;
	        sprite.u = wTxtChar[c].u;
	        sprite.v = wTxtChar[c].v;

			for(l=0;l<w->wobble;l++)
				{
                sprite.r = (wTxtColour[w->cIndex].r*wbb[l])>>8;
                sprite.g = (wTxtColour[w->cIndex].g*wbb[l])>>8;
                sprite.b = (wTxtColour[w->cIndex].b*wbb[l])>>8;
                sprite.x = x + wbx[l];
                sprite.y = y + wby[l] - ((sprite.h-1)>>1);
				if((c>=95)&&(c<113))
					sprite.y--;
	    	    GsSortFastSprite(&sprite,MWotPtr,0);
				}
			}
		else{
            sprite.w = wTxtChar[c].w;
	        sprite.h = wTxtChar[c].h;
	        sprite.u = wTxtChar[c].u;
	        sprite.v = wTxtChar[c].v;
	        sprite.r = wTxtColour[w->cIndex].r;
			sprite.g = wTxtColour[w->cIndex].g;
			sprite.b = wTxtColour[w->cIndex].b;
			sprite.x = x;
            sprite.y = y - ((sprite.h-1)>>1);
			if((c>=95)&&(c<113))
				sprite.y--;
            GsSortFastSprite(&sprite,MWotPtr,0);
			}
		
		x += sprite.w + 2;
        }
	}

int WTXT_optistrlen(register char *t)
	{
	register char *tp = t;
	register u32 r;
	while(*tp++);
	r = (u32)tp - (u32)t - 1;
	return (u16)r;
	}

u16 WTXT_optirand(register u16 b)
	{
	#if 0
	// Untested
	
	static int nBit = 0;
	static u16 randVal = 0;
	register u16 r;
	if(nBit>b)
		{
		r = randVal&((1<<b)-1);
		randVal >>= b;
		nBit -= b;
		return r;
		}
	if(nBit==b)
		{
		r = randVal&((1<<b)-1);
		randVal = (u16)rand();
		nBit = 16;
		return r;
		}
	randVal = (u16)rand();
	r = randVal&((1<<b)-1);
	randVal >>= b;
	nBit = 16 - b;
	return r;
	
	#else
	
//	return rand()&((1<<b)-1);
	return rand()%b;
	
	#endif
	}

WCHAR wTxtChar[115] =
	{
	// 0
	// Small font, a-z
    {0,150,11,9},
    {16,150,11,9},
    {32,150,11,9},
    {48,150,11,9},
    {64,150,11,9},
    {80,150,6,9},
    {88,150,11,9},
    {104,150,11,9},
    {120,150,2,9},
    {128,150,6,9},
    {136,150,11,9},
    {152,150,2,9},
    {160,150,16,9},
    {176,150,11,9},
    {192,150,11,9},
    {208,150,11,9},
    {224,150,11,9},
    {240,150,6,9},
    {0,159,11,9},
    {16,159,7,9},
    {24,159,11,9},
    {40,159,11,9},
    {56,159,13,9},
    {72,159,11,9},
    {88,159,11,9},
    {104,159,11,9},
    
	// 26
	// Small font, 0-9
    {120,159,11,9},
    {136,159,2,9},
    {144,159,11,9},
    {160,159,11,9},
    {176,159,11,9},
    {192,159,11,9},
    {208,159,11,9},
    {224,159,11,9},
    {240,159,11,9},
    {0,168,11,8},
    
	// 36
	// Small font, !%&*():'#.,<>-/?
    {16,168,2,8},
    {24,168,10,8},
    {40,168,11,8},
    {56,168,10,8},
    {72,168,4,8},
    {80,168,4,8},
    {88,168,2,8},
    {96,168,2,8},
    {104,168,13,8},
    {120,168,2,8},
    {128,168,2,8},
    {136,168,9,8},
    {152,168,9,8},
    {168,168,7,8},
    {176,168,8,8},
    {184,168,11,8},
    
	// 52
    // Big font, 0-9
    {0,176,23,13},
    {24,176,4,13},
    {32,176,24,14},
    {56,176,24,14},
    {80,176,26,14},
    {112,176,25,14},
    {144,176,25,14},
    {176,176,24,14},
    {200,176,23,14},
    {224,176,24,14},

	// 62
    // Big font, a-z
    {0,192,21,16},
    {24,192,21,16},
    {48,192,21,16},
    {72,192,21,16},
    {96,192,21,16},
    {120,192,10,16},
    {136,192,21,16},
    {160,192,21,16},
    {184,192,4,16},
    {192,192,10,16},
    {208,192,17,16},
    {232,192,4,16},
    {0,208,28,16},
    {32,208,20,16},
    {56,208,20,16},
    {80,208,21,16},
    {104,208,21,16},
    {128,208,10,16},
    {144,208,19,16},
    {168,208,12,16},
    {184,208,21,16},
    {208,208,22,16},
    {0,224,29,16},
    {32,224,21,16},
    {56,224,21,16},
    {80,224,22,16},

	// 88
    // Big font, .?!
    {104,224,4,16},
    {112,224,16,16},
    {0,239,4,16},
    
	// 91
	// Psx, (x)(o)(s)(t)
    {131,227,25,17},
    {163,227,25,17},
    {195,227,25,17},
    {227,227,25,17},
    
	// 95
	// Foreign (18)
    {56,240,11,8},
    {72,240,11,8},
    {88,240,11,8},
    {56,247,11,9},
    {72,247,11,9},
    {88,247,11,9},
    {104,247,11,9},
    {120,247,4,9},
    {128,247,11,9},
    {144,247,11,9},
    {160,247,11,9},
    {176,247,9,9},
    {192,247,11,9},
    {208,247,11,9},
    {224,247,11,9},
    {240,247,4,9},
    {248,247,4,9},
	{104,240,11,8},
	
	// 113
	// Special: end + del
    {136-128,239,20,16},
	{160-128,239,20,16}
	};

u8 wTxtTableLg[256] =
	{
    /* . */ 0,
    /*  */ 0,  // Control
    /*  */ 0,  // Control
    /*  */ 64, // 95,
    /*  */ 74, // 96,
    /*  */ 66, // 97,
    /*  */ 66, // 98,
    /*  */ 62, // 99,
    /* . */ 82, // 100,
    /* . */ 62, // 101,
    /* . */ 70, // 102,
    /*  */ 76, // 103,
    /*  */ 62, // 104,
    /*  */ 76, // 105,
    /*  */ 106, // 106,
    /*  */ 82, // 107,
    /*  */ 62, // 108,
    /*  */ 82, // 109,
    /*  */ 70, // 110,
    /*  */ 76, // 111,
    /*  */ 66, // 112,
    /*  */ 113, // 113,
    /*  */ 114, // 114,
    
    /*  */ 0,
    /* . */ 0,
    /* . */ 0,
    /* . */ 0,
    /* . */ 0,
    /*  */ 0,
    /*  */ 0,

    /*  */ 0,
    /*  */ 0,
    /*   */ 0,
    /* ! */ 90,
    /* " */ 0,
    /* # */ 0,
    /* $ */ 0,
    /* % */ 0,
    /* & */ 0,
    /* ' */ 0,
    /* ( */ 0,
    /* ) */ 0,
    /* * */ 0,
    /* + */ 0,
    /* , */ 0,
    /* - */ 0,
    /* . */ 88,
    /* / */ 0,
    /* 0 */ 52,
    /* 1 */ 53,
    /* 2 */ 54,
    /* 3 */ 55,
    /* 4 */ 56,
    /* 5 */ 57,
    /* 6 */ 58,
    /* 7 */ 59,
    /* 8 */ 60,
    /* 9 */ 61,
    /* : */ 0,
    /* ; */ 0,
    /* < */ 0,
    /* = */ 0,
    /* > */ 0,
    /* ? */ 89,
    /* @ */ 0,
    /* A */ 0,
    /* B */ 0,
    /* C */ 0,
    /* D */ 0,
    /* E */ 0,
    /* F */ 0,
    /* G */ 0,
    /* H */ 0,
    /* I */ 0,
    /* J */ 0,
    /* K */ 0,
    /* L */ 0,
    /* M */ 0,
    /* N */ 0,
    /* O */ 92,
    /* P */ 0,
    /* Q */ 0,
    /* R */ 0,
    /* S */ 93,
    /* T */ 94,
    /* U */ 0,
    /* V */ 0,
    /* W */ 0,
    /* X */ 91,
    /* Y */ 0,
    /* Z */ 0,
    /* [ */ 0,
    /* \ */ 0,
    /* ] */ 0,
    /* ^ */ 0,
    /* _ */ 0,
    /* ` */ 0,
    /* a */ 62,
    /* b */ 63,
    /* c */ 64,
    /* d */ 65,
    /* e */ 66,
    /* f */ 67,
    /* g */ 68,
    /* h */ 69,
    /* i */ 70,
    /* j */ 71,
    /* k */ 72,
    /* l */ 73,
    /* m */ 74,
    /* n */ 75,
    /* o */ 76,
    /* p */ 77,
    /* q */ 78,
    /* r */ 79,
    /* s */ 80,
    /* t */ 81,
    /* u */ 82,
    /* v */ 83,
    /* w */ 84,
    /* x */ 85,
    /* y */ 86,
    /* z */ 87,
    /* { */ 0,
    /* | */ 0,
    /* } */ 0,
    /* ~ */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /* . */ 0
    };

u8 wTxtTableSm[256] =
	{
    /* . */ 0,
    /*  */ 0,  // Control
    /*  */ 0,  // Control
    /*  */ 95,
    /*  */ 96,
    /*  */ 97,
    /*  */ 98,
    /*  */ 99,
    /* . */ 100,
    /* . */ 101,
    /* . */ 102,
    /*  */ 103,
    /*  */ 104,
    /*  */ 105,
    /*  */ 106,
    /*  */ 107,
    /*  */ 108,
    /*  */ 109,
    /*  */ 110,
    /*  */ 111,
    /*  */ 112,
    /*  */ 113,
    /*  */ 114,
	
    /*  */ 0,
    /* . */ 0,
    /* . */ 0,
    /* . */ 0,
    /* . */ 0,
    /*  */ 0,
    /*  */ 0,

    /*  */ 0,
    /*  */ 0,
    /*   */ 0,
    /* ! */ 36,
    /* " */ 0,
    /* # */ 44,
    /* $ */ 0,
    /* % */ 37,
    /* & */ 38,
    /* ' */ 43,
    /* ( */ 40,
    /* ) */ 41,
    /* * */ 39,
    /* + */ 0,
    /* , */ 46,
    /* - */ 49,
    /* . */ 45,
    /* / */ 50,
    /* 0 */ 26,
    /* 1 */ 27,
    /* 2 */ 28,
    /* 3 */ 29,
    /* 4 */ 30,
    /* 5 */ 31,
    /* 6 */ 32,
    /* 7 */ 33,
    /* 8 */ 34,
    /* 9 */ 35,
    /* : */ 42,
    /* ; */ 0,
    /* < */ 47,
    /* = */ 0,
    /* > */ 48,
    /* ? */ 51,
    /* @ */ 0,
    /* A */ 0,
    /* B */ 0,
    /* C */ 0,
    /* D */ 0,
    /* E */ 0,
    /* F */ 0,
    /* G */ 0,
    /* H */ 0,
    /* I */ 0,
    /* J */ 0,
    /* K */ 0,
    /* L */ 0,
    /* M */ 0,
    /* N */ 0,
    /* O */ 92,
    /* P */ 0,
    /* Q */ 0,
    /* R */ 0,
    /* S */ 93,
    /* T */ 94,
    /* U */ 0,
    /* V */ 0,
    /* W */ 0,
    /* X */ 91,
    /* Y */ 0,
    /* Z */ 0,
    /* [ */ 0,
    /* \ */ 0,
    /* ] */ 0,
    /* ^ */ 0,
    /* _ */ 0,
    /* ` */ 0,
    /* a */ 0,
    /* b */ 1,
    /* c */ 2,
    /* d */ 3,
    /* e */ 4,
    /* f */ 5,
    /* g */ 6,
    /* h */ 7,
    /* i */ 8,
    /* j */ 9,
    /* k */ 10,
    /* l */ 11,
    /* m */ 12,
    /* n */ 13,
    /* o */ 14,
    /* p */ 15,
    /* q */ 16,
    /* r */ 17,
    /* s */ 18,
    /* t */ 19,
    /* u */ 20,
    /* v */ 21,
    /* w */ 22,
    /* x */ 23,
    /* y */ 24,
    /* z */ 25,
    /* { */ 0,
    /* | */ 0,
    /* } */ 0,
    /* ~ */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /*  */ 0,
    /* . */ 0
    };
