#define	WTXT_TPAGE		26

typedef struct
	{
	u8 r;
	u8 g;
	u8 b;
	u8 pad;
	}RGBP;

typedef struct
	{
	u8 cIndex;			// Index into wTxtColour[]
    u8 wRad;            // Radius of wobble
	u8 align;			// Alignment: 0=L, 1=R, 2=C
	u8 wobble;			// Wobble flag
	u16 x;				// Screen x pos
	u16 y;				// Screen y pos   (0,0=center of screen)
    char *txt[6];       // Text pointer  0-Eng 1-Fre 2-Ger 3-Span 4-Ita 5-Swed
    }WTXT;

typedef struct
	{
	u8 u;
	u8 v;
	u8 w;
	u8 h;
	}WCHAR;

extern WCHAR wTxtChar[];
extern RGBP wTxtColour[];
extern u8 wTxtTableSm[];
extern u8 wTxtTableLg[];

void WTXT_print(register WTXT *w);
u16 WTXT_optirand(register u16 b);
int WTXT_optistrlen(register char *t);

void WTXT_test(void);

void WTXT_init(void);

