#include <stdio.h>
#include <sys/types.h>
#include <libetc.h>
#include <libgte.h>
#include <libgpu.h>
#include <libgs.h>
#include <libsn.h>
#include <gtemac.h>
#include <inline_c.h>
#include <ctrller.h>
#include	<libmath.h>

#include "frontend.h"
#include	"rand.h"
#include "sdlib\sdfunc.h"
#include	"header.h"
#include	"render.h"
#include "frontend.h"
#include "psx\mathpsx.h"
#include "psx\gpuPSX.h"
#include "gameloop.h"
#include	"objects.h"
#include	"sim.h"
#include	"mesh.h"
#include	"camera.h"
#include	"collide.h"
#include "state.h"
#include "hue.h"
#include "psx\textPSX.h"
#include "version.h"
#include "water.h"
#include "psx\gpupsx.h"
#include "wake.h"
#include "menu.h"
#include "s2.h"

#define FASTMODE	0

///////////////////////////////////////////////////////////////////////////////////
// 360. SmartDog PSX version started 8/6/'98
// Guilty person  : Mongletonjongopoon
// Notes:    chamaaawf. bitch flavour cheese
//	render.c
///////////////////////////////////////////////////////////////////////////////////
extern   void  GPU_halfcls( u8  );
extern   void  GPU_highlightgrid( s16 x,s16 z, u8 r, u8 g, u8 b );
extern   GsOT        *ptrwot;//jof
#if   JON
s8    TWEAK_cgrid=1;
#else
s8    TWEAK_cgrid=0;
#endif
void  RENDER_debmodel( u32 model, u32 subobj );
void  RENDER_fog( vec32 *pos );
void  RENDER_thrusters();
void  RENDER_swirl();
void  RENDER_rain();
void  RENDER_jellypoly4( s16 xa0,s16 ya0, s16 xa1,s16 ya1, s16 xa2,s16 ya2, s16 xa3,s16 ya3,
                         s16 xb0,s16 yb0, s16 xb1,s16 yb1, s16 xb2,s16 yb2, s16 xb3,s16 yb3);
extern   void  RENDER_rtext();
void  RENDER_321go();
s32      R_drawtime;
mat16   t;
mat16   objm;
vec32 	scl;

void  GPU_drawdebgrid();
void  RENDER_crosshair();
void  GPU_plot( s16 x,s16 z, u8 r, u8 g, u8 b );

s32	anrendermodelstart;
s32	anrendermodelend;

extern int vs_f_upd_track;
extern int vs_f_upd_wake;
extern int vs_f_upd_obj;

// model ref
u8 RENDER_reflection[17]={ 1,1,1,1, //water
                           1,1,1,1, //ice
                           1,1,1,1, //seabed
                           1,1,1,1, //lava
                           1};      //jungle

// backdrop ref
u8 RENDER_refback[17]   ={ 0,0,0,0, //water
                           1,1,1,1, //ice
                           0,0,1,1, //seabed
                           1,1,1,1, //lava
                           1};      //jungle

//temp
s32	seg[10];
s32	oseg;

s32      RENDER_maxx, RENDER_minx, RENDER_xdiff=17000;
s32      RENDER_maxz, RENDER_minz, RENDER_zdiff=17000;

OBJ_STRUCT        *pobj;
vec32            pos;

vec16 RENDER_thrusterpos[10][2]={
   //TOP/BOT
   {{30, 30, -100},  {0,-40,64}},       //0
   {{35,50,-100},    {35,-50,-100}},    //1
   {{0,25,-75},      {0,0,0}},        //2
   {{35, 10,-80},    {35,-30,70}},     //3
   {{23, 30,-60},    {0,0,0}},         //4
   {{67,-20, -10},   {32,-20,-60}},    //5
   {{0,0,-130},      {15,-11,-140}},   //6
   {{48,40,-60},     {0,0,0}},         //7
   {{36,8,-70},      {0,0,0}},         //8
   {{35,2,-65},      {0,0,0}} };


s16   robjlist[60];
s16   robjlisti;

extern   int   FarZDist;

s32   RENDER_rlestart[32*32];
u8    RENDER_rledata[25*1024] ;

s32   anrendertrackstart;
s32   anrendertrackend;

void	RENDER_update()
	{
	int		f, g;// i, j;
	vec16 	rot;
//   vec16    pos16;
	vec32		t;


///////////////////////////////////////////////////////////////////////////////////
// print track
///////////////////////////////////////////////////////////////////////////////////

   t.vx  =  CAM_camp[CAM_c].vx;
   t.vy  =  CAM_camp[CAM_c].vy;
   t.vz  =  CAM_camp[CAM_c].vz;

	// print local segs
   rot.vx =( CAM_came[CAM_c].vx )>>4;      // change 0x10000=360 to 0x1000=360
   rot.vy =( CAM_came[CAM_c].vy )>>4;
   rot.vz =( CAM_came[CAM_c].vz )>>4;
   vrotmatrix( &rot,&CAM_camm[CAM_c] );
   //vrotmatrix2( &rot,&CAM_camm[CAM_c] );

   vapplymatrix32( &CAM_camm[CAM_c], &t, &t );
   t.vx   =  (t.vx*25)>>4;//aspect correct

   CAM_camm[CAM_c].m[0][0]  =  ( CAM_camm[CAM_c].m[0][0]*25 )>>4;//aspect fix
   CAM_camm[CAM_c].m[0][1]  =  ( CAM_camm[CAM_c].m[0][1]*25 )>>4;//aspect fix
   CAM_camm[CAM_c].m[0][2]  =  ( CAM_camm[CAM_c].m[0][2]*25 )>>4;//aspect fix
   CAM_camm[CAM_c].t[0]  =  -t.vx;
   CAM_camm[CAM_c].t[1]  =  -t.vy;
   CAM_camm[CAM_c].t[2]  =  -t.vz;
   //{
   //vec32 scale={8000,8000,8000};
   //vscalematrix( &CAM_camm.m , &scale  );
   //}
   vsetrotmatrix( &CAM_camm[CAM_c] );
   vsettransmatrix( &CAM_camm[CAM_c] );
   robjlisti=0;

   anrendertrackstart=999;
#if !CDMASTER
   if( SD_PadData[0].push&PAD_FLT)STATE.newvc=1-STATE.newvc;
#endif
if(STATE.newvc==0)
   {// viewcone
   OBJ_STRUCT  *pobj;
   s16   vcleftx=0, vcleftz=64;
   s16   vcnormleftx, vcnormleftz;
   s16   vcrightx=0, vcrightz=64;
   s16   vcnormrightx, vcnormrightz;

   s16   backx=0, backz= 6000;
   const u16   vd=8;// viewcone len in gridunits
   s32   gx, x, lx;
   s32   gz, z, lz;
   vec32 v0,v1;
//   s32   len;
   vec16 camp;
//   s32   xx,zz;
   s32   xx_nlx, xx_nrx;
   s32   zz_nlz, zz_nrz;

   s32   Dzz_nlz, Azz_nlz;
   s32   Dzz_nrz, Azz_nrz;

   s32   DDzz_nlz, AAzz_nlz;
   s32   DDzz_nrz, AAzz_nrz;

   camp.vx  =  CAM_camp[CAM_c].vx;//cam position
   camp.vy  =  CAM_camp[CAM_c].vy;
   camp.vz  =  CAM_camp[CAM_c].vz;

   vrot( &vcleftx, &vcleftz, -7000  -CAM_came[CAM_c].vy);//rotate by inverse camera y
   vrot( &vcrightx, &vcrightz, 7000 -CAM_came[CAM_c].vy);
   vrot( &backx, &backz, -CAM_came[CAM_c].vy);

   vcnormleftx =  +vcleftz;
   vcnormleftz =  -vcleftx;
   vcnormrightx =  -vcrightz;
   vcnormrightz =  +vcrightx;

   gx  =  (( camp.vx+32768)*MESH_xgridnum)>>16;
   gz  =  ((-camp.vz+32768)*MESH_zgridnum)>>16;

   x  =  (( camp.vx+32768)*MESH_xgridnum)>>13;
   z  =  ((-camp.vz+32768)*MESH_zgridnum)>>13;

   //GPU_plot( x,z,0xff,0xff,0xff );
   lx =  0;
   lz =  10;

   //GPU_line( x, z, x+lx, z-lz );
   //GPU_line( x, z, x+(vcleftx>>4), z-(vcleftz>>4) );
   //GPU_line( x, z, x+(vcrightx>>4), z-(vcrightz>>4) );

      AAzz_nlz= (gz-vd)*vcnormleftz*-MESH_zgridsize
                + vcnormleftz*((-MESH_zgridsize>>1) + 32768 - camp.vz + backz);
      DDzz_nlz= vcnormleftz*-MESH_zgridsize;

      AAzz_nrz= (gz-vd)*vcnormrightz*-MESH_zgridsize
                + vcnormrightz*((-MESH_zgridsize>>1) + 32768 - camp.vz + backz);
      DDzz_nrz= vcnormrightz*-MESH_zgridsize;

   for(f=gx-vd;f<=gx+vd;f++)
      {
      //xx_nlx = vcnormleftx * (f* MESH_xgridsize + ( MESH_xgridsize>>1) - 32768 - camp.vx + backx);
      //xx_nrx = vcnormrightx * (f* MESH_xgridsize + ( MESH_xgridsize>>1) - 32768 - camp.vx + backx);

      xx_nlx = vcnormleftx * ((f<<11) + ( MESH_xgridsize>>1) - 32768 - camp.vx + backx);
      xx_nrx = vcnormrightx * ((f<<11) + ( MESH_xgridsize>>1) - 32768 - camp.vx + backx);

      Azz_nlz= AAzz_nlz;
      Dzz_nlz= DDzz_nlz;
      Azz_nrz= AAzz_nrz;
      Dzz_nrz= DDzz_nrz;

      for(g=gz-vd;g<=gz+vd;g++)
         {
         if( (f>=0) && (f<MESH_xgridnum) && (g>=0) && (g<MESH_zgridnum) )
            {
            zz_nlz=Azz_nlz;
            zz_nrz=Azz_nrz;

            if( (xx_nlx + zz_nlz > 0) &&
                (xx_nrx + zz_nrz > 0) )
               {
               //GPU_highlightgrid( f,g, 0, 0 ,0xff );
               if(MESH_map[g][f]!=0xffffffff)
                  {
#if !FASTMODE
                  GPU_rendersdtrackseg( MESH_map[g][f] );
#else
				if(G_cyc>1100)
                  GPU_rendersdtrackseg( MESH_map[g][f] );
#endif
                  }

               if(MESH_mapref[g][f]!=0xffffffff)
                  {
#if !FASTMODE
                  if( RENDER_reflection[STATE.currlevel] && (STATE.numscreens==1) )
                     GPU_rendersdtracksegref( MESH_mapref[g][f] );
#else
				if(G_cyc>1100)
                  if( RENDER_reflection[STATE.currlevel] && (STATE.numscreens==1) )
                     GPU_rendersdtracksegref( MESH_mapref[g][f] );
#endif
                  }
               // add objects to list
               pobj  = (OBJ_STRUCT *) COL_oocgrid[g][f];
               // walk linked list until end
               while( pobj != 0 )
                  {
                  robjlist[robjlisti++]   =  pobj->index;
                  if(robjlisti==61)
                     {
                     FntPrint("too many objects \n");
                     robjlisti=60;
                     }
                  pobj = (OBJ_STRUCT *) pobj->link;
                  }
               // add objects to list
               }
            }
         Azz_nlz+=Dzz_nlz;
         Azz_nrz+=Dzz_nrz;
         }
      }

   v0.vx =  OBJ_objects[0].p.vx>>8;
   v0.vy =  OBJ_objects[0].p.vy>>8;
   v0.vz =  OBJ_objects[0].p.vz>>8;
   v1.vx =  (OBJ_objects[0].p.vx>>8)+100;
   v1.vy =  (OBJ_objects[0].p.vy>>8);
   v1.vz =  (OBJ_objects[0].p.vz>>8)+100;
   GPU_3dline( &v0, &v1,0xff,0,0 );
   }
else
   {//rle viewcone
   register s16   cx,cz;
   register s16   vx,vz;
   OBJ_STRUCT  *pobj;
   s16   vcleftx=0, vcleftz=64;
   s16   vcnormleftx, vcnormleftz;
   s16   vcrightx=0, vcrightz=64;
   s16   vcnormrightx, vcnormrightz;
   s16   backx=0, backz= 6000;
   u32   seg   =  38;   // the camera segment
   u8    *prle;         // pointer to start of respecive rle
   s8    stat=0;
   s16   runlen;
   s16   i;
   s32   cnt;
   s32   visleft  =  32*32;
   u32   vseg=0;

   //FntPrint("\n\n\n\n\nnewvc\n");

//      vrot( &vcleftx, &vcleftz, -7000  +CAM_came[CAM_c].vy);//rotate by inverse camera y
//      vrot( &vcrightx, &vcrightz, 7000 +CAM_came[CAM_c].vy);
      vrot( &vcleftx, &vcleftz, -6000  +CAM_came[CAM_c].vy);//rotate by inverse camera y
      vrot( &vcrightx, &vcrightz, 6000 +CAM_came[CAM_c].vy);
      vrot( &backx, &backz, -CAM_came[CAM_c].vy);

      vcnormleftx =  +vcleftz;
      vcnormleftz =  -vcleftx;
      vcnormrightx =  -vcrightz;
      vcnormrightz =  +vcrightx;

      cx    =  R2CGX( (CAM_camp[CAM_c].vx)<<8 );
      cz    =  R2CGZ( (CAM_camp[CAM_c].vz)<<8 );
#if !CDMASTER
      FntPrint("GX(%d) GZ(%d)\n", cx, cz);
#endif
      //GPU_highlightgrid(cx,cz,255,200,220);
      if( (cx<0) || (cx>31) || (cz<0) || (cz>31) )
         {
         printf("camera out of bounds. Gonna chop your willy off!\n");
         cx=cz=0;
         }

      seg   =   cx + (cz<<5);

      cx    =  R2CGX( (CAM_camp[CAM_c].vx-backx)<<8 );
      cz    =  R2CGZ( (CAM_camp[CAM_c].vz-backz)<<8 );
      //GPU_highlightgrid(cx,cz,255,200,220);

      if( RENDER_rlestart[seg] != -1 )
         {
         prle  =  RENDER_rledata + RENDER_rlestart[seg];
         cnt   =  0;

         while(visleft>0)
            {
            runlen   =  *prle++;
            if(runlen==0)//extend code
               {
               runlen   = (*prle++);
               runlen   +=  (*prle++)<<8;
               }

            if(cnt==0)
               {
               cnt++;
               runlen--;
               visleft--;
               }

            if(stat)
               {
               for(i=0;i<runlen;i++, visleft-- )
                  {
                  vx    =  vseg&31;
                  vz    =  vseg>>5;
                  if( ((vx-cx)*vcnormleftx  + (vz-cz)*vcnormleftz  <0 ) &&
                      ((vx-cx)*vcnormrightx + (vz-cz)*vcnormrightz <0 ) )
                     {
                     //GPU_highlightgrid(vseg&31,vseg>>5,0,200,220);

                     // add objects to list
                     pobj  = (OBJ_STRUCT *) COL_oocgrid[vz][vx];
                     // walk linked list until end
                     while( pobj != 0 )
                        {
                        robjlist[robjlisti++]   =  pobj->index;
                        if(robjlisti==61)
                           {
                           FntPrint("too many objects \n");
                           robjlisti=60;
                           }
                        pobj = (OBJ_STRUCT *) pobj->link;
                        }
                     // add objects to list

                     if( *( (u32*)MESH_map+vseg) !=0xffffffff)
                        {
                        GPU_rendersdtrackseg( *((u32*)MESH_map+vseg) );
                        }

                     if( RENDER_reflection[STATE.currlevel] && STATE.numscreens==1 )
                        if( *( (u32*)MESH_mapref+vseg) !=0xffffffff )
                           GPU_rendersdtracksegref( *( (u32*)MESH_mapref+vseg) );
                     }
                  vseg++;
                  cnt++;
                  }
               }
            else
               {
               visleft  -= runlen;
               vseg     += runlen;
               cnt      += runlen;
               }
            stat  =  1-stat;
            }
         //U_print("visleft (%d)\n", visleft);
         }
   }

   anrendertrackend=999;

vs_f_upd_track = GsGetVcount();

	if(execGame)
		WAKE_process();
	WAKE_draw();

vs_f_upd_wake = GsGetVcount();

///////////////////////////////////////////////////////////////////////////////////
// print objects
///////////////////////////////////////////////////////////////////////////////////
   //pobj  =  OBJ_objects;
   //for(f=0;f<MAXNUMOBJS;f++,pobj++)
   for(g=0;g<robjlisti;g++)
		{
      u16   plr=0;
      u16   rtype;
      u16   roti;

      pobj  =  &OBJ_objects[ robjlist[g] ];
      f  =  pobj->index;


      if( pobj->stat==OFF )continue;//object switched off
      //if( (f==0) && (CAM_c==0) && (STATE.numscreens==2) )continue;// firdt person
      //if( (f==1) && (CAM_c==1) && (STATE.numscreens==2) )continue;// firdt person
      if( (f==0) && (CAM_c==0) && (CAM_cammode[0]==2))continue;// firdt person

		// check roughly near camera
      //if( (pobj->p.vx>>8) > RENDER_maxx )continue;
      //if( (pobj->p.vx>>8) < RENDER_minx )continue;
      //if( (pobj->p.vz>>8) > RENDER_maxz )continue;
      //if( (pobj->p.vz>>8) < RENDER_minz )continue;

      rtype =  OBJ_typeinfo[ pobj->type ].rendertype;

      if(   rtype==RTeulemod||// sdmodel
            rtype==RTmatrmod||
            rtype==RTprecmat)
         {
         // find origin w.r.t camera

         pos.vx   =  (OBJ_objects[f].p.vx>>8);
         pos.vy   =  (OBJ_objects[f].p.vy>>8);
         pos.vz   =  (OBJ_objects[f].p.vz>>8);

         sub( pos, CAM_camp[CAM_c] );
         //vsetrotmatrix( &CAM_camm[CAM_c]);
         vapplymatrix32( &CAM_camm[CAM_c], &pos, &pos );
         //pos.vx   =  (pos.vx*25)>>4;//aspect correct

         //if( pos.vz >8000 )continue;
         // prepare rotation matrix
         switch( rtype )
            {
            case  RTeulemod   ://euler angles
                     {
                     rot.vx =( OBJ_objects[f].r.vx )>>4;    // change 0x10000=360 to 0x1000=360
                     rot.vy =( OBJ_objects[f].r.vy )>>4;
                     rot.vz =( OBJ_objects[f].r.vz )>>4;
                     vrotmatrix( &rot, &objm );
                     vmulmatrix2( &CAM_camm[CAM_c], &objm );
                     break;
                     }
            case  RTmatrmod   :// matrix
                     {
                     plr   =  OBJ_objects[f].owner;
                     memcpy( objm.m, OBJ_players[ plr ].SIM_objmat.m, 18  );
                     if(OBJ_players[plr].mode360==2)
                        {
                        mat16    mat;
                        vec16    rot;

                        rot.vx   =  0;
                        rot.vy   =  2048;
                        rot.vz   =  0;
                        vrotmatrix( &rot, &mat );
                        vmulmatrix2( &mat,&objm );
                        }

                     vmulmatrix2( &CAM_camm[CAM_c], &objm );
                     break;
                     }
            case  RTprecmat   ://pre-calculated matrix
                     {
                     roti         = (( CAM_came[CAM_c].vy>>10 )+( OBJ_objects[f].r.vy>>10 ))&63;
                     memcpy( objm.m, CAM_yrotmat[ roti ].m, 18  );
                     break;
                     }
            default  :  break;
            }

	  		////////////////////////////////////

         // render model
				{
            objm.t[0] =pos.vx ;  objm.t[1] =pos.vy ;  objm.t[2] =pos.vz ;
            vsetrotmatrix( &objm );
            vsettransmatrix( &objm );

            switch(OBJ_objects[f].type)
               {
               case OTcraft:
                  if( !(((CAM_c==0)&&(f==0)&&(OBJ_players[plr].mode360==2)) ||
                        ((CAM_c==1)&&(f==1)&&(OBJ_players[plr].mode360==2)) ))

                  //if( (OBJ_players[plr].mode360!=2) )// WRONG!
                     {
#if !FASTMODE
                     if( ((f==0) && (CAM_c==0)) ||
                         ((f==1) && (CAM_c==1)) )
                        // norm mod
                        GPU_rendersdmodel( crafts[ OBJ_players[OBJ_objects[f].owner].crafttype].model, 0 );
                     else
                        // mip mod
                      GPU_rendersdmodel( 6 + OBJ_players[OBJ_objects[f].owner].crafttype, 0 );

#else

				if(G_cyc>1100)
					{
                     if( ((f==0) && (CAM_c==0)) ||
                         ((f==1) && (CAM_c==1)) )
                        // norm mod
                        GPU_rendersdmodel( crafts[ OBJ_players[OBJ_objects[f].owner].crafttype].model, 0 );
                     else
                        // mip mod
                      GPU_rendersdmodel( 6 + OBJ_players[OBJ_objects[f].owner].crafttype, 0 );
					}
#endif

                     RENDER_thrusters();

//                   doWake(f);
                     }
                     break;

               case OTcluster:
                     scl.vx   =  0x4000;
                     scl.vy   =  0x4000;
                     scl.vz   =  0x4000;
                     vscalematrix( &objm,&scl );
                     GPU_rendersdmodel( 16,  0 ); break ;
               case OTfragment:
                     scl.vx   =  0x4000;
                     scl.vy   =  0x4000;
                     scl.vz   =  0x4000;
                     vscalematrix( &objm,&scl );
                     GPU_rendersdmodel( 17,  0 ); break ;
               case OTmine:
                    scl.vx   =  0x2000;
                    scl.vy   =  0x2000;
                    scl.vz   =  0x2000;
                    vscalematrix( &objm,&scl );
                    GPU_rendersdmodel( 18, 0 ); break ;

               case OTmissile:   GPU_rendersdmodel( 19, 0 ); break ;
               case OTpickup:
                    GPU_rendersdmodel( 20, 0 ); break ;
               case OTtorpedo:   GPU_rendersdmodel( 21, 0 ); break ;
               }
            }
         }
      //eof sd_model
      if( OBJ_objects[f].type == OTfog)
         {
//         RENDER_fog( &pos );
         }
      }

vs_f_upd_obj = GsGetVcount();

   //render crap
   RENDER_backdrop();
   RENDER_printmessages();
   if( OBJ_players[CAM_c].mode360==2 )
      RENDER_crosshair();
   //RENDER_scanmodel();
   //SOUND_debug();

   waterFallAnimate();

RENDER_321go();

#if 0

if(STATE.timebar)
   {
   GPU_drawtimebar( 0,GPU_vsync[0], 255,0,0 );
   FntPrint( "time %d\n", GPU_vsync[0] );
//   GPU_drawtimebar( 0,GPU_vsync[0], 0,0,255 );
//   GPU_drawtimebar( GPU_vsync[0],GPU_vsync[1], 255,0,0 );
//   GPU_drawtimebar( GPU_vsync[1],GPU_vsync[2], 254,254,0 );
//   GPU_drawtimebar( 0,GPU_vsync[3], 0,255,0 );
   }

#endif

if((STATE.demomode) && (G_cyc&16))
   {
   //FntPrint("Demo Mode\n");

   TEXT_x   =  -40;
   TEXT_y   =  -80;
   TEXT_prstr("demo mode", 20,200,200);

   TEXT_x   =  -41;
   TEXT_y   =  -81;
   TEXT_prstr("demo mode", 0,0,0);

   }

   if(0)//TWEAK_cgrid)
      {
      GPU_drawdebgrid();
      for(f=0;f<32;f++)
         for(g=0;g<32;g++)
            {

            if(COL_oocgrid[f][g] != 0)
               {
               if( ((OBJ_STRUCT*)COL_oocgrid[f][g])->link ==0)
                  GPU_highlightgrid(g,f,200,0,0);
               else
                  GPU_highlightgrid(g,f,255,200,0);
               }
            }

      for( f=0;f<MAXNUMOBJS;f++ )
         {
         if( OBJ_objects[f].stat==ON )
            {
            s16   dim, x, z;
            dim   =  OBJ_typeinfo[ OBJ_objects[f].type ].coldim;
            x     =  (32768+( OBJ_objects[f].p.vx>>8))>>8;
            z     =  (32768+(-OBJ_objects[f].p.vz>>8))>>8;
            GPU_plot(  x, z, 255,255,255 );

            }
         }
      }

//#endif	// PSX
	}

                     /*
                     {
                     // reflection
                     vec16 c0,c1;
                     c0.vx =  OBJ_objects[0].p.vx>>8;
                     c0.vy =  OBJ_objects[0].p.vy>>8;
                     c0.vz =  OBJ_objects[0].p.vz>>8;

                     c1.vx =  (OBJ_objects[0].p.vx>>8);
                     c1.vy =  (OBJ_objects[0].p.vy>>8)+100;
                     c1.vz =  (OBJ_objects[0].p.vz>>8);
                     if(COL_test2(&c0,&c1)>=0)
                        {
                        pos.vx   =  COL_inter.vx;
                        pos.vy   =  COL_inter.vy;
                        pos.vz   =  COL_inter.vz;
                        vsub( &pos, &CAM_camp[CAM_c] );
                        vsetrotmatrix( &CAM_camm[CAM_c]);
                        vapplymatrix32( &CAM_camm[CAM_c], &pos, &pos );
                        pos.vx   =  (pos.vx*25)>>4;//aspect correct

                        objm.m[1][0]   =  -objm.m[1][0];//aspect fix
                        objm.m[1][1]   =  -objm.m[1][1];//aspect fix
                        objm.m[1][2]   =  -objm.m[1][2];//aspect fix
                        objm.t[0] =pos.vx;
                        objm.t[1] =pos.vy;
                        objm.t[2] =pos.vz;
                        vsettransmatrix( &objm );
                        vsetrotmatrix( &objm );
                        GPU_rendersdmodel( 1, 0 );
                        }
                     }
                     */

s8 RENDER_inrange( vec32 *v , vec16 *output)
   {
   if( (output->vx = (v->vx >> 8)) < (CAM_camp[CAM_c].vx -  RENDER_xdiff))return 0;
   if( (output->vx = (v->vx >> 8)) > (CAM_camp[CAM_c].vx +  RENDER_xdiff))return 0;
   if( (output->vz = (v->vz >> 8)) < (CAM_camp[CAM_c].vz -  RENDER_zdiff))return 0;
   if( (output->vz = (v->vz >> 8)) > (CAM_camp[CAM_c].vz +  RENDER_zdiff))return 0;

   output->vy = v->vy >> 8;

   return 1;
   }

void  RENDER_fog( vec32 *pos )
   {
   s32   dimy, dimx;
   s32   sx, sy;
//   s32   i;
   POLY_FT4  polyft4;


   if( pos->vz > 10 )
      {
      dimy  =  0x6fff/pos->vz;
      dimx  =  (dimy*25)>>4;
      sx =  (pos->vx*225) / pos->vz;
      sy =  (pos->vy*225) / pos->vz;

   SetPolyFT4( &polyft4 );

   polyft4.u0  =  64;   polyft4.v0  =  127;
   polyft4.u1  =  127;   polyft4.v1  =  127;
   polyft4.u2  =  64;   polyft4.v2  =  190;
   polyft4.u3  =  127;   polyft4.v3  =  190;
   polyft4.tpage  =  GetTPage(0,1,704,256);
   polyft4.clut   =  GetClut(704,449);//8148;
   SetSemiTrans( &polyft4, 1 );

      polyft4.r0=128;
      polyft4.g0=128;
      polyft4.b0=128;

      polyft4.x0  =  sx-dimx; polyft4.y0   =  sy-dimy;
      polyft4.x1  =  sx+dimx; polyft4.y1   =  sy-dimy;
      polyft4.x2  =  sx-dimx; polyft4.y2   =  sy+dimy;
      polyft4.x3  =  sx+dimx; polyft4.y3   =  sy+dimy;

      GsSortPoly( &polyft4, ptrwot, (pos->vz>>2)>>otzshift );
      }
   }
//                0    1    2    3    4    5    6    8    9   10
u8 thr_r[10]={ 0x00,0x00,0xff,0xff,0x00,0xff,0xff,0x00,0xff,0x80};
u8 thr_g[10]={ 0x80,0xff,0x00,0x80,0x00,0x00,0xa0,0x80,0xff,0xff};
u8 thr_b[10]={ 0xff,0x20,0x00,0x40,0xff,0xff,0x00,0xff,0xff,0x80};

void RENDER_thrusters()
   {
   s32   dimy=30, dimx=30;
   POLY_FT4  polyft4;
   vec16 tl,tr;
  // vec32 v;
   s16 i;
   u8    ct;
   s32   zot, z;
   s32   myz;
   u32   sxy;
   s16   sx,sy;
   u32   flag;
   s32   zrecip;
   u8    turbow;
   u16    cr,cg,cb;

   ct =  OBJ_players[pobj->owner].crafttype;
   i  =  OBJ_players[pobj->owner].throttle;
   if(i<64)i=64;

   cr =  ((thr_r[ct] * i)   >> 9) + OBJ_players[pobj->owner].turbo;
   if(cr>255)cr=255;
   cg =  ((thr_g[ct] * i)   >> 9) + OBJ_players[pobj->owner].turbo;
   if(cg>255)cg=255;
   cb =  ((thr_b[ct] * i)   >> 9) + OBJ_players[pobj->owner].turbo;
   if(cb>255)cb=255;

   turbow   =  OBJ_players[pobj->owner].turbo;

   SetPolyFT4( &polyft4 );
   polyft4.u0  =  64;      polyft4.v0  =  127;
   polyft4.u1  =  127;     polyft4.v1  =  127;
   polyft4.u2  =  64;      polyft4.v2  =  189;
   polyft4.u3  =  127;     polyft4.v3  =  189;
   polyft4.tpage  =  GetTPage(0,1,704,256);
   polyft4.clut   =  GetClut(704,449);//8148;
   SetSemiTrans( &polyft4, 1 );

   mov(tl, RENDER_thrusterpos[ct][0]);
   mov(tr,tl);
   tr.vx=-tr.vx;

	if( ct != 7 )
	{
   if( (ct!=2) && (ct!=6)  )
      {
      //double engine
      z  =   RotTransPers( (SVECTOR*)&tl, &sxy, &myz, &flag );
      zot   =  (z>>otzshift)-2;
      if( !(flag&0x80000000) && (zot>0) )      // Valid screen coords ?
         {
         zrecip   =  3096/z;

         sx =  sxy&0xffff;
         sy =  sxy>>16;

         //inner
         dimx     =  (zrecip*24)>>4;
         dimy     =  zrecip;
         polyft4.r0=cr;
         polyft4.g0=cg;
         polyft4.b0=cb;
         polyft4.x0  =  sx-dimx; polyft4.y0   =  sy-dimy;
         polyft4.x1  =  sx+dimx; polyft4.y1   =  sy-dimy;
         polyft4.x2  =  sx-dimx; polyft4.y2   =  sy+dimy;
         polyft4.x3  =  sx+dimx; polyft4.y3   =  sy+dimy;
         GsSortPoly( &polyft4, ptrwot, zot );
//         //outer
//         dimx     =  dimx<<1;
//         dimy     =  dimy<<1;
//         polyft4.r0=cr;
//         polyft4.g0=cg;
//         polyft4.b0=cb;
//         polyft4.x0  =  sx-dimx; polyft4.y0   =  sy-dimy;
//         polyft4.x1  =  sx+dimx; polyft4.y1   =  sy-dimy;
//         polyft4.x2  =  sx-dimx; polyft4.y2   =  sy+dimy;
//         polyft4.x3  =  sx+dimx; polyft4.y3   =  sy+dimy;
//         GsSortPoly( &polyft4, ptrwot, zot );
         }

      z  =   RotTransPers( (SVECTOR*)&tr, &sxy, &myz, &flag );
      zot   =  (z>>otzshift)-2;
      if( !(flag&0x80000000) && (zot>0) )      // Valid screen coords ?
         {
         zrecip   =  3096/z;

         sx =  sxy&0xffff;
         sy =  sxy>>16;

         //inner
         dimx     =  (zrecip*24)>>4;
         dimy     =  zrecip;
         polyft4.r0=cr;
         polyft4.g0=cg;
         polyft4.b0=cb;
         polyft4.x0  =  sx-dimx; polyft4.y0   =  sy-dimy;
         polyft4.x1  =  sx+dimx; polyft4.y1   =  sy-dimy;
         polyft4.x2  =  sx-dimx; polyft4.y2   =  sy+dimy;
         polyft4.x3  =  sx+dimx; polyft4.y3   =  sy+dimy;
         GsSortPoly( &polyft4, ptrwot, zot );
//         //outer
//         dimx     =  dimx<<1;
//         dimy     =  dimy<<1;
//         polyft4.r0=cr;
//         polyft4.g0=cg;
//         polyft4.b0=cb;
//         polyft4.x0  =  sx-dimx; polyft4.y0   =  sy-dimy;
//         polyft4.x1  =  sx+dimx; polyft4.y1   =  sy-dimy;
//         polyft4.x2  =  sx-dimx; polyft4.y2   =  sy+dimy;
//         polyft4.x3  =  sx+dimx; polyft4.y3   =  sy+dimy;
//         GsSortPoly( &polyft4, ptrwot, zot );
         }
      }
   else
      {
      //single engine
      z  =   RotTransPers( (SVECTOR*)&tl, &sxy, &myz, &flag );
      zot   =  (z>>otzshift)-2;
      if( !(flag&0x80000000) && (zot>0) )      // Valid screen coords ?
         {
         zrecip   =  3096/z;

         sx =  sxy&0xffff;
         sy =  sxy>>16;

         //inner
         dimx     =  (zrecip*24)>>4;
         dimy     =  zrecip;
         polyft4.r0=cr;
         polyft4.g0=cg;
         polyft4.b0=cb;
         polyft4.x0  =  sx-dimx; polyft4.y0   =  sy-dimy;
         polyft4.x1  =  sx+dimx; polyft4.y1   =  sy-dimy;
         polyft4.x2  =  sx-dimx; polyft4.y2   =  sy+dimy;
         polyft4.x3  =  sx+dimx; polyft4.y3   =  sy+dimy;
         GsSortPoly( &polyft4, ptrwot, zot );
//         //outer
//         dimx     =  dimx<<1;
//         dimy     =  dimy<<1;
//         polyft4.r0=cr;
//         polyft4.g0=cg;
//         polyft4.b0=cb;
//         polyft4.x0  =  sx-dimx; polyft4.y0   =  sy-dimy;
//         polyft4.x1  =  sx+dimx; polyft4.y1   =  sy-dimy;
//         polyft4.x2  =  sx-dimx; polyft4.y2   =  sy+dimy;
//         polyft4.x3  =  sx+dimx; polyft4.y3   =  sy+dimy;
//         GsSortPoly( &polyft4, ptrwot, zot );
         }
      }
   }
   }

/*
void  RENDER_trail()
   {
   u8      f, i;
   static   vec32 tr[32];
   static   u8  ti=0;
   vec32    scr[32];
   vec32    norm[32];
   GsLINE   line;

   line.attribute=0;
   line.r   =0xff;
   line.g   =0xff;
   line.b   =0xff;

   tr[ti].vx   =  pobj->p.vx>>8;
   tr[ti].vy   =  pobj->p.vy>>8;
   tr[ti].vz   =  pobj->p.vz>>8;

   i=ti;
   for(f=0;f<32;f++)
      {
      // transform 3d to screen
      vec32 v;
      mov( v, tr[i] );
      sub( v, CAM_camp[CAM_c] );
      vapplymatrix32( &CAM_camm[CAM_c], &v, &v );
      if(v.vz>0)
         {
         scr[f].vz   =  v.vz;
         scr[f].vx   =  v.vx*225/v.vz;
         scr[f].vy   =  v.vy*225/v.vz;
         }
      i  =  (i-1)&31;
      }

   for(f=0;f<31;f++)
      {
      // find norms
      u32   d;
      norm[f].vx  = -( scr[f+1].vy - scr[f].vy );
      norm[f].vy  =  ( scr[f+1].vx - scr[f].vx );
      d  =  vqlen2( norm[f].vx, norm[f].vy );
      if(d>0)
         {
         norm[f].vx  = (norm[f].vx*256)/d;
         norm[f].vy  = (norm[f].vy*256)/d;
         }
      }

   mov( norm[31], norm[30] );

   //for(f=1;f<31;f++)
   //   {
   //   // average norms not ends
   //   norm[f].vx  = (norm[f].vx+norm[f-1].vx)>>1;
   //   norm[f].vy  = (norm[f].vy+norm[f-1].vy)>>1;
   //   }

   for(f=1;f<31;f++)
      {
      norm[f].vx  =  norm[f].vx>>4;///scr[f].vz;
      norm[f].vy  =  norm[f].vy>>4;///scr[f].vz;
      }

   for(f=0;f<30;f++)
      {
      line.x0  =  scr[f].vx;
      line.y0  =  scr[f].vy;
      line.x1  =  scr[f+1].vx;
      line.y1  =  scr[f+1].vy;
      line.r   =  0xff-(f<<3);
      line.g   =  0xff-(f<<3);
      line.b   =  0xff-(f<<3);
      GsSortLine( &line, ptrwot, 5 );
      }

   for(f=0;f<31;)
      {
      POLY_FT4  polyft4;
      SetPolyFT4( &polyft4 );
      polyft4.u0  =  16;    polyft4.v0  =  94;
      polyft4.u1  =  39;    polyft4.v1  =  94;
      polyft4.u2  =  16;    polyft4.v2  =  125;
      polyft4.u3  =  39;    polyft4.v3  =  125;
      polyft4.tpage  =  GetTPage(1,1,704,256);
      polyft4.clut   =  GetClut(768,375);
      SetSemiTrans( &polyft4, 1 );

      polyft4.r0=255-(f<<3);
      polyft4.g0=255-(f<<3);
      polyft4.b0=255-(f<<3);

      polyft4.x1  =  scr[f].vx-norm[f].vx;
      polyft4.y1  =  scr[f].vy-norm[f].vy;

      polyft4.x2  =  scr[f].vx+norm[f].vx;
      polyft4.y2  =  scr[f].vy+norm[f].vy;

      polyft4.x0  =  scr[f+3].vx-norm[f+3].vx;
      polyft4.y0  =  scr[f+3].vy-norm[f+3].vy;

      polyft4.x3  =  scr[f+3].vx+norm[f+3].vx;
      polyft4.y3  =  scr[f+3].vy+norm[f+3].vy;

      GsSortPoly( &polyft4, ptrwot, 0 );
      f+=4;
      }
   ti =  (ti+1)&31;
   }
*/

void  RENDER_swirl()
   {
   s16   scdimx=280, scdimy=140;
//   u32   f;
   RECT  rect;
   POLY_FT4  polyft4;
   SetPolyFT4( &polyft4 );
   SetSemiTrans( &polyft4, 1 );
   //for(f=0;f<100;f++)
      {
      rect.x   =  0;
      rect.y   =  0;
      rect.w   =  1024;
      rect.h   =  512;
      //DrawSync(0);
      GsSetClip( &rect );
      GsSetDrawBuffOffset();

      polyft4.r0  = 100;//+ (newhue2rgb[(G_cyc)&0xff].r>>2);
      polyft4.g0  = 100;//+ (newhue2rgb[(G_cyc)&0xff].g>>2);
      polyft4.b0  = 168;//+ (newhue2rgb[(G_cyc)&0xff].b>>2);
      G_cyc+=13;

      ///////////////////////////////////////////////
      polyft4.u0  =  0;       polyft4.v0  =  0;
      polyft4.u1  =  255;     polyft4.v1  =  0;
      polyft4.u2  =  0;       polyft4.v2  =  127;
      polyft4.u3  =  255;     polyft4.v3  =  127;
      polyft4.x0  =  -scdimx;       polyft4.y0  =  -scdimy;
      polyft4.x1  =  0;             polyft4.y1  =  -scdimy;
      polyft4.x2  =  -scdimx;       polyft4.y2  =  0;
      polyft4.x3  =  0;             polyft4.y3  =  0;
      if(outbuf_idx==0)
         polyft4.tpage  =  GetTPage(2,0,0,0);
      else
         polyft4.tpage  =  GetTPage(2,0,0,256);
      GsSortPoly( &polyft4, ptrwot, 0 );

      ///////////////////////////////////////////////
      polyft4.u0  =  0;       polyft4.v0  =  0;
      polyft4.u1  =  255;     polyft4.v1  =  0;
      polyft4.u2  =  0;       polyft4.v2  =  127;
      polyft4.u3  =  255;     polyft4.v3  =  127;

      polyft4.x0  =  0;          polyft4.y0  =  -scdimy;
      polyft4.x1  =  scdimx;     polyft4.y1  =  -scdimy;
      polyft4.x2  =  0;          polyft4.y2  =  0;
      polyft4.x3  =  scdimx;     polyft4.y3  =  0;

      if(outbuf_idx==0)
         polyft4.tpage  =  GetTPage(2,0,256,0);
      else
         polyft4.tpage  =  GetTPage(2,0,256,256);
      GsSortPoly( &polyft4, ptrwot, 0 );

      ///////////////////////////////////////////////
      polyft4.u0  =  0;       polyft4.v0  =  128;
      polyft4.u1  =  255;     polyft4.v1  =  128;
      polyft4.u2  =  0;       polyft4.v2  =  255;
      polyft4.u3  =  255;     polyft4.v3  =  255;

      polyft4.x0  =  -scdimx;    polyft4.y0  =  0;
      polyft4.x1  =  0;          polyft4.y1  =  0;
      polyft4.x2  =  -scdimx;    polyft4.y2  =  scdimy;
      polyft4.x3  =  0;          polyft4.y3  =  scdimy;

      if(outbuf_idx==0)
         polyft4.tpage  =  GetTPage(2,0,0,0);
      else
         polyft4.tpage  =  GetTPage(2,0,0,256);
      GsSortPoly( &polyft4, ptrwot, 0 );

      ///////////////////////////////////////////////
      polyft4.u0  =  0;       polyft4.v0  =  128;
      polyft4.u1  =  255;     polyft4.v1  =  128;
      polyft4.u2  =  0;       polyft4.v2  =  255;
      polyft4.u3  =  255;     polyft4.v3  =  255;

      polyft4.x0  =  0;          polyft4.y0  =  0;
      polyft4.x1  =  scdimx;     polyft4.y1  =  0;
      polyft4.x2  =  0;          polyft4.y2  =  scdimy;
      polyft4.x3  =  scdimx;     polyft4.y3  =  scdimy;

      if(outbuf_idx==0)
         polyft4.tpage  =  GetTPage(2,0,256,0);
      else
         polyft4.tpage  =  GetTPage(2,0,256,256);
      GsSortPoly( &polyft4, ptrwot, 0 );

      rect.x   =  0;
      rect.y   =  0;
      rect.w   =  512;
      rect.h   =  256;
      //DrawSync(0);
      GsSetClip( &rect );
      GsSetDrawBuffOffset();
      //SD_EndDraw();
      }
   }

void  RENDER_dupbuf()
   {
   RECT  rect;

   rect.x = 0;
   rect.y = 0;
   rect.w = 511;
   rect.h = 255;

   DrawSync( 0 );
   MoveImage( &rect, 0, 256 );
   DrawSync( 0 );
   }


/*
void  RENDER_jellypoly4( s16 xa0,s16 ya0, s16 xa1,s16 ya1, s16 xa2,s16 ya2, s16 xa3,s16 ya3,
                         s16 xb0,s16 yb0, s16 xb1,s16 yb1, s16 xb2,s16 yb2, s16 xb3,s16 yb3)
   {
   RECT  rect;
   POLY_FT4  polyft4;
   SetPolyFT4( &polyft4 );
   SetSemiTrans( &polyft4, 1 );
   rect.x   =  0;
   rect.y   =  0;
   rect.w   =  1024;
   rect.h   =  512;
   GsSetClip( &rect );
   GsSetDrawBuffOffset();

   polyft4.r0  = 128;
   polyft4.g0  = 128;
   polyft4.b0  = 128;

   ///////////////////////////////////////////////
   polyft4.x0  =  xa0;     polyft4.y0  =  ya0;
   polyft4.x1  =  xa1;     polyft4.y1  =  ya1;
   polyft4.x2  =  xa2;     polyft4.y2  =  ya2;
   polyft4.x3  =  xa3;     polyft4.y3  =  ya3;
   polyft4.u0  =  xb0+256;     polyft4.v0  =  yb0+128;
   polyft4.u1  =  xb1+256;     polyft4.v1  =  yb1+128;
   polyft4.u2  =  xb2+256;     polyft4.v2  =  yb2+128;
   polyft4.u3  =  xb3+256;     polyft4.v3  =  yb3+128;

   if(outbuf_idx==0)
      polyft4.tpage  =  GetTPage(2,0,0,0);
   else
      polyft4.tpage  =  GetTPage(2,0,0,256);
   GsSortPoly( &polyft4, ptrwot, 0 );

   }

void RENDER_rain()
   {
   //LINE_F2  line;
   GsLINE  line;

   line.r=0;
   line.g=128;
   line.b=255;

   line.x0  =  0;
   line.y0  =  0;
   line.x1  =  0;
   line.y1  =  60;

   GsSortLine( &line, ptrwot, 0 );

   }
*/
/*
void  RENDER_swirl()
   {
   }
 */

s16   RENDER_321startstate=0;
s16   RENDER_alpha=250;

void  RENDER_321go()
   {
   // 0 - '3'
   // 1 - '2'
   // 2 - '1'
   // 3 - 'go'
   if((RENDER_321startstate!=5) && execGame && (CAM_c==0) )
      {

      TEXT_y=-60;
      TEXT_x=-50;

      TEXT_r=RENDER_alpha;
      TEXT_g=RENDER_alpha;
      TEXT_b=RENDER_alpha;

      switch( RENDER_321startstate )
         {
         case 0:
            break;
         case 1:
            if(RENDER_alpha==150)
               {
               S2_sfxdynamic( 27, CAM_camp[0].vx, CAM_camp[0].vz, 0, 120, 5000 );
               }
            TEXT_intro( '3', 32767 );
            break;
         case 2:
            if(RENDER_alpha==150)
               S2_sfxdynamic( 26, CAM_camp[0].vx, CAM_camp[0].vz, 0, 120, 5000 );
            TEXT_intro( '2', 32767 );
            break;
         case 3:
            if(RENDER_alpha==150)
               S2_sfxdynamic( 25, CAM_camp[0].vx, CAM_camp[0].vz, 0, 120, 5000 );
            TEXT_x=-20;
            TEXT_intro( '1', 32767 );
            break;
         case 4:
//            if(RENDER_alpha==150)
//               S2_sfxdynamic( 28, CAM_camp[0].vx, CAM_camp[0].vz, 0, 120, 5000 );
            TEXT_x=-100;
            TEXT_intro( 'G', 32767 );
            TEXT_x=10;
            TEXT_intro( 'O', 32767 );
            break;
         }

      RENDER_alpha-=6;
      if(RENDER_alpha<20)
         {

         RENDER_alpha=150;
         RENDER_321startstate++;
         if(RENDER_321startstate==4)
            {
            STATE.raceclock=0;
            }
         }
      }
   }
